-- BOSS挑战个人阶段伤害奖励界面
Lua_BossChallengeHurtRewardWindow = class("Lua_BossChallengeHurtRewardWindow", Lua_Window);
function Lua_BossChallengeHurtRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_BossChallengeHurtRewardWindow";
	self.skinName = "BossChallengeHurtRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_BossChallengeHurtRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsTxt:setLangValue(640013);

	self.itemList = Lua_DragList.new(self.content, 628, 720, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_BossChallengeHurtRewardItem, 628, 165, 1);
	self.itemList:setLocation(0, -85, 0);
	self.itemList:setArrayData(DataCenter.bossChallengeData.daily_hurt_reward);
	self.itemList:moveToIndex(DataCenter.bossChallengeData.curStageIdx, true, false);
end

function Lua_BossChallengeHurtRewardWindow:dispose()
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	self:superCall("dispose")
end










Lua_BossChallengeHurtRewardItem = class("Lua_BossChallengeHurtRewardItem", Lua_ListCell);
function Lua_BossChallengeHurtRewardItem:ctor(p)
	self:superCall("ctor", p, "BossChallengeHurtRewardItem_skin");
end

function Lua_BossChallengeHurtRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 420, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_BossChallengeHurtRewardIconItem, 87, 87, 1);
	self.rewardList:setLocation(-80, -20.5, 0);
	self.rewardList:setCellSpacing(5, 0);
	self:setSubList(self.rewardList);
end

function Lua_BossChallengeHurtRewardItem:setData(data)
	if data == nil then
		return;
	end

	self.titleTxt.text = LanUtil.formateStr(640014, data.hurt);
	self.rewardList.canDrag = #data.item_list > 4;
	self.rewardList:setArrayData(data.item_list);

	-- 是否达成(0否 1是)
	if data.is_finish == 0 then
		self.stateIcon:setAltas("common_altas_4", "xui_common_label_28")
	else
		self.stateIcon:setAltas("common_altas_4", "xui_common_label_30")
	end
end

function Lua_BossChallengeHurtRewardItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onUpClick();
	end
end

function Lua_BossChallengeHurtRewardItem:checkClick()
	local showArr = self.rewardList.showList;
	for i = 1, showArr:getSize() do
		winPos = LuaUtil.getTouchPosInverseObj(showArr[i].mainContent);
		if showArr[i].itemIcon.isActive and showArr[i].itemIcon:checkInBound(winPos.x, winPos.y) then
			return showArr[i];
		end
	end
	return nil;
end

function Lua_BossChallengeHurtRewardItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.9, 0.9);
	end
end

function Lua_BossChallengeHurtRewardItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(1, 1);
	end
end

function Lua_BossChallengeHurtRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_BossChallengeHurtRewardIconItem = class("Lua_BossChallengeHurtRewardIconItem", Lua_ItemIconCell)
function Lua_BossChallengeHurtRewardIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end

function Lua_BossChallengeHurtRewardIconItem:onUpClick()
	if self.data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data);
end

function Lua_BossChallengeHurtRewardIconItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onItemClick();
	end
end

function Lua_BossChallengeHurtRewardIconItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon.isActive and self.itemIcon:checkInBound(winPos.x, winPos.y) then
		return self.itemIcon;
	end
	return nil;
end

function Lua_BossChallengeHurtRewardIconItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.6, 0.6);
	end
end

function Lua_BossChallengeHurtRewardIconItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.7, 0.7);
	end
end