-- BOSS挑战排行奖励
Lua_BossChallengeRankRewardWindow = class("Lua_BossChallengeRankRewardWindow", Lua_Window);
function Lua_BossChallengeRankRewardWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_BossChallengeRankRewardWindow";
	self.skinName = "BossChallengeRankRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_BossChallengeRankRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 600, 690, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_BossChallengeRankRewardItem, 600, 120, 1);
	self.itemList:setLocation(0, -114, 0);
	self.itemList:setCellSpacing(0, 5);

	self:addLuaEvent("UPDATE_BOSSCHALLENGE_RANKREWARD_INFO", self, self.updateShowInfo);
	Lua_MsgUtil.callFunc("REQUEST_BOSSCHALLENGE_RANKREWARD_INFO");
end

function Lua_BossChallengeRankRewardWindow:updateShowInfo()
	self.itemList:setArrayData(DataCenter.bossChallengeData.rank_reward);
end

function Lua_BossChallengeRankRewardWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.myRewardList ~= nil then
		self.myRewardList:dispose();
		self.myRewardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_BossChallengeRankRewardItem = class("Lua_BossChallengeRankRewardItem", Lua_ListCell);
function Lua_BossChallengeRankRewardItem:ctor(p)
	self:superCall("ctor", p, "BossChallengeRankRewardItem_skin");
end

function Lua_BossChallengeRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 320, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_BossChallengeRankRewardIconItem, 87, 87, 1);
	self.rewardList:setLocation(51, 0, 0);
	self.rewardList:setCellSpacing(5, 0);
	self:setSubList(self.rewardList);
end

function Lua_BossChallengeRankRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if data.rank_left == data.rank_right then
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_1"..(data.rank_left - 1));
		self.rankTxt:setEnable(false);
	else
		self.rankTxt:setEnable(true);
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_13");
		local rightStr = data.rank_right == 0 and "+" or "-"..data.rank_right;
		self.rankTxt.text = data.rank_left..rightStr;
	end

	local tvo;
	local tvoArr = Array();
	for i = 1, #data.reward do
		tvo = Lua_ToolVo.createToolVo(data.reward[i].key, data.reward[i].value);
		tvoArr:add(tvo);
	end
	self.rewardList:setArrayData(tvoArr);
	self.rewardList.canDrag = tvoArr:getSize() > 3;
end

function Lua_BossChallengeRankRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end










Lua_BossChallengeRankRewardIconItem = class("Lua_BossChallengeRankRewardIconItem", Lua_ItemIconCell)
function Lua_BossChallengeRankRewardIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end