-- 钻石商城购买弹窗
Lua_DiamondShopBuyGiftWindow = class("Lua_DiamondShopBuyGiftWindow", Lua_Window);
function Lua_DiamondShopBuyGiftWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_DiamondShopBuyGiftWindow";
	self.skinName = "DiamondShopBuyGiftWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -344;
end

function Lua_DiamondShopBuyGiftWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 510, 124, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_DiamondShopBuyGiftRewardItem, 124, 124, 1);
	self.rewardList:setCellSpacing(9, 0);
	self.rewardList:setLocation(0, 41, 0);

	self.numberInputItem = Lua_NumberInputItem.new(self.content);
	self.numberInputItem:setCallBack(self, self.updateCount);
	self.numberInputItem:setLocation(0, -88, 0);
	
	self.sureBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_DiamondShopBuyGiftWindow:showWin(param)
	self:superCall("showWin", param);

	local len = #param.items;
	local posX = len > 4 and 0 or (510 - len * 134 - 10) / 2;
	self.rewardList.canDrag = len > 4;
	self.rewardList:setArrayData(param.items);
	self.rewardList:setLocation(posX, 41, 0);

	self.buyMaxNum = param.num - param.value;
	self.limitBuyTxt.text = LanUtil.formateStr(769005, self.buyMaxNum);

	self.numberInputItem:setValue(1, 1, self.buyMaxNum);
	if self.buyMaxNum <= 1 then
		self.numberInputItem:removeClickFun();
	end
end

function Lua_DiamondShopBuyGiftWindow:updateCount(val)
	if self.showData == nil then return; end
	if val > self.buyMaxNum then
		val = self.buyMaxNum;
	elseif val < 1 then
		val = 1;
	end
	self.selectNum = val;
	self.totalPrice = self.selectNum * self.showData.price;

	if self.totalPrice <= 0 then
		self.sureBtn:setLangValue(769006);
	else
		local hasCount = DataCenter.moneyData:getMoney(self.showData.money_type);
		local colorStr = self.totalPrice <= hasCount and "8F5123" or "DA5A32";
		self.sureBtn.label = LanUtil.formateStr(769007, spliceIconStrById(self.showData.money_type), colorStr, self.totalPrice);
	end
end

function Lua_DiamondShopBuyGiftWindow:onBuyBtnClick(go)
	if DataCenter.moneyData:isMoneyEnough(self.showData.money_type, self.totalPrice, true, true) then
		if self.totalPrice > 0 then
			local tipsData = {
				owner = self,
				des = LanUtil.formateStr(769008, spliceIconStrById(self.showData.money_type), self.totalPrice, self.showData.gift_name),
				btnType = 1,
				sureFun = self.onSureFun
			}
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
		else
			self:onSureFun();
		end
	end
end

function Lua_DiamondShopBuyGiftWindow:onSureFun()
	Lua_MsgUtil.callFunc("ON_DIAMONDSHOP_BUYGIFT", {data = self.showData, buyNum = self.selectNum});
	self:hide();
end

function Lua_DiamondShopBuyGiftWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.numberInputItem ~= nil then
		self.numberInputItem:dispose();
		self.numberInputItem = nil;
	end
	self:superCall("dispose");
end










Lua_DiamondShopBuyGiftRewardItem = class("Lua_DiamondShopBuyGiftRewardItem", Lua_ItemIconCell);
function Lua_DiamondShopBuyGiftRewardItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_DiamondShopBuyGiftRewardItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onItemClick();
	end
end

function Lua_DiamondShopBuyGiftRewardItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon.isActive and self.itemIcon:checkInBound(winPos.x, winPos.y) then
		return self.itemIcon;
	end
	return nil;
end

function Lua_DiamondShopBuyGiftRewardItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.95, 0.95);
	end
end

function Lua_DiamondShopBuyGiftRewardItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(1, 1);
	end
end