-- 今日助力
Lua_EuropeanRecruitInvitationWindow = class("Lua_EuropeanRecruitInvitationWindow", Lua_Window);
function Lua_EuropeanRecruitInvitationWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EuropeanRecruitInvitationWindow";
	self.skinName = "EuropeanRecruitInvitationWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_EuropeanRecruitInvitationWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.descTxt:setLangValue(163005);
	self.titleNameTxt:setLangValue(163006);
	self.shareBtn:setLangValue(163007);
	self.shareObj:SetActive(false);

	self.shareBtn:addClickFuntion(self, self.onClickShareBtn);
	self.areaSp:addClickFuntion(self, self.onClickShareAreaSp); -- 公会分享icon
	self.friendSp:addClickFuntion(self, self.onClickShareFriendSp); -- 私聊分享icon

	self:addLuaEvent("UPDATE_EUROPEANRECRUIT_INVITATION", self, self.showWin);
end

function Lua_EuropeanRecruitInvitationWindow:showWin(param)
	self:superCall("showWin", param);

	local residueNum = self.showData.share_times or 0; 
	self.shareBtn:setGray(residueNum <= 0);
	self.recruitTxt.text = LanUtil.formateStr(163008, param.add_times);
	self:updateInvitationPersonNum();
	self:updateHelpPlayers();
	self:updateResidueNum();
end

function Lua_EuropeanRecruitInvitationWindow:dispose()
	self.actVo = nil;
	self:superCall("dispose");
end

function Lua_EuropeanRecruitInvitationWindow:updateInvitationPersonNum()
	local totalNum = self.showData.max_help or 0;
	local residueNum = self.showData.curr_help or 0;
	self.personNumTxt.text = LanUtil.formateStr(163009, residueNum, totalNum);
	self.shareBtn:setGray(totalNum <= residueNum);
	-- self.shareBtn.clickScale = totalNum > residueNum;
end

function Lua_EuropeanRecruitInvitationWindow:updateResidueNum()
	local residueNum = self.showData.share_times or 0; 
	self.residueNumTxt.text = LanUtil.formateStr(163010, residueNum);
end

function Lua_EuropeanRecruitInvitationWindow:checkClickValid()
	local residueNum = self.showData.share_times or 0; 
	if residueNum <= 0 then
		OperateAlert.showLangValue(163011);
		return;
	end

	local endTick = tonumber(self.showData.share_tick) or 0;
	local residueTime = endTick - DataCenter.roleData.serverTime;
	if residueTime > 0 then
		local str = LanUtil.formateStr(163012, residueTime);
		OperateAlert.show(str);
		return;
	end

	if self.actVo == nil then
		local activeId = DataCenter.europeanRecruitData:getEuropeanRecruitActId();
		self.actVo = DataCenter.backstageActData:getActVoByIdx(activeId);
	end

	if DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	local totalNum = self.showData.max_help or 0;
	local residueNum = self.showData.curr_help or 0;
	if totalNum <= residueNum then
		OperateAlert.showLangValue(163013);
		return;
	end

	local bReceived = DataCenter.europeanRecruitData:checkReceived();
	if bReceived then
		OperateAlert.showLangValue(163061);
		return;
	end

	return true;
end

function Lua_EuropeanRecruitInvitationWindow:onClickShareBtn()
	local bReceived = DataCenter.europeanRecruitData:checkReceived();
	if bReceived then
		OperateAlert.showLangValue(163061);
		return;
	end

	local totalNum = self.showData.max_help or 0;
	local residueNum = self.showData.curr_help or 0;
	if totalNum <= residueNum then
		OperateAlert.showLangValue(163013);
		return;
	end

	local residueNum = self.showData.share_times or 0; 
	if residueNum <= 0 then
		OperateAlert.showLangValue(163014);
		return;
	end

	self.shareObj:SetActive(not self.shareObj.activeSelf);
end

function Lua_EuropeanRecruitInvitationWindow:onClickShareAreaSp()
	if self:checkClickValid() ~= true then
		return;
	end

	if not DataCenter.funcOpenData:isOpened(10229) then
		OperateAlert.showLangValue(163015);
	elseif DataCenter.roleData.league_id <= 0 then
		OperateAlert.showLangValue(163016);
	else
		self.shareObj:SetActive(false);
		local str = spliceStr(LanUtil.getValue(163045), "<url=europeanRecruitInvitaion_>", LanUtil.getValue(163046), "</url>");
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_EUROPEAN_RECRUIT_INVITATION, str);
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, str, false, false);
		OperateAlert.showLangValue(163017);
	end
end

function Lua_EuropeanRecruitInvitationWindow:onClickShareFriendSp()
	if self:checkClickValid() ~= true then
		return;
	end

	if not DataCenter.funcOpenData:isOpened(10231) then
		OperateAlert.showLangValue(163015);
	else
		self.shareObj:SetActive(false);

		local param = { owner = self, callFunc = self.checkConfirmSend}
		Lua_WindowUtil.openWin("Lua_EuropeanRecruitShareFriendWindow", Lua_WinParam.ACTION_OPEN, param);
	end
end

function Lua_EuropeanRecruitInvitationWindow:checkConfirmSend(friendInfo)
	self.shareFriendId = friendInfo.playerId;
	self.shareFriendName = friendInfo.playerName;
	local tipData = {
		type = 2,
		btnType = 1,
		des = LanUtil.formateStr(163047, friendInfo.playerName);
		sureLabel = LanUtil.getValue(163048);
		cancelLabel = LanUtil.getValue(163049);
		owner = self,
		sureFun = self.shareInvitationToFriend
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_EuropeanRecruitInvitationWindow:shareInvitationToFriend()
	if self.shareFriendId == nil then
		return;
	end

	local chatContent = spliceStr(LanUtil.getValue(163045), "<url=europeanRecruitInvitaion_>", LanUtil.getValue(163046), "</url>");
	DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_EUROPEAN_RECRUIT_INVITATION, chatContent);
	Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_FRIEND, chatContent, false, false, self.shareFriendId);

	local str = LanUtil.formateStr(163018, self.shareFriendName);
	OperateAlert.show(str);
end

function Lua_EuropeanRecruitInvitationWindow:updateHelpPlayers()
	if self.helpPlayers == nil then
		self.helpPlayers = {};
	end

	local item;
	local count = 5;
	local posList = {
		{-8, 245},
		{201, 97},
		{117, -140},
		{-133, -138},
		{-208, 97}
	};
	local posX, posY;
	local obj = self.showData.helper_list or {};
	for i = 1, count do
		item = self.helpPlayers[i];
		if item == nil then
			item = Lua_EuropeanRecruitInvitationItem.new(self.content);
			self.helpPlayers[i] = item;
		end

		posX = posList ~= nil and posList[i] ~= nil and posList[i][1] or 0;
		posY = posList ~= nil and posList[i] ~= nil and posList[i][2] or 0;
		item:setLocation(posX, posY);
		item:setData(obj[i]);
	end
end




















----------------------------------
Lua_EuropeanRecruitInvitationItem = class("Lua_EuropeanRecruitInvitationItem", Lua_DisplayObject);
function Lua_EuropeanRecruitInvitationItem:ctor(p)
	self:superCall("ctor", p, "EuropeanRecruitInvitationItem_skin");
end

function Lua_EuropeanRecruitInvitationItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_EuropeanRecruitInvitationItem:dispose()
	self.data = nil;
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end

	self:superCall("dispose");
end

function Lua_EuropeanRecruitInvitationItem:setData(data)
	self.data = data;

	self.addSp:setEnable(data == nil);
	self.selectedSp:setEnable(data ~= nil);
	self:showAvatarItem(data);
end

function Lua_EuropeanRecruitInvitationItem:showAvatarItem(playerInfo)
	if playerInfo == nil then
		if self.avatarItem ~= nil then
			self.avatarItem:setEnable(false);
		end
	else
		if self.avatarItem == nil then
			self.avatarItem = Lua_AvatarItem.new(self.content)
			self.avatarItem:setScale(0.82, 0.82, 1)
			self.avatarItem:setSiblingIndex(self.selectedSp.siblingIndex);
		end

		self.avatarItem:setRoleId(playerInfo.id)
		self.avatarItem:setRoleDressUp(playerInfo.dress_info, true)
		self.avatarItem:setRoleLevel(playerInfo.level);
	end
end
