-- 暂存记录
Lua_EuropeanRecruitRecordWindow = class("Lua_EuropeanRecruitRecordWindow", Lua_Window);
function Lua_EuropeanRecruitRecordWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EuropeanRecruitRecordWindow";
	self.skinName = "EuropeanRecruitRecordWindow_skin";
	self.showWinBg = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_EuropeanRecruitRecordWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.recordList = Lua_DragList.new(self.content, 610, 646, Lua_AxisDefine.Vertical);
	self.recordList:setListCell(Lua_EuropeanRecruitRecordItem, 610, 250, 1);
    self.recordList:setLocation(0, 24, 0);
    self.recordList:setCellSpacing(0, 10);

    self.titleNameTxt:setLangValue(163019);
    self.recortType = DataCenter.europeanRecruitData.recordType;
    self.saveBtn:setLangValue(self.recortType == 1 and 163020 or 163021);
    self.saveBtn:setGray(true);
    self.costSp:setEnable(false)

	self.saveBtn:addClickFuntion(self, self.onClickSaveBtn);
	self:addLuaEvent("UPDATE_EUROPEANRECRUIT_RECORDINFO", self, self.updateRecordData);
	self:addLuaEvent("UPDATE_EUROPEANRECRUIT_RECORDLIST", self, self.updateRecordList);
end

function Lua_EuropeanRecruitRecordWindow:dispose()
	self.actVo = nil;
	self.recordIds = nil;
	DataCenter.europeanRecruitData.recordType = nil;
	DataCenter.europeanRecruitData.selectedRecordIndex = nil;
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	if self.recordList ~= nil then
		self.recordList:dispose();
		self.recordList = nil;
	end
	self:superCall("dispose");
end

function Lua_EuropeanRecruitRecordWindow:showWin(param)
	self:superCall("showWin", param);

	local index = self:setDefaultSelectedIndex();
	self:updateRecordList();	
	if self.bFirstEnter ~= true then
		self.bFirstEnter = true;
		if index == nil then
			return;
		end
		
		if self.recortType == 1 then
			index = index + 1;
		end

		if index ~= nil and index <= self.recordList.showDragDataList:getSize() then
			local item = self.recordList.showDragDataList:getItem(index).cell;
			item:setFirstClick(true);
			item:onPressClick();
		end
	end
end

function Lua_EuropeanRecruitRecordWindow:checkClickValid()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if self.actVo == nil then
		local activeId = DataCenter.europeanRecruitData:getEuropeanRecruitActId();
		self.actVo = DataCenter.backstageActData:getActVoByIdx(activeId);
	end

	if DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	return true;
end

function Lua_EuropeanRecruitRecordWindow:onClickSaveBtn()
	local bReceived = DataCenter.europeanRecruitData:checkReceived();
	if bReceived then
		OperateAlert.showLangValue(163061);
		return;
	end

	if self:checkClickValid() ~= true then
		return;
	end

	if self.recortItemData == nil then
		return;
	end

	if self.btnType == 2 then
		return;
	end

	local activeId = DataCenter.europeanRecruitData:getEuropeanRecruitActId();
	if self.btnType == 1 then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sReceiveEuropeanRecruitReward(activeId, self.recortItemData.key);
	elseif self.btnType == 4 then
		local tipData = {
			type = 2,
			btnType = 1,
			des = LanUtil.getValue(163062),
			sureLabel = LanUtil.getValue(163048),
			cancelLabel = LanUtil.getValue(163049),
			owner = self,
			sureFun = self.sendSaveRecord
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
	else
		self:sendSaveRecord();
	end
end

function Lua_EuropeanRecruitRecordWindow:sendSaveRecord()
	if self.recortItemData == nil then
		return;
	end

	local activeId = DataCenter.europeanRecruitData:getEuropeanRecruitActId();
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sSaveEuropeanRecruitRecord(activeId, self.recortItemData.key);
end

function Lua_EuropeanRecruitRecordWindow:updateRecordData(data)
	self.recortItemData = data;
	if data == nil then
		return;
	end

	local str;
	-- self.btnType; -- 1:可以领取  2：不可领取 3： 有空档可存储  4：消耗资源覆盖存档
	if self.recortType == 1 then
		if self.recortItemData.list == nil or #self.recortItemData.list <= 0 then
			self.btnType = 3;
			str = LanUtil.getValue(163020);
		elseif self.recortItemData.list ~= nil and #self.recortItemData.list > 0 then
			self.btnType = 4;
			local obj = self.showData.cost_item;
			obj = obj ~= nil and obj[1];
			if obj ~= nil then
				str = LanUtil.formateStr(163064, tonumber(obj.value));
				local tvo = Lua_ToolVo.createToolVo(tonumber(obj.key));
				self.costSp:setAltas(tvo.atlas, tvo.sprite);
			end
		end
	else
		if self.recortItemData.list ~= nil and #self.recortItemData.list > 0 then
			self.btnType = 1;
		else
			self.btnType = 2;
		end
		str = LanUtil.getValue(163021);
	end

	self.costSp:setEnable(self.btnType == 4)
	self.saveBtn:setGray(self.btnType == 2);
	self.saveBtn.label = str;

	local posX, posY;
	self.saveBtn.txt:resetSize();
	if self.btnType == 4 then
		posX = 21;
		posY = 3;
		local costPosX = -6 - self.saveBtn.txt.width / 2;
		self.costSp:setLocation(costPosX, -358); 
	else
		posX = 0;
		posY = 3;
	end
	self.saveBtn.txt:setLocation(posX, posY);
	self:updateRecordList();
end

function Lua_EuropeanRecruitRecordWindow:updateRecordList()
	if self.recordIds == nil then
		local list = {};
		if self.recortType == 1 then
			list[1] = 0;
		end

		local count = #self.showData.hero_record;
		for i = 1, count do
			list[#list + 1] = i;
		end
		self.recordIds = list;
	end
	self.recordList:setArrayData(self.recordIds);

	local bReceived = DataCenter.europeanRecruitData:checkReceived();
	self.saveBtn:setGray(bReceived);
end

function Lua_EuropeanRecruitRecordWindow:setDefaultSelectedIndex()
	if self.recortType == 1 then
		local index = DataCenter.europeanRecruitData:getBlankRecordIndex();
		if index == nil then
			DataCenter.europeanRecruitData.selectedRecordIndex = 1;
		end
	end

	return DataCenter.europeanRecruitData.selectedRecordIndex;
end

















----------------------------------
Lua_EuropeanRecruitRecordItem = class("Lua_EuropeanRecruitRecordItem", Lua_ListCell);
function Lua_EuropeanRecruitRecordItem:ctor(p)
	self:superCall("ctor", p, "EuropeanRecruitRecordItem_skin");
end

function Lua_EuropeanRecruitRecordItem:buildShowItem()
	self:superCall("buildShowItem");

end

function Lua_EuropeanRecruitRecordItem:dispose()
	self.data = nil;
	if self.heroItems ~= nil then
		for i = 1, #self.heroItems do
			self.heroItems[i]:dispose();
			self.heroItems[i] = nil;
		end
		self.heroItems = nil;
	end

	self:superCall("dispose");
end

function Lua_EuropeanRecruitRecordItem:setData(data)
	self.recordIdex = data;
	if self.recordIdex ~= 0 then
		self.data = DataCenter.europeanRecruitData:getRecordDataByIndex(self.recordIdex);
	else
		self.data = DataCenter.europeanRecruitData.curEuropeanRecruitResult;
	end

	if self.data == nil then
		return;
	end

	local noneStr;
	local heroList;
	if self.recordIdex ~= 0 then
		heroList = self.data.list;
	else
		heroList = self.data;
	end
	heroList = heroList or {};
	local bShowHero = #heroList > 0;
	self.heroObj:SetActive(bShowHero);
	if bShowHero then
		self:showHeros(heroList);
	else
		noneStr = LanUtil.getValue(163022);
	end
	self.noneTxt.text = noneStr;

	local str;
	local itemIndex;
	if self.recordIdex == 0 then
		str = LanUtil.getValue(163023);
		itemIndex = -1;
	else
		itemIndex = self.data.key;
		str = LanUtil.formateStr(163024, itemIndex);
	end
	self.nameTxt.text = str;

	self.selectedSp:setEnable(DataCenter.europeanRecruitData.selectedRecordIndex == itemIndex);
end

function Lua_EuropeanRecruitRecordItem:showHeros(heroList)
	if self.heroItems == nil then
		self.heroItems = {};
	end

	local startPosX, startPosY = -238, 24;
	local distanceX, distanceY = 94, 119;
	local posX, posY;
	local row, col;
	local curIndex;
	local item;
	local len = #heroList;
	local tvo;
	for i = 1, len do
		item = self.heroItems[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.heroObj);
			item:setScale(0.7, 0.7);
			self.heroItems[i] = item;
		end
		curIndex = i - 1;
		row = Mathf.Floor(curIndex / 5);
		col = curIndex % 5;
		posX = startPosX + col * distanceY;
		posY = startPosY - row * distanceX;

		tvo = Lua_ToolVo.createToolVo(heroList[i]);
		item:setData(tvo);
		item:setLocation(posX, posY);
	end
end

function Lua_EuropeanRecruitRecordItem:onPressClick()
	if self.data == nil then
		return;
	end

	local bReceived = DataCenter.europeanRecruitData:checkReceived();
	if bReceived then
		OperateAlert.showLangValue(163061);
		return;
	end

	if self.recordIdex == 0 then
		OperateAlert.showLangValue(163025);
		return;
	end

	if DataCenter.europeanRecruitData.selectedRecordIndex == self.data.key and self.firstClick ~= true then
		return;
	end
	self:setFirstClick(nil);

	DataCenter.europeanRecruitData.selectedRecordIndex = self.data.key;
	Lua_MsgUtil.callFunc("UPDATE_EUROPEANRECRUIT_RECORDINFO", self.data);
end

function Lua_EuropeanRecruitRecordItem:setFirstClick(value)
	self.firstClick = value;
end
