-- 好友分享邀请
Lua_EuropeanRecruitShareFriendWindow = class("Lua_EuropeanRecruitShareFriendWindow", Lua_Window);
function Lua_EuropeanRecruitShareFriendWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EuropeanRecruitShareFriendWindow";
	self.skinName = "EuropeanRecruitShareFriendWindow_skin";
	self.showWinBg = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_EuropeanRecruitShareFriendWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.friendList = Lua_DragList.new(self.content, 610, 473, Lua_AxisDefine.Vertical);
	self.friendList:setListCell(Lua_EuropeanRecruitShareFriendItem, 610, 136, 1);
    self.friendList:setLocation(0, -40, 0);
    self.friendList:setCellSpacing(0, 10);

    self.titleName:setLangValue(163050);

    self:addLuaEvent("SET_FRIENDPANEL_INFO", self, self.updateFriendList);
    self:addLuaEvent("SELECTED_SHARE_FRIEND_INFO", self, self.selectedShareFriendInfo);
    Lua_ProxyManager.getProxy("Lua_FriendProxy"):sGetFriendListInfo(Lua_FriendData.FRIEND_TYPE);
end

function Lua_EuropeanRecruitShareFriendWindow:dispose()
	self.owner = nil;
	self.callFunc = nil;
	if self.friendList ~= nil then
		self.friendList:dispose();
		self.friendList = nil;
	end
	self:superCall("dispose");
end

function Lua_EuropeanRecruitShareFriendWindow:showWin(param)
	self:superCall("showWin", param);

	self.owner = param.owner;
	self.callFunc = param.callFunc;
end

function Lua_EuropeanRecruitShareFriendWindow:updateFriendList()
    local friendInfo = DataCenter.friendData:getFriendType(Lua_FriendData.FRIEND_TYPE);
    local friends = friendInfo:getFriendList();
    self.friendList:setArrayData(friends);

    local str;
    if friends == nil or #friends <= 0 then
    	str = LanUtil.getValue(163063);
    end
    self.tipTxt.text = str;
end

function Lua_EuropeanRecruitShareFriendWindow:selectedShareFriendInfo(friendInfo)
	if self.owner == nil or self.callFunc == nil then
		return;
	end

	self.callFunc(self.owner, friendInfo);
	self:hide();
end









Lua_EuropeanRecruitShareFriendItem = class("Lua_EuropeanRecruitShareFriendItem", Lua_ListCell);
function Lua_EuropeanRecruitShareFriendItem:ctor(p)
	self:superCall("ctor", p, "EuropeanRecruitShareFriendItem_skin");
end

function Lua_EuropeanRecruitShareFriendItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
    self.avatarItem:setLocation(-237, 0, 0);
    self.avatarItem:setAvatarClick(self, self.onHeadImageClick);
    self.avatarItem:setScale(0.8, 0.8);

    self.shareSp:addClickFuntion(self, self.onClickShareSp);
end

function Lua_EuropeanRecruitShareFriendItem:dispose()
	if self.avatarItem ~= nil then
        self.avatarItem:dispose();
        self.avatarItem = nil;
    end
	self:superCall("dispose");
end

function Lua_EuropeanRecruitShareFriendItem:setData(data)
	self.data = data;
    self.friendData = DataCenter.friendData:getFriendType(Lua_FriendData.FRIEND_TYPE):getFriendItemById(data);

	if self.friendData == nil then 
		return; 
	end
    self.playerId = tonumber(self.friendData.show.id);
    self.avatarItem:setRoleId(self.playerId);
	self.avatarItem:setRoleDressUp(self.friendData.show.dress_info, true)
	self.avatarItem:setRoleLevel2(self.friendData.show.level)
    self.playerTxt.text = self.friendData.show.name;
    self.froceTxt.text = self.friendData.show.force;

    if self.friendData.offlineTick == 0 then
        self.onlineTxt:setLangValue(163051);
    else
        if self.friendData.offlineTick / 3600 < 1 then
            self.onlineTxt.text = LanUtil.formateStr(163052,tostring(Mathf.Floor(self.friendData.offlineTick / 60)));
        elseif self.friendData.offlineTick / 3600 < 24 then
            self.onlineTxt.text = LanUtil.formateStr(163053,tostring(Mathf.Floor(self.friendData.offlineTick / 3600)));
        elseif self.friendData.offlineTick / 3600 < 48 then
            self.onlineTxt.text = LanUtil.formateStr(163054,"1");
        elseif self.friendData.offlineTick / 3600 < 72 then
            self.onlineTxt.text = LanUtil.formateStr(163054,"2");
        else
            self.onlineTxt:setLangValue(163055);
        end
    end

end

function Lua_EuropeanRecruitShareFriendItem:onHeadImageClick(go)
    Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.friendData.show.id, self.friendData.show.server_flag);
end

function Lua_EuropeanRecruitShareFriendItem:onClickShareSp()
	if self.friendData == nil then 
		return; 
	end

	local data = {playerId = self.playerId, playerName = self.friendData.show.name}
	Lua_MsgUtil.callFunc("SELECTED_SHARE_FRIEND_INFO", data);
end