-- 远征双倍活动
Lua_ExpeditionDoublePanel = class("Lua_ExpeditionDoublePanel", Lua_DisplayObject);
function Lua_ExpeditionDoublePanel:ctor(p)
	self:superCall("ctor", p, "ExpeditionDoublePanel_skin");
end

function Lua_ExpeditionDoublePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.topObj, 306, 85, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ExpeditionRewardItem, 80, 85, 1);
	self.rewardList:setLocation(-193, -563);
	self.rewardList:setRectAnchor(1);
	self.rewardList:setCellSpacing(5, 0);
	self.goBtn:addClickFuntion(self,self.gotoExpedition);
	self.help:addClickFuntion(self, self.onShowTipsClick);

	self:addLuaEvent("UPDATE_MORE_DOUBLE_INFO", self, self.updateDoubleServerInfo);
end

function Lua_ExpeditionDoublePanel:setData(data)
	self.data = data;
	self.show_des.text = self.data.help_des;
	self:startTimer();
end

function Lua_ExpeditionDoublePanel:updateDoubleServerInfo()
	local data = DataCenter.moreDoubleData:getMoreDoubleVoById(1001);
	if data == nil then
		return
	end
	self.layerTxt.text = LanUtil.formateStr(671000,data.stage_num,tostring(data.star));
	self.layerTxt:resetSize();
	self.starIcon:setLocation(-201 + self.layerTxt.width+19,-446,0);
	self.rewardList:setArrayData(data.item_list);
end

function Lua_ExpeditionDoublePanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:updateLeftTime();
		Lua_CommonUtil.addTimer("ExpeditionDoubleUpdateLeftTime", 1, self, self.updateLeftTime);
	end
end

function Lua_ExpeditionDoublePanel:updateLeftTime()
	local time = self.data.residueTime;
	if time <= 0 then
		time = 0;
		self:endTimer();	
	end
	self.leftTimeTxt.text = Lua_TimeTransform.transSeconds16(time, true, true, true);
end

function Lua_ExpeditionDoublePanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_ExpeditionDoublePanel:gotoExpedition()
	local bOpen = DataCenter.funcOpenData:isOpened(10092);
	if bOpen then
		DataCenter.funcPathUtil:gotoFunction(1016);
	else
		local vo = DataCenter.funcOpenUtil:getFuncOpenVoById(10092);
		local str = LanUtil.formateStr(671002, vo.advanceMessage);
		OperateAlert.show(str);
	end
end

function Lua_ExpeditionDoublePanel:onShowTipsClick(go)
	local tipsData = { des = LanUtil.getValue(671003), posX = 175, posY = -260 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_ExpeditionDoublePanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;
	self:endTimer();
	self:superCall("dispose");
end










Lua_ExpeditionRewardItem = class("Lua_ExpeditionRewardItem", Lua_ItemIconCell)
function Lua_ExpeditionRewardItem:buildShowItem()
	self:superCall("buildShowItem")
	self.itemIcon:setScale(0.64, 0.64, 0.64);
end

function Lua_ExpeditionRewardItem:setData(data)
	self.data = Lua_ToolVo.createToolVo(data.key, data.value);
	self.itemIcon:setData(self.data);
	self.itemIcon:showNum(0);
end