-- 幸运礼盒详情界面信息
Lua_LuckyGiftBoxDetailWindow = class("Lua_LuckyGiftBoxDetailWindow", Lua_Window);
function Lua_LuckyGiftBoxDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LuckyGiftBoxDetailWindow";
	self.skinName = "LuckyGiftBoxDetailWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -576
end

function Lua_LuckyGiftBoxDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardDesList = Lua_DragList.new(self.content, 480, 230, Lua_AxisDefine.Vertical);
	self.rewardDesList:setListCell(Lua_LuckyGiftBoxDetailRewardDesItem, 480, 22, 1);
	self.rewardDesList:setCellSpacing(0, 4);
	self.rewardDesList:setLocation(0, 180, 0);

	self.tipsDesContainer = Lua_DragContainer.new(self.content, 480, 380, Lua_AxisDefine.Vertical);
	self.tipsDesContainer:setLocation(0, -210, 0);

	self:addLuaEvent("UPDATE_LUCKYGIFTBOX_DETAIL_INFO", self, self.updateDetailInfo);
end

function Lua_LuckyGiftBoxDetailWindow:showWin(param)
	self:superCall("showWin", param);

	self.tipsDesContainer:addSubContainer(Lua_LuckyGiftBoxDetailTipsDesItem, param.help_des, true);
	self.tipsDesContainer.canDrag = not self.tipsDesContainer.isTheEnd;

	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sLuckyGiftBoxDetailInfo(param.actIdx);
end

function Lua_LuckyGiftBoxDetailWindow:updateDetailInfo(msg)
	if msg == nil then
		return;
	end

	if #msg > 0 then
		local obj;
		local info;
		local sortWeight = 0;
		local itemDic = {};
		local bestGiftInfo;
		for i = 1, #msg do
			obj = msg[i];
			if bestGiftInfo == nil
				and obj.gift_id == DataCenter.luckyGiftBoxData.advance_gift_id
				and obj.gift_amount == DataCenter.luckyGiftBoxData.advance_gift_amount
				and obj.limit_times == 1 then
					bestGiftInfo = obj;
			else
				if itemDic[obj.gift_id] == nil then
					itemDic[obj.gift_id] = {};
				end

				info = itemDic[obj.gift_id][obj.gift_amount];
				if info == nil then
					sortWeight = sortWeight + 1;
					info = {
						sortWeight = sortWeight,
						gift_id = obj.gift_id,
						gift_amount = obj.gift_amount,
						residue_times = obj.residue_times,
						limit_times = obj.limit_times,
					};
					itemDic[obj.gift_id][obj.gift_amount] = info;
				else
					info.residue_times = info.residue_times + obj.residue_times;
					info.limit_times = info.limit_times + obj.limit_times;
				end
			end
		end
		local arr = Array();
		for k,v in pairs(itemDic) do
			for i, j in pairs(v) do
				arr:add(j);
			end
		end
		arr:sortf(self, self.onSortFun);
		arr:insert(bestGiftInfo, 1);
		self.rewardDesList.canDrag = (arr:getSize() * 26 - 4) > 230;
		self.rewardDesList:setArrayData(arr);
	end
	self.rewardDesList:setEnable(#msg > 0);
	self.desTxt_2:setEnable(#msg > 0);
	self.desTxt_3:setEnable(#msg > 0);
	self:showTipsFun(#msg <= 0);
end

function Lua_LuckyGiftBoxDetailWindow:onSortFun(a, b)
	local tvoA = Lua_ToolVo.createToolVo(a.gift_id, a.gift_amount);
	local tvoB = Lua_ToolVo.createToolVo(b.gift_id, b.gift_amount);
	if a.residue_times ~= b.residue_times then
		return a.residue_times < b.residue_times;
	else
		if tvoA.color ~= tvoB.color then
			return tvoA.color > tvoB.color;
		else
			return a.sortWeight < b.sortWeight;
		end
	end
end

function Lua_LuckyGiftBoxDetailWindow:showTipsFun(bShow)
	if bShow then
		if self.tipsTxt == nil then
			self.tipsTxt = UICreate.createLabel(self.content, LanUtil.getValue(766028), 0, 180, 0, 0, 26);
			self.tipsTxt.alignmentValue = 4;
			self.tipsTxt.horizontalOverflowValue = 1;
			self.tipsTxt.colorStr = Lua_ColorDefine.transColorStr("726763");
		end
		self.tipsTxt:setEnable(true);
	else
		if self.tipsTxt ~= nil then
			self.tipsTxt:setEnable(false);
		end
	end
end

function Lua_LuckyGiftBoxDetailWindow:dispose()
	if self.tipsTxt ~= nil then
		self.tipsTxt:dispose();
		self.tipsTxt = nil;
	end
	if self.rewardDesList ~= nil then
		self.rewardDesList:dispose();
		self.rewardDesList = nil;
	end
	if self.tipsDesContainer ~= nil then
		self.tipsDesContainer:dispose();
		self.tipsDesContainer = nil;
	end
	self:superCall("dispose");
end










Lua_LuckyGiftBoxDetailRewardDesItem = class("Lua_LuckyGiftBoxDetailRewardDesItem", Lua_ListCell);
function Lua_LuckyGiftBoxDetailRewardDesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LuckyGiftBoxDetailRewardDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemDes = UICreate.createLabel(self.content, "", -239, 0, 0, 22, 22);
	self.itemDes.pivotValue = 3;
	self.itemDes.alignmentValue = 3;
	self.itemDes.horizontalOverflowValue = 1;
	self.itemDes.colorStr = Lua_ColorDefine.transColorStr("726763");

	self.countDes = UICreate.createLabel(self.content, "", 195, 0, 0, 22, 22);
	self.countDes.alignmentValue = 4;
	self.countDes.horizontalOverflowValue = 1;
	self.countDes.colorStr = Lua_ColorDefine.transColorStr("726763");
end

function Lua_LuckyGiftBoxDetailRewardDesItem:setData(data)
	if data == nil then
		return;
	end

	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(data.gift_id, data.gift_amount);
	else
		self.tvo:setData(data.gift_id, data.gift_amount);
	end
	self.itemDes.text = LanUtil.formateStr(766009, self.tvo.name, self.tvo.count);
	self.countDes.text = LanUtil.formateStr(766010, data.residue_times, data.limit_times);
end

function Lua_LuckyGiftBoxDetailRewardDesItem:dispose()
	if self.itemDes ~= nil then
		self.itemDes:dispose();
		self.itemDes = nil;
	end
	if self.countDes ~= nil then
		self.countDes:dispose();
		self.countDes = nil;
	end
	self.tvo = nil;
	self:superCall("dispose");
end










Lua_LuckyGiftBoxDetailTipsDesItem = class("Lua_LuckyGiftBoxDetailTipsDesItem", Lua_ListCell);
function Lua_LuckyGiftBoxDetailTipsDesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LuckyGiftBoxDetailTipsDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt = UICreate.createLabel(self.content, "", 0, 0, 480, 0, 22);
	self.desTxt.verticalOverflowValue = 1;
	self.desTxt.alignmentValue = 0;
	self.desTxt.colorStr = Lua_ColorDefine.transColorStr("726763");
end

function Lua_LuckyGiftBoxDetailTipsDesItem:setData(data)
	if data == nil then
		return;
	end
	self.desTxt.text = data;
	self.desTxt:resetSize();
end

function Lua_LuckyGiftBoxDetailTipsDesItem:getWidth()
	return self.desTxt.width;
end

function Lua_LuckyGiftBoxDetailTipsDesItem:getHeight()
	return self.desTxt.height;
end

function Lua_LuckyGiftBoxDetailTipsDesItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self:superCall("dispose");
end