-- 幸运礼盒
Lua_LuckyGiftBoxPanel = class("Lua_LuckyGiftBoxPanel", Lua_DisplayObject);
function Lua_LuckyGiftBoxPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_LuckyGiftBoxPanel:buildShowItem()
	self:superCall("buildShowItem");

	DataCenter.luckyGiftBoxData.isOpen = 1;
	self.showItemArr = Array();

	self.bestGiftIcon = Lua_LuckyGiftBoxItemIcon.new(self.uitweenObj_2);
	self.bestGiftIcon:setSiblingIndex(2);
	self.bestGiftIcon:setRectAnchor(1);
	self.bestGiftIcon:setLocation(0, -3, 0);
	self.bestGiftIcon:setClick(self, self.onSelectGiftClick);

	self.taskPoint = Lua_RedPointIcon.new(self.uitweenObj_3, Lua_RedPointList.LuckyGiftBox_Task);
	self.taskPoint:setLocation(318, 80, 0);

	self.reSelectIcon:addClickFuntion(self, self.onSelectGiftClick);
	self.detailInfoBtn:addClickFuntion(self, self.onDetailInfoClick);
	self.actCoinIcon:addClickFuntion(self, self.onItemTipsClick);
	self.addBtn:addClickFuntion(self, self.onItemInfoClick);
	self.taskBtn:addClickFuntion(self, self.onGoTaskClick);

	self:updateUIAdaptHeight();

	self:addLuaEvent("UPDATE_LUCKYGIFTBOX_INFO", self, self.updateLuckyGiftBoxInfo);
	self:addLuaEvent("UPDATE_LUCKYGIFTBOX_NEXTROUND_INFO", self, self.updateNextRoundInfo);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateItemCount); -- 更新道具数量
	self:addLuaEvent("MONEY_UPDATE", self, self.updateItemCount); -- 更新道具数量
	self:addLuaEvent("SELECT_LUCKYGIFTBOX_BRSTGIFT", self, self.onSelectGiftClick);
	self:addLuaEvent("DRAW_LUCKYGIFTBOX_REWARD", self, self.drawLuckyGiftBoxReward);
	self:addLuaEvent("ENTER_LUCKYGIFTBOX_NEXTROUND", self, self.enterLuckyGiftBoxNextRound);
	self:addLuaEvent("REMOVE_LUCKYGIFTBOX_MASK", self, self.onDelayCallFun);
end

function Lua_LuckyGiftBoxPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self:updateUIAdaptHeight();
end

function Lua_LuckyGiftBoxPanel:updateUIAdaptHeight()
	if self.adaptHeight > 0 then
		LuaUtil.setObjPos(self.uitweenObj_3, 0, 905 + self.adaptHeight, 0);
	else
		LuaUtil.setObjPos(self.uitweenObj_3, 0, 905, 0);
	end
end

function Lua_LuckyGiftBoxPanel:setData(actVo)
	self.actVo = actVo;
	self:startTimer();
	self:updateLeftTime();
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sLuckyGiftBoxTaskInfo(actVo.actIdx); -- 用于红点
end

function Lua_LuckyGiftBoxPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_LuckyGiftBoxPanel_CountDown", 1, self, self.updateLeftTime);
	end
end

function Lua_LuckyGiftBoxPanel:updateLeftTime()
	local time = self.actVo.residueTime;
	self.leftTimeTxt.text = Lua_TimeTransform.transSeconds20(time);
	if time <= 0 then
		self.leftTimeTxt:setLangValue(766000);
		self:endTimer();
	end
end

function Lua_LuckyGiftBoxPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_LuckyGiftBoxPanel:updateLuckyGiftBoxInfo()
	local luckyGiftBoxData = DataCenter.luckyGiftBoxData;
	local tvo = Lua_ToolVo.createToolVo(luckyGiftBoxData.cost_item_id);
	local str = spliceIconStr(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth * 0.8, tvo.iconHeight * 0.8);
	self.actCoinIcon:setAltas(tvo.atlas, tvo.sprite);
	self.actCoinTxt.text = numberTrans(DataCenter.packData:getItemCountById(luckyGiftBoxData.cost_item_id));
	self.diamondCostTxt.text = LanUtil.formateStr(766027, str, luckyGiftBoxData.cost_item_num);
	self:updateItemCount();

	if luckyGiftBoxData.advance_gift_id ~= 0 then
		tvo:setData(luckyGiftBoxData.advance_gift_id, luckyGiftBoxData.advance_gift_amount);
		self.bestGiftIcon:setData(tvo, 2);
		self.bestGiftIcon:setShowState(false, true, false);
		self.bestGiftIcon:setDrawMask(luckyGiftBoxData.isDrawBestGIft);

		self.curRewardBg_1:setEnable(true);
		self.curRewardBg_2:setEnable(true);
	else
		self.bestGiftIcon:setData(nil, 2);
		self.bestGiftIcon:setShowState(false, false, true);
		self.bestGiftIcon:setDrawMask(false);

		self.curRewardBg_1:setEnable(false);
		self.curRewardBg_2:setEnable(false);
	end
	self.reSelectIcon:setEnable(not luckyGiftBoxData.isDrawBestGIft and luckyGiftBoxData.advance_gift_id ~= 0);

	local showType = 1;
	if luckyGiftBoxData.advance_gift_id == 0 then
		showType = 1;
	else
		showType = luckyGiftBoxData.isShowOpenTween and 2 or 3;
	end

	local posList = luckyGiftBoxData.posList;
	local maxLen = posList[1] * posList[2];
	local lineIdx;
	local columnIdx;
	local startPosY = -141;
	local posX;
	local posY;
	local showIdx = 0;
	self.bestGiftPosX = 0;
	self.bestGiftPosY = 0;
	for i = 1, maxLen do
		if luckyGiftBoxData.showInfoDic[i] then
			lineIdx = Mathf.Ceil(i / posList[2]);
			columnIdx = i - Mathf.Floor((i - 1) / posList[2]) * posList[2];
			posX = (columnIdx - (posList[2] + 1) / 2) * 112;
			posY = startPosY - (lineIdx - 1) * 113;
			if luckyGiftBoxData.showInfoDic[i].key == 0 then
				self.bestGiftPosX = posX;
				self.bestGiftPosY = posY;
			end

			showIdx = showIdx + 1;
			item = self.showItemArr[showIdx];
			if item == nil then
				item = Lua_LuckyGiftBoxItem.new(self.uitweenObj_3);
				self.showItemArr:add(item);
			end
			item.contentName = "Lua_LuckyGiftBoxItem_" .. i;
			item:setEnable(self.isFirstTween ~= nil);
			item:setIndex(i);
			item:setData(i, showType);
			item:setLocation(posX, posY);
		end
	end

	if showIdx < self.showItemArr:getSize() then
		for i = showIdx + 1, self.showItemArr:getSize() do
			self.showItemArr:remove(showIdx + 1);
		end
	end

	if showType == 2 then
		luckyGiftBoxData.isShowOpenTween = false;
		self:onDelayFun();
		Lua_CommonUtil.delayCall(0.5, self, self.playNewRoundTween);
	end

	-- 首次进入动画
	if self.isFirstTween == nil then
		self.isFirstTween = true;
		self.tweenIdx = 0;
		self:addTimer("Lua_LuckyGiftBoxPanel_FirstTween", 0.04, self, self.onFirstTween);
	end
end

function Lua_LuckyGiftBoxPanel:playNewRoundTween()
	for i = 1, self.showItemArr:getSize() do
		TweenUtil.getInstance():addTweenTargetScale(self.showItemArr[i].mainContent,
			0.5, 0, 0, 1, 1, self, self.onTweenFun_1, 0, false, i);
	end
end

function Lua_LuckyGiftBoxPanel:onTweenFun_1(index)
	self.showItemArr[index].giftIcon:setData(nil, 1);
	self.showItemArr[index]:setShowState(true, false);
	TweenUtil.getInstance():addTweenTargetScale(self.showItemArr[index].mainContent,
		0.5, 0, 1, 1, 1, self, self.onTweenFun_2, 0, false, index);
end

function Lua_LuckyGiftBoxPanel:onTweenFun_2(index)
	TweenUtil.getInstance():addTweenTargetPos(self.showItemArr[index].mainContent,
		1, 0, self.bestGiftPosX, self.bestGiftPosY, 0, self, self.onTweenFun_3, 0, false, index);
end

function Lua_LuckyGiftBoxPanel:onTweenFun_3(index)
	local showIdx = self.showItemArr[index].idx;
	local posList = DataCenter.luckyGiftBoxData.posList;
	local lineIdx = Mathf.Ceil(showIdx / posList[2]);
	local columnIdx = showIdx - Mathf.Floor((showIdx - 1) / posList[2]) * posList[2];
	local startPosY = -141;
	local posX = (columnIdx - (posList[2] + 1) / 2) * 112;
	local posY = startPosY - (lineIdx - 1) * 113;
	TweenUtil.getInstance():addTweenTargetPos(self.showItemArr[index].mainContent,
		1, 0, posX, posY, 0, self, self.onEndTweenFun, 0, false, index);
end

function Lua_LuckyGiftBoxPanel:onEndTweenFun(index)
	TweenUtil.getInstance():stop(self.showItemArr[index].mainContent);
	self:onDelayCallFun();
end

function Lua_LuckyGiftBoxPanel:onFirstTween()
	self.tweenIdx = self.tweenIdx + 1;
	if self.tweenIdx > self.showItemArr:getSize() then
		self:removeTimer(self, self.onFirstTween);
		return;
	end
	local item = self.showItemArr[self.tweenIdx];
	item:setEnable(true);
	TweenUtil.getInstance():addTweenTargetAlpha(item.content, 0.2, 0, -1, true);
end

-- 全部奖励抽完之后请求界面信息
function Lua_LuckyGiftBoxPanel:updateNextRoundInfo()
	local luckyGiftBoxData = DataCenter.luckyGiftBoxData;
	if luckyGiftBoxData.showCount == luckyGiftBoxData.drawCount and luckyGiftBoxData.is_last_round == 0 then
		self:onLuckyGiftBoxOperate(0);
	end
end

function Lua_LuckyGiftBoxPanel:updateItemCount(dic)
	local luckyGiftBoxData = DataCenter.luckyGiftBoxData;
	local langId = 766001;
	local limitTimes = luckyGiftBoxData.diamondLeftTimes or 0;
	local totalTimes = luckyGiftBoxData.diamondTotalTimes or 1;
	-- 不区分折扣和非折扣
	-- if luckyGiftBoxData.discount_residue_times > 0 then
	-- 	langId = 766001;
	-- 	limitTimes = luckyGiftBoxData.discount_residue_times;
	-- 	totalTimes = luckyGiftBoxData.discount_max_times;
	-- else
	-- 	langId = 766002;
	-- 	limitTimes = luckyGiftBoxData.cost_residue_times;
	-- 	totalTimes = luckyGiftBoxData.cost_max_times;
	-- end
	self.limitTimesTxt.text = LanUtil.formateStr(langId, limitTimes, totalTimes);

	-- 不区分折扣和非折扣
	local itemId = luckyGiftBoxData.recharge_item_id; -- luckyGiftBoxData.curItemId;
	local itemCount = luckyGiftBoxData.curDiamondCount; -- luckyGiftBoxData.curItemCount;
	local tvo = Lua_ToolVo.createToolVo(itemId);
	local str = spliceIconStr(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth, tvo.iconHeight);
	self.curLuckyDrawTxt.text = LanUtil.formateStr(766003, str, itemCount);
	
	if dic and dic[luckyGiftBoxData.cost_item_id] then
		self.actCoinTxt.text = numberTrans(DataCenter.packData:getItemCountById(luckyGiftBoxData.cost_item_id));
	end
end

function Lua_LuckyGiftBoxPanel:onDetailInfoClick(go)
	self:onLuckyGiftBoxOperate(1);
end

function Lua_LuckyGiftBoxPanel:onSelectGiftClick(go)
	self:onLuckyGiftBoxOperate(2);
end

function Lua_LuckyGiftBoxPanel:onItemTipsClick(go)
	self:showActTvoInfo(1);
end

function Lua_LuckyGiftBoxPanel:onItemInfoClick(go)
	self:showActTvoInfo(2);
end

function Lua_LuckyGiftBoxPanel:showActTvoInfo(showType)
	if self.actTvo == nil then
		self.actTvo = Lua_ToolVo.createToolVo(DataCenter.luckyGiftBoxData.cost_item_id);
	else
		self.actTvo:setData(DataCenter.luckyGiftBoxData.cost_item_id);
	end
	if showType == 1 then
		DataCenter.packUtil:showItemInfo(self.actTvo, false);
	else
		DataCenter.packUtil:openPathWindow(self.actTvo, false);
	end
end

function Lua_LuckyGiftBoxPanel:onGoTaskClick(go)
	self:onLuckyGiftBoxOperate(3);
end

function Lua_LuckyGiftBoxPanel:enterLuckyGiftBoxNextRound(go)
	if DataCenter.luckyGiftBoxData.is_last_round == 0 then
		self:onLuckyGiftBoxOperate(4);
	end
end

function Lua_LuckyGiftBoxPanel:drawLuckyGiftBoxReward(giftIdx)
	self:onLuckyGiftBoxOperate(5, giftIdx);
end

function Lua_LuckyGiftBoxPanel:onLuckyGiftBoxOperate(operateType, param)
	if self.actVo == nil or DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	if operateType == 0 then
		Lua_WindowUtil.openWin("Lua_LuckyGiftBoxTipsWindow", Lua_WinParam.ACTION_OPEN, {owner = self, callBack = self.onUpdateFun});
	elseif operateType == 1 then
		Lua_WindowUtil.openWin("Lua_LuckyGiftBoxDetailWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 2 then
		if DataCenter.luckyGiftBoxData.isDrawBestGIft then
			OperateAlert.showLangValue(766004);
		else
			Lua_WindowUtil.openWin("Lua_SelectBestGiftBoxWindow", Lua_WinParam.ACTION_OPEN, self.actVo.actIdx);
		end
	elseif operateType == 3 then
		Lua_WindowUtil.openWin("Lua_LuckyGiftBoxTaskWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 4 then
		if DataCenter.luckyGiftBoxData.isDrawBestGIft then
			local tipsData = {
				owner = self,
				des = LanUtil.getValue(766005),
				btnType = 1,
				sureFun = self.sEnterNext
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
		end
	elseif operateType == 5 then
		self:onDelayFun();
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sDrawLuckyGiftBox(self.actVo.actIdx, param);
	end
end

function Lua_LuckyGiftBoxPanel:onUpdateFun()
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx);
end

function Lua_LuckyGiftBoxPanel:sEnterNext()
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sStartNextRounds(self.actVo.actIdx);
end

-- 播放动画增加遮罩，不可以执行其他操作
function Lua_LuckyGiftBoxPanel:onDelayFun()
	Lua_MsgUtil.callFunc("OPERATIONAL_ACTIVITIES_CLICKLIMIT", 2);
end

function Lua_LuckyGiftBoxPanel:onDelayCallFun()
	Lua_MsgUtil.callFunc("OPERATIONAL_ACTIVITIES_CLICKLIMIT", 0);
end

function Lua_LuckyGiftBoxPanel:dispose()
	if self.taskPoint ~= nil then
		self.taskPoint:dispose();
		self.taskPoint = nil;
	end
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	self.actVo = nil;
	self.actTvo = nil;
	DataCenter.luckyGiftBoxData.isOpen = 0;
	self:removeTimer(self, self.onFirstTween);
	self:endTimer();
	self:onDelayCallFun();
	self:superCall("dispose");
end










Lua_LuckyGiftBoxItem = class("Lua_LuckyGiftBoxItem", Lua_DisplayObject);
function Lua_LuckyGiftBoxItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LuckyGiftBoxItem:buildShowItem()
	self:superCall("buildShowItem");

	self.giftIcon = Lua_LuckyGiftBoxItemIcon.new(self.content);
	self.giftIcon:setClick(self, self.onPressClick);
end

function Lua_LuckyGiftBoxItem:setIndex(index)
	self.idx = index;
end

function Lua_LuckyGiftBoxItem:setData(data, showType)
	self._data = data;
	if data == nil then
		return;
	end

	local luckyGiftBoxData = DataCenter.luckyGiftBoxData;
	self.giftIcon:setBoxIcon(luckyGiftBoxData.icon_config.icon_atlas, luckyGiftBoxData.icon_config.icon_index);
	if showType == 1 then
		self.isRemove = false;
		self:setShowInfo_1();
	elseif showType == 3 then
		self.giftIcon:setData(nil, 1);
		self:setShowInfo_2();
	end
end

function Lua_LuckyGiftBoxItem:setShowInfo_1()
	local itemInfo = DataCenter.luckyGiftBoxData.showInfoDic[self._data];
	local tvo = Lua_ToolVo.createToolVo(itemInfo.key, tonumber(tostring(itemInfo.value)));
	self.giftIcon:setData(tvo, 1);
	self:setShowState(false, true, itemInfo.key == 0);
	self:showEffect(false);
end

function Lua_LuckyGiftBoxItem:setShowState(boxShow, iconShow, addShow)
	addShow = addShow or false;
	self.giftIcon:setShowState(boxShow, iconShow and not addShow, addShow);
end

function Lua_LuckyGiftBoxItem:setShowInfo_2()
	local luckyGiftBoxData = DataCenter.luckyGiftBoxData;
	local giftInfo = luckyGiftBoxData.luckyBoxInfoDic[self._data];
	local isShowEffect = false;
	self:setShowState(true, giftInfo ~= nil);
	if giftInfo ~= nil then
		if self.tvo == nil then
			self.tvo = Lua_ToolVo.createToolVo(giftInfo.gift_id, giftInfo.gift_amount);
		else
			self.tvo:setData(giftInfo.gift_id, giftInfo.gift_amount);
		end
		self.giftIcon:setData(self.tvo, 1);

		isShowEffect = self.tvo.id == luckyGiftBoxData.advance_gift_id and self.tvo.count == luckyGiftBoxData.advance_gift_amount;
		if giftInfo.cell_index == luckyGiftBoxData.curGiftIdx and self.isShowDrawTween then	
			if not isShowEffect then
				self.isRemove = true;
				Lua_MsgUtil.callFunc("REMOVE_LUCKYGIFTBOX_MASK"); -- 普通奖励隐藏遮罩
			end
			self:onPlayTween();
		else
			self:setShowState(false, true);
		end
	end
	self:showEffect(isShowEffect and luckyGiftBoxData.is_last_round == 0);
end

-- 开始动画
function Lua_LuckyGiftBoxItem:onPlayTween()
	self:setShowState(true, false);
	TweenUtil.getInstance():addTweenTargetScale(self.mainContent, 0.35, 0, 0, 1, 1, self, self.onBoxComplete);
end

-- 箱子动画结束
function Lua_LuckyGiftBoxItem:onBoxComplete()
	self:setShowState(false, true);
	TweenUtil.getInstance():addTweenTargetScale(self.mainContent, 0.35, 0, 1, 1, 1, self, self.onRewardComplete);
end

-- 奖励显示动画结束
function Lua_LuckyGiftBoxItem:onRewardComplete()
	if not self.isRemove then
		Lua_MsgUtil.callFunc("REMOVE_LUCKYGIFTBOX_MASK");
	end
	TweenUtil.getInstance():stop(self.mainContent);

	local luckyGiftBoxData = DataCenter.luckyGiftBoxData;
	local giftInfo = luckyGiftBoxData.luckyBoxInfoDic[self._data];
	if giftInfo ~= nil then
		if self.isShowDrawTween then
			if self.tvo.id == luckyGiftBoxData.advance_gift_id and self.tvo.count == luckyGiftBoxData.advance_gift_amount then
				local arr = Array();
				arr:add(self.tvo);
				Lua_WindowUtil.openWin("Lua_LuckyGiftBoxRewardWindow", Lua_WinParam.ACTION_OPEN, arr);
			else
				OperateAlert.show(LanUtil.formateStr(766006, self.tvo.name, self.tvo.count));
				Lua_MsgUtil.callFunc("UPDATE_LUCKYGIFTBOX_NEXTROUND_INFO");
			end
		end
		self.isShowDrawTween = false;
	end
end

function Lua_LuckyGiftBoxItem:showEffect(isShow)
	if isShow then
		if self.uiEffect == nil then
			self.uiEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_boxeffect_02", "ui_boxeffect_02", 0, 0);
			self.uiEffect:setScale(1, 1);
		end
		self.uiEffect:setEnable(false);
		self.uiEffect:setEnable(true);
	else
		if self.uiEffect ~= nil then
			self.uiEffect:setEnable(false);
		end
	end
end

function Lua_LuckyGiftBoxItem:onPressClick()
	local luckyGiftBoxData = DataCenter.luckyGiftBoxData;
	local giftInfo = luckyGiftBoxData.luckyBoxInfoDic[self._data];
	if luckyGiftBoxData.advance_gift_id == 0 then
		OperateAlert.showLangValue(766007);
		Lua_MsgUtil.callFunc("SELECT_LUCKYGIFTBOX_BRSTGIFT");
	else
		if giftInfo ~= nil then
			if giftInfo.gift_id == luckyGiftBoxData.advance_gift_id
				and giftInfo.gift_amount == luckyGiftBoxData.advance_gift_amount
				and luckyGiftBoxData.is_last_round == 0 then
					Lua_MsgUtil.callFunc("ENTER_LUCKYGIFTBOX_NEXTROUND");
			else
				DataCenter.packUtil:showItemInfo(self.tvo);
			end
		else
			if luckyGiftBoxData.costType == 1 then -- 3 消耗活动道具
				self:sDrawBox();
			elseif luckyGiftBoxData.costType == 2 or luckyGiftBoxData.costType == 3 then -- 2折扣钻石，3原价钻石
				local needCount = luckyGiftBoxData.curItemCount;
				local hasCount = DataCenter.moneyData:getMoney(luckyGiftBoxData.recharge_item_id);
				if hasCount >= needCount then
					if not DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.LUCKYGIFTBOX) then
						local actTvo = Lua_ToolVo.createToolVo(luckyGiftBoxData.cost_item_id);
						local str = spliceIconStrById(luckyGiftBoxData.recharge_item_id);
						local tipsData = {
							des = LanUtil.formateStr(766008, str, needCount, hasCount, luckyGiftBoxData.cost_item_num, actTvo.colorStr, actTvo.name),
							posY = 50,
							btnType = 1,
							neverTip = Lua_NeverTipDefine.LUCKYGIFTBOX,
							owner = self,
							sureFun = self.sDrawBox
						};
						Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
					else
						self:sDrawBox();
					end
				else
					local tvo = Lua_ToolVo.createToolVo(luckyGiftBoxData.cost_item_id);
					DataCenter.packUtil:openPathWindow(tvo, false);
				end
			else -- 0 钻石和道具次数都不足
				local tvo = Lua_ToolVo.createToolVo(luckyGiftBoxData.cost_item_id);
				DataCenter.packUtil:openPathWindow(tvo, false);
			end
		end
	end
end

function Lua_LuckyGiftBoxItem:sDrawBox()
	if self.clickTime and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();
	self.isShowDrawTween = true;
	Lua_MsgUtil.callFunc("DRAW_LUCKYGIFTBOX_REWARD", self._data);
end

function Lua_LuckyGiftBoxItem:dispose()
	TweenUtil.getInstance():stop(self.mainContent);
	self._data = nil;
	self.tvo = nil;
	self:superCall("dispose");
end










Lua_LuckyGiftBoxItemIcon = class("Lua_LuckyGiftBoxItemIcon", Lua_ItemIcon);
function Lua_LuckyGiftBoxItemIcon:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LuckyGiftBoxItemIcon:buildShowItem()
	self:superCall("buildShowItem");

	self.addIcon = UICreate.createUIAtlasImage(self.content, "luckygiftbox_atlas", "xui_xylh_button_2", 0, 0, 0, 0);
	self.addIcon.name = "addIcon";
	self.addIcon.siblingIndex = 1;
	self.boxIcon = UICreate.createUIAtlasImage(self.content, "luckygiftbox_atlas", "xui_xylh_widget_14", 0, 0, 0, 0);
	self.boxIcon.name = "boxIcon";
	self.boxIcon:setScale(0.76, 0.76);
end

function Lua_LuckyGiftBoxItemIcon:setData(data, bgType)
	self:superCall("setData", data);

	if bgType == 1 then
		self:setIconBg("luckygiftbox_atlas", "xui_xylh_itembg_2");
		self:setRectSize(109, 109);
		self.iconBg:SetDimensions(109, 109);
		self.iconImg:setScale(0.8, 0.8);
	else
		self:setIconBg("luckygiftbox_atlas", "xui_xylh_itembg_1");
		self:setRectSize(120, 120);
		self.iconBg:SetDimensions(120, 120);
		self.iconImg:setScale(1, 1);
	end

	if self._txt_right_down ~= nil then
		self.txt_right_down:setLocation(45, -35, 0);
	end
end

function Lua_LuckyGiftBoxItemIcon:setBoxIcon(atlas, sprite)
	self.boxIcon:setAltas(atlas, sprite);
end

function Lua_LuckyGiftBoxItemIcon:setShowState(boxShow, iconShow, addShow)
	self.boxIcon:setEnable(boxShow);
	self.iconImg:setEnable(iconShow);
	self.addIcon:setEnable(addShow);
end