-- 幸运礼盒任务界面信息
Lua_LuckyGiftBoxTaskWindow = class("Lua_LuckyGiftBoxTaskWindow", Lua_Window);
function Lua_LuckyGiftBoxTaskWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LuckyGiftBoxTaskWindow";
	self.skinName = "LuckyGiftBoxTaskWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -540
end

function Lua_LuckyGiftBoxTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.taskList = Lua_DragList.new(self.content, 628, 760, Lua_AxisDefine.Vertical);
	self.taskList:setListCell(Lua_LuckyGiftBoxTaskItem, 628, 144, 1);
	self.taskList:setLocation(0, -59.5, 0);

	self:addLuaEvent("UPDATE_LUCKYGIFTBOX_TASK_INFO", self, self.updateShowInfo);
	self:addLuaEvent("DRAW_LUCKYGIFTBOX_TASK_REWARD", self, self.onDrawLuckyGiftBoxTaskReward);
end

function Lua_LuckyGiftBoxTaskWindow:showWin(param)
	self:superCall("showWin", param);

	self.onTimer = param.residueTime;
	self:startTimer();
	self:updateLeftTime();
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sLuckyGiftBoxTaskInfo(param.actIdx);
end

function Lua_LuckyGiftBoxTaskWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_LuckyGiftBoxTaskWindow", 1, self, self.updateLeftTime);
	end
end

function Lua_LuckyGiftBoxTaskWindow:updateLeftTime()
	self.onTimer = self.onTimer - 1;
	if self.onTimer <= 0 then
		self.onTimer = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr(766011, Lua_TimeTransform.transSeconds16(self.onTimer, true, true, true));
end

function Lua_LuckyGiftBoxTaskWindow:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_LuckyGiftBoxTaskWindow:updateShowInfo()
	self.taskList:setArrayData(DataCenter.luckyGiftBoxData.taskInfoArr);
end

function Lua_LuckyGiftBoxTaskWindow:onDrawLuckyGiftBoxTaskReward(taskId)
	if DataCenter.backstageActData:checkActIsEnd(self.showData) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sLuckyGiftBoxTaskReward(self.showData.actIdx, taskId);
end

function Lua_LuckyGiftBoxTaskWindow:dispose()
	if self.taskList ~= nil then
		self.taskList:dispose();
		self.taskList = nil;
	end
	self:endTimer();
	self:superCall("dispose");
end










Lua_LuckyGiftBoxTaskItem = class("Lua_LuckyGiftBoxTaskItem", Lua_ListCell);
function Lua_LuckyGiftBoxTaskItem:ctor(p)
	self:superCall("ctor", p, "LuckyGiftBoxTaskItem_skin");
end

function Lua_LuckyGiftBoxTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.condTxt:setEnable(false);

	self.rewardList = Lua_DragList.new(self.content, 166, 80, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_LuckyGiftBoxRewardItem, 80, 80, 1);
	self.rewardList:setCellSpacing(6, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-40, 1, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_LuckyGiftBoxTaskItem:setData(data)
	self._data = DataCenter.luckyGiftBoxData:getLuckyGiftBoxTaskVoInfo(data);
	if self._data == nil then
		return;
	end

	self.desTxt.text = self._data.dec;

	local openState = self._data.openState;
	local maxValue = self._data.totalProgress;
	local value = self._data.curProcess;
	if openState then
		self.progressTxt.text = LanUtil.formateStr(766012, value, maxValue);
		self.progressBar:setMaxValue(maxValue);
		self.progressBar:setValue(value);

		self.drawIcon:setAltas("common_altas_1", "xui_common_label_12");
	else
		self.condTxt.text = self._data.advanceMessage;
		self.drawIcon:setAltas("task_altas", "xui_rcrw_label_1");
	end

	self.rewardList.canDrag = #self._data.award > 2;
	self.rewardList:setArrayData(self._data.award);

	if maxValue > value then
		self.drawState = 0;
		self.stateBtn:setStyle(3);
		self.stateBtn:setLangValue(766013);
	else
		if self._data.drawState == 0 then
			self.drawState = 1;
			self.stateBtn:setStyle(1);
			self.stateBtn:setLangValue(766014);
		else
			self.drawState = 2;
		end
	end
	self.condTxt:setEnable(not openState);
	self.progressTxt:setEnable(openState);
	self.progressBar:setEnable(openState);
	self.stateBtn:setEnable(openState and self.drawState ~= 2);
	self.drawIcon:setEnable(not openState or self.drawState == 2);
	self:showRedDot(self.drawState == 1);
end

function Lua_LuckyGiftBoxTaskItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onUpClick();
	end
end

function Lua_LuckyGiftBoxTaskItem:checkClick()
	local showArr = self.rewardList.showList;
	for i = 1, showArr:getSize() do
		winPos = LuaUtil.getTouchPosInverseObj(showArr[i].mainContent);
		if showArr[i].itemIcon.isActive and showArr[i].itemIcon:checkInBound(winPos.x, winPos.y) then
			return showArr[i];
		end
	end
	return nil;
end

function Lua_LuckyGiftBoxTaskItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.9, 0.9);
	end
end

function Lua_LuckyGiftBoxTaskItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(1, 1);
	end
end

function Lua_LuckyGiftBoxTaskItem:showRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(278, 16, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_LuckyGiftBoxTaskItem:onBtnClick(go)
	if self.drawState == 0 then -- 未完成
		DataCenter.funcPathUtil:gotoFunction(self._data.funcPathId, true)
	elseif self.drawState == 1 then -- 完成
		if self.checkTime and getTime() - self.checkTime < 0.5 then
			OperateAlert.showLangValue(766015);
			return;
		end
		self.checkTime = getTime();
		Lua_MsgUtil.callFunc("DRAW_LUCKYGIFTBOX_TASK_REWARD", self._data.taskId);
	end
end

function Lua_LuckyGiftBoxTaskItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_LuckyGiftBoxRewardItem = class("Lua_LuckyGiftBoxRewardItem", Lua_ItemIconCell);
function Lua_LuckyGiftBoxRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.64, 0.64);
end

function Lua_LuckyGiftBoxRewardItem:onUpClick()
	if self.data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data);
end

function Lua_LuckyGiftBoxRewardItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onItemClick();
	end
end

function Lua_LuckyGiftBoxRewardItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon.isActive and self.itemIcon:checkInBound(winPos.x, winPos.y) then
		return self.itemIcon;
	end
	return nil;
end

function Lua_LuckyGiftBoxRewardItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.54, 0.54);
	end
end

function Lua_LuckyGiftBoxRewardItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.64, 0.64);
	end
end