-- 幸运礼盒终极奖励自选界面信息
Lua_SelectBestGiftBoxWindow = class("Lua_SelectBestGiftBoxWindow", Lua_Window);
function Lua_SelectBestGiftBoxWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SelectBestGiftBoxWindow";
	self.skinName = "SelectBestGiftBoxWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -520;
end

function Lua_SelectBestGiftBoxWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isFirst = true;

	self.bestGiftIcon = Lua_ItemIcon.new(self.content);
	self.bestGiftIcon:setLocation(-193, 163);
	self.bestGiftIcon:setScale(0.9, 0.9);

	self.itemDesContainer = Lua_DragContainer.new(self.content, 390, 70, Lua_AxisDefine.Vertical);
	self.itemDesContainer:setLocation(93, 120, 0);

	self.selectGiftList = Lua_DragList.new(self.content, 566, 366, Lua_AxisDefine.Vertical);
	self.selectGiftList.canLongPress = true;
	self.selectGiftList:setListCell(Lua_SelectBestGiftBoxItem, 566, 119, 1);
	self.selectGiftList:setLocation(3, -128, 0);

	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);

	self:addLuaEvent("UPDATE_LUCKYGIFTBOX_BESTGIFT_INFO", self, self.updateBestGiftBoxInfo);
	self:addLuaEvent("UPDATE_BESTGIFTBOX_ITEMCLICK_SHOWINFO", self, self.updateShowInfo);
end

function Lua_SelectBestGiftBoxWindow:showWin(param)
	self:superCall("showWin", param);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sBestGiftBoxInfo(param);
end

function Lua_SelectBestGiftBoxWindow:updateBestGiftBoxInfo()
	self.titleTxt_1.text = LanUtil.formateStr(766016, DataCenter.luckyGiftBoxData.round);
	self.selectGiftList:setArrayData(DataCenter.luckyGiftBoxData.bestGiftInfoDic);
	self.selectGiftList:moveToIndex(DataCenter.luckyGiftBoxData.round, true, false);
	self:updateShowInfo();
end

function Lua_SelectBestGiftBoxWindow:updateShowInfo(data)
	local luckyGiftBoxData = DataCenter.luckyGiftBoxData;
	local tvo;
	if data ~= nil then
		tvo = Lua_ToolVo.createToolVo(data.gift_id, data.gift_amount);
		self.selectIdx = data.cell_index;
	else
		if luckyGiftBoxData.advance_gift_id ~= 0 then
			tvo = Lua_ToolVo.createToolVo(luckyGiftBoxData.advance_gift_id, luckyGiftBoxData.advance_gift_amount);
		end
		self.selectIdx = 1;
	end

	if tvo then
		self.bestGiftIcon:setData(tvo);
		self.bestGiftNameTxt.text = tvo.name;
		self.curCountTxt.text = LanUtil.formateStr(766017, DataCenter.packData:getItemCountById(tvo.id));

		if self.isFirst then
			self.isFirst = false;
			self.itemDesContainer:addSubContainer(Lua_ItemDesItem, tvo.des);
		end
		self.itemDesContainer:setChildData(tvo.des);
		self.itemDesContainer:updateChildPos();
		self.itemDesContainer.canDrag = not self.itemDesContainer.isTheEnd;
	end
end

function Lua_SelectBestGiftBoxWindow:onSureBtnClick(go)
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sChangeBestGiftBox(self.showData, self.selectIdx);
	self:hide();
end

function Lua_SelectBestGiftBoxWindow:dispose()
	if self.bestGiftIcon ~= nil then
		self.bestGiftIcon:dispose();
		self.bestGiftIcon = nil;
	end
	if self.itemDesContainer ~= nil then
		self.itemDesContainer:dispose();
		self.itemDesContainer = nil;
	end
	if self.selectGiftList ~= nil then
		self.selectGiftList:dispose();
		self.selectGiftList = nil;
	end
	self.isFirst = true;
	DataCenter.luckyGiftBoxData.selectBestGiftIdx = nil;
	self:superCall("dispose");
end










Lua_SelectBestGiftBoxItem = class("Lua_SelectBestGiftBoxItem", Lua_ListCell);
function Lua_SelectBestGiftBoxItem:ctor(p)
	self:superCall("ctor", p, "SelectBestGiftBoxItem_skin");
end

function Lua_SelectBestGiftBoxItem:buildShowItem()
	self:superCall("buildShowItem");
	self.giftArr = Array();
end

function Lua_SelectBestGiftBoxItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local arrLen = self.giftArr:getSize();
	local dataLen = #data;
	local maxLen = arrLen > dataLen and arrLen or dataLen;
	local item;
	for i = 1, maxLen do
		item = self.giftArr[i];
		if i > dataLen then
			item:setEnable(false);
		else
			if item == nil then
				item = Lua_BestGiftBoxItem.new(self.content);
				self.giftArr:add(item);
			end
			item:setEnable(true);
			item:setLocation(-98 + 100 * (i - 1), 0, 0);
			item:setData(data[i], i);
		end
	end

	local round = data[1].round;
	if round == DataCenter.luckyGiftBoxData.round then
		self.roundsTxt:setLangValue(766018);
		local selectIdx = DataCenter.luckyGiftBoxData.curSelectIdx;
		selectIdx = DataCenter.luckyGiftBoxData.selectBestGiftIdx or selectIdx;
		self.pressItem = self.giftArr[selectIdx];
		self.giftArr[selectIdx]:onPressClick();
	else
		self.roundsTxt.text = LanUtil.formateStr(766019, round);
		for i = 1, self.giftArr:getSize() do
			self.giftArr[i]:onSelectionChange(false);
		end
	end
	self.roundsBg:setGray(round > DataCenter.luckyGiftBoxData.round);
	self.lockIcon:setEnable(round > DataCenter.luckyGiftBoxData.round);
end

function Lua_SelectBestGiftBoxItem:onMouseDownHandle()
	local checkItem = self:checkClick();
	if checkItem then
		if self._data[1].round == DataCenter.luckyGiftBoxData.round then
			DataCenter.luckyGiftBoxData.selectBestGiftIdx = checkItem.index;
		end
		if self.pressItem and self.pressItem ~= checkItem then
			self.pressItem:onSelectionChange(false);
		end
		self.pressItem = checkItem;
		self.pressItem:onPressClick();
		self.pressItem:setScale(0.9, 0.9);
	end
end

function Lua_SelectBestGiftBoxItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(1, 1);
		self.isClick = false;
	end
end

function Lua_SelectBestGiftBoxItem:onLongPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem and not self.isClick then
		self.isClick = true;
		if self._data[1].round ~= DataCenter.luckyGiftBoxData.round then
			self.pressItem:onLongPressClick();
		end
	end
end

function Lua_SelectBestGiftBoxItem:checkClick()
	for i = 1, self.giftArr:getSize() do
		winPos = LuaUtil.getTouchPosInverseObj(self.giftArr[i].mainContent);
		if self.giftArr[i].isActive and self.giftArr[i].giftIcon:checkInBound(winPos.x, winPos.y) then
			return self.giftArr[i];
		end
	end
	return nil;
end

function Lua_SelectBestGiftBoxItem:dispose()
	if self.giftArr ~= nil then
		self.giftArr:dispose();
		self.giftArr:clear();
		self.giftArr = nil;
	end
	self.pressItem = nil;
	self:superCall("dispose");
end










Lua_BestGiftBoxItem = class("Lua_BestGiftBoxItem", Lua_DisplayObject);
function Lua_BestGiftBoxItem:ctor(p)
	self:superCall("ctor", p, "BestGiftBoxItem_skin");
end

function Lua_BestGiftBoxItem:buildShowItem()
	self:superCall("buildShowItem");

	-- 策划要求不显示
	self.noSelectIcon:setEnable(false);
	self.giftIcon = Lua_ItemIcon.new(self.content);
	self.giftIcon:setScale(0.71, 0.71);
	self.giftIcon:setSiblingIndex(0);
end

function Lua_BestGiftBoxItem:setData(data, index)
	self._data = data;
	self.index = index;
	if data == nil then
		return;
	end

	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(data.gift_id, data.gift_amount);
	else
		self.tvo:setData(data.gift_id, data.gift_amount);
	end
	self.giftIcon:setData(self.tvo);

	if data.round ~= DataCenter.luckyGiftBoxData.round then
		self.mask:setEnable(true);
		self.lvTxt:setEnable(false);
		-- self.noSelectIcon:setEnable(true);
	else
		if DataCenter.roleData.level > data.limit_level then
			self.lvTxt.text = LanUtil.formateStr(766021, data.limit_level);
		end
		self.mask:setEnable(DataCenter.roleData.level < data.limit_level);
		self.lvTxt:setEnable(DataCenter.roleData.level < data.limit_level);
		-- self.noSelectIcon:setEnable(false);
	end
end

function Lua_BestGiftBoxItem:onPressClick()
	local round = DataCenter.luckyGiftBoxData.round;
	if self._data.round < round then
		OperateAlert.showLangValue(766022);
	elseif self._data.round > round then
		OperateAlert.showLangValue(766023);
	else
		if DataCenter.roleData.level >= self._data.limit_level then
			self:onSelectionChange(true);
			Lua_MsgUtil.callFunc("UPDATE_BESTGIFTBOX_ITEMCLICK_SHOWINFO", self._data);
			return true;
		else
			OperateAlert.show(LanUtil.formateStr(766024, self._data.limit_level));
		end
	end
end

function Lua_BestGiftBoxItem:onLongPressClick()
	if self._data then
		local tvo = Lua_ToolVo.createToolVo(self._data.gift_id, self._data.gift_amount);
		DataCenter.packUtil:showItemInfo(tvo);
	end
end

function Lua_BestGiftBoxItem:onSelectionChange(bSelect)
	self.giftIcon:setDrawMask(bSelect);
end

function Lua_BestGiftBoxItem:dispose()
	if self.giftIcon ~= nil then
		self.giftIcon:dispose();
		self.giftIcon = nil;
	end
	self._data = nil;
	self.tvo = nil;
	self:superCall("dispose");
end










Lua_ItemDesItem = class("Lua_ItemDesItem", Lua_ListCell);
function Lua_ItemDesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ItemDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt = UICreate.createLabel(self.content, "", 0, 0, 390, 0, 22);
	self.desTxt.verticalOverflowValue = 1;
	self.desTxt.alignmentValue = 0;
	self.desTxt.colorStr = Lua_ColorDefine.transColorStr("727663");
end

function Lua_ItemDesItem:setData(data)
	if data == nil then
		return;
	end
	self.desTxt.text = data;
	self.desTxt:resetSize();
end

function Lua_ItemDesItem:getWidth()
	return self.desTxt.width;
end

function Lua_ItemDesItem:getHeight()
	return self.desTxt.height;
end

function Lua_ItemDesItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self:superCall("dispose");
end










-- Lua_SelectBestGiftBoxItem = class("Lua_SelectBestGiftBoxItem", Lua_ListCell);
-- function Lua_SelectBestGiftBoxItem:ctor(p)
-- 	self:superCall("ctor", p, "SelectBestGiftBoxItem_skin");
-- end

-- function Lua_SelectBestGiftBoxItem:buildShowItem()
-- 	self:superCall("buildShowItem");

-- 	self.bestGiftList = Lua_DragList.new(self.content, 390, 89, Lua_AxisDefine.Horizontal);
-- 	self.bestGiftList:setListCell(Lua_BestGiftBoxItem, 89, 89, 1);
-- 	self.bestGiftList:setCellSpacing(11, 0);
-- 	self.bestGiftList:setLocation(53, 0, 0);
-- 	self:setSubList(self.bestGiftList);
-- end

-- function Lua_SelectBestGiftBoxItem:setData(data)
-- 	if data == nil then
-- 		return;
-- 	end

-- 	local round = data[1].round;
-- 	self.lockIcon:setEnable(round > DataCenter.luckyGiftBoxData.round);
-- 	self.bestGiftList.canDrag = #data > 4;
-- 	self.bestGiftList:setArrayData(data);
-- 	if round == DataCenter.luckyGiftBoxData.round then
-- 		self.roundsTxt:setLangValue(766018);

-- 		local curSelectIdx = DataCenter.luckyGiftBoxData.curSelectIdx;
-- 		self.bestGiftList:moveToIndex(curSelectIdx, true, false);
-- 		self.bestGiftList:setSelectClick(curSelectIdx);
-- 		self.bestGiftList:setSelected(curSelectIdx);
-- 	else
-- 		self.roundsTxt.text = LanUtil.formateStr(766019, round);

-- 		self.bestGiftList:moveToIndex(1, true, false);
-- 		self.bestGiftList:setSelected(nil);
-- 	end
-- 	self.roundsBg:setGray(round > DataCenter.luckyGiftBoxData.round);
-- end

-- function Lua_SelectBestGiftBoxItem:onLongPressClick()
-- 	if self.tvo then
-- 		DataCenter.packUtil:showItemInfo(self.tvo);
-- 	end
-- end

-- function Lua_SelectBestGiftBoxItem:dispose()
-- 	if self.bestGiftList ~= nil then
-- 		self.bestGiftList:dispose();
-- 		self.bestGiftList = nil;
-- 	end
-- 	self:superCall("dispose");
-- end