-- 新英雄配套活动 英雄预告提示window
Lua_NewHeroGordonPreviewTipWindow = class("Lua_NewHeroGordonPreviewTipWindow", Lua_Window);

function Lua_NewHeroGordonPreviewTipWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0.1;

	self.windowName = "Lua_NewHeroGordonPreviewTipWindow";
	self.skinName = "NewHeroGordonPreviewTipWindow_skin";
end

function Lua_NewHeroGordonPreviewTipWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 380, 450, Lua_AxisDefine.Vertical)
	self.dragContainer:setLocation(0, 130, 0)
	self.dragContainer:addSubContainer(Lua_NewHeroGordonPreviewTipItem, DataCenter.newHeroActData.notice_content, true)
	self.dragContainer.canDrag = not self.dragContainer.isTheEnd;
end

function Lua_NewHeroGordonPreviewTipWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end

























Lua_NewHeroGordonPreviewTipItem = class("Lua_NewHeroGordonPreviewTipItem", Lua_DragContainerItem);

function Lua_NewHeroGordonPreviewTipItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_NewHeroGordonPreviewTipItem:buildShowItem()
    self:superCall("buildShowItem");

    self.tipTxt = UICreate.createLabel(self.content, nil, 0, 0, 380, 0, 22);
    self.tipTxt.verticalOverflowValue = 1;
end

function Lua_NewHeroGordonPreviewTipItem:dispose()
	if self.tipTxt ~= nil then
		self.tipTxt:dispose();
		self.tipTxt = nil;
	end
    self:superCall("dispose");
end

function Lua_NewHeroGordonPreviewTipItem:setData(list)
	local str;
	local info;
	local startDate;
	local endDate;
	for i = 1, #list do
		info = list[i];
		if str == nil then
			str = "";
		else
			str = spliceStr(str, "\n\n");
		end

		if info.title ~= nil then
			str = spliceStr(str, Lua_ColorDefine.getColorStr("fdeeb2", info.title));
		end
		if info.start_time ~= nil and info.end_time then
			startDate = Lua_TimeTransform.transSeconds27(info.start_time, false);
			endDate = Lua_TimeTransform.transSeconds27(info.end_time, false);
			str = spliceStr(str, "\n", LanUtil.formateStr(761302, startDate, endDate));
		end
		if info.content ~= nil then
			str = spliceStr(str, "\n", LanUtil.formateStr(761303, info.content));
		end
	end
    self.tipTxt.text = str;
    self.tipTxt:resetSize();
end

function Lua_NewHeroGordonPreviewTipItem:getWidth()
    return self.tipTxt.width;
end

function Lua_NewHeroGordonPreviewTipItem:getHeight()
    return self.tipTxt.height;
end