-- 新英雄配套活动 英雄预告window
Lua_NewHeroGordonPreviewWindow = class("Lua_NewHeroGordonPreviewWindow", Lua_Window);

function Lua_NewHeroGordonPreviewWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_NewHeroGordonPreviewWindow";
	self.skinName = "NewHeroGordonPreviewWindow_skin";
end

function Lua_NewHeroGordonPreviewWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("UPDATE_GORDONPREVOEW_INFO", self, self.onShowUI);

	local arr = DataCenter.backstageActData:getActIdxArrByType(20012)
	if arr then
		self.actVo = DataCenter.backstageActData:getActVoByIdx(arr[1]);
	end
	if self.actVo ~= nil then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx);
	end
	
	self.viewBtn:addClickFuntion(self, self.onViewBtnClick);
	self.fightBtn:addClickFuntion(self, self.onFightBtnClick);
	self.previewBtn:addClickFuntion(self, self.onPreviewBtnClick);
end

function Lua_NewHeroGordonPreviewWindow:dispose()
	self:superCall("dispose");
end

function Lua_NewHeroGordonPreviewWindow:onShowUI()
	local newHeroActData = DataCenter.newHeroActData;

	self.winBg:addLoadCompleteFun(self, self.onImgLoadComplete);
	self.winBg:setEnable(false);
	self.winBg:SetDimensions(0, 0);
	self.winBg:setUrl(nil);
	self.winBg:setUrl(newHeroActData.bg_path);

	self.titleBg:setAltas(newHeroActData.name_atlas, newHeroActData.name_sprite);
	self.titleBg:resetSize();

	local heroVo = Lua_HeroVo.new(newHeroActData.hero_id);
	self.campIcon:setAltas("common_altas_2", "xui_common_attribute_"..(heroVo.campType + 6));
	self.campTxt.text = heroVo.posit_des;

	self.time = self.actVo.residueTime + 1;
	self:onTimer();
end

function Lua_NewHeroGordonPreviewWindow:onImgLoadComplete()
	self.winBg:setEnable(true);
end

function Lua_NewHeroGordonPreviewWindow:onTimer()
	self.time = self.time - 1;
	if self.time < 0 then
		self.time = 0;
	end

	if self.time > 0 then
		if not self.isTimer then
			self.isTimer = true;
			self:addTimer("onTimer", 1, self, self.onTimer)
		end
		self.timeTxt.text = LanUtil.formateStr(761300, Lua_TimeTransform.transSeconds1(self.time));
	else
		if self.isTimer then
			self.isTimer = false;
			self:removeTimer(self, self.onTimer);
		end
		self.timeTxt.text = LanUtil.getValue(761301);
	end
end

function Lua_NewHeroGordonPreviewWindow:onViewBtnClick()
	if DataCenter.newHeroActData.hero_id ~= nil then
		DataCenter.heroAtlasData:onOpenAtlasWindow(DataCenter.newHeroActData.hero_id, nil, nil, nil, nil, 1);
	end
end

function Lua_NewHeroGordonPreviewWindow:onFightBtnClick()
	if self.clcikTime == nil or getTime() - self.clcikTime >= 0.5 then
		self.clcikTime = getTime();
	else
		OperateAlert.showLangValue(761304);
		return;
	end

	if self.actVo ~= nil then
		Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sGordonPreviewFight(self.actVo.actIdx);
	end
end

function Lua_NewHeroGordonPreviewWindow:onPreviewBtnClick()
	Lua_WindowUtil.openWin("Lua_NewHeroGordonPreviewTipWindow", Lua_WinParam.ACTION_OPEN);
end