-- 英雄试炼增益信息窗口
Lua_HeroTrialBuffInfoWindow = class("Lua_HeroTrialBuffInfoWindow", Lua_Window);
function Lua_HeroTrialBuffInfoWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroTrialBuffInfoWindow";
	self.skinName = "HeroTrialBuffInfoWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = false;
	self.blackAlpha = 0.01;
end

function Lua_HeroTrialBuffInfoWindow:buildShowItem()
	self:superCall("buildShowItem");

	LuaUtil.setObjPos(self.content, -71, 400, 0);
	self:updateDesInfo();
end

function Lua_HeroTrialBuffInfoWindow:updateDesInfo()
	local buffInfo = DataCenter.newHeroActData.buffInfo;
	if buffInfo == nil then
		return;
	end

	self.skillNameTxt.text = LanUtil.formateStr("{1}LV{2}", buffInfo.buff_name, buffInfo.buff_lvl);

	local indent = Lua_SpaceDefine.SPACE_4 .. Lua_SpaceDefine.SPACE_4;
	local str, info, skillInfo, skillStr, topTextAddHeight, downTextAddHeight = nil, nil, nil, "", 0, 0;
	if buffInfo.hero_add and #buffInfo.hero_add > 0 then
		info = buffInfo.skill_info;
		skillInfo = Lua_SkillConfigData.getConfigData(info.key);
		if skillInfo ~= nil then
			skillStr = LanUtil.formateStr(750011, skillInfo.name, info.value, Mathf.Floor(info.other * 100));
			skillStr = "，" .. skillStr
		end
		str = self:getDesInfo(buffInfo.hero_add, 1);
		str = LanUtil.formateStr("{1}{2}{3}", indent, str, skillStr);
		str = LanUtil.formateStr("{1}\n{2}{3}", str, indent, self:getDesInfo(buffInfo.all_add, 2));
		self.heroAddTxt.text = str;
		self.heroAddTxt:resetSize();

		topTextAddHeight = self.heroAddTxt.height;
		self.nextLevelTxt:setLocation(-140, -90 - topTextAddHeight);
		self.allHeroAddTxt:setLocation(0, -107 - topTextAddHeight);
	end

	skillStr = "";
	if #buffInfo.next_hero_add > 0 then
		info = buffInfo.next_skill_info;
		skillInfo = Lua_SkillConfigData.getConfigData(info.key);
		if skillInfo ~= nil then
			skillStr = LanUtil.formateStr(750011, skillInfo.name, info.value, Mathf.Floor(info.other * 100))
		end
		str = self:getDesInfo(buffInfo.next_hero_add, 1);
		str = LanUtil.formateStr("{1}{2}{3}", indent, str, skillStr); 
		str = LanUtil.formateStr("{1}\n{2}{3}", str, indent, self:getDesInfo(buffInfo.next_all_add, 2));
		self.allHeroAddTxt.text = str;
		self.allHeroAddTxt:resetSize();

		downTextAddHeight = self.allHeroAddTxt.height;
		self.tipTxt:setLocation(-140, -141 - topTextAddHeight - downTextAddHeight);
		self.winBg:SetDimensions(430, Mathf.Abs(-141 - topTextAddHeight - downTextAddHeight) + 42);
		self.nextLevelTxt:setEnable(true);
	else
		self.tipTxt:setLocation(-140, -90 - topTextAddHeight - downTextAddHeight);
		self.winBg:SetDimensions(430, Mathf.Abs(-90 - topTextAddHeight - downTextAddHeight) + 42);
		self.nextLevelTxt:setEnable(false);
	end
end

function Lua_HeroTrialBuffInfoWindow:getDesInfo(attribute, upType)
	local str;
	if upType == 1 then
		local heroVo = Lua_HeroVo.new(DataCenter.newHeroActData.buffInfo.hero_id);
		str = LanUtil.formateStr(750012, heroVo.name);
	else
		str = LanUtil.getValue(750013);
	end

	local desArr = Array();
	for i = 1, #attribute do
		vo = Lua_AttributesVo.new(attribute[i].name);
		vo.value = attribute[i].value
		desArr:add(vo);
	end
	desArr:sort("sort", false);

	local desStr;
	local attrValue;
	local tab;
	local addValue;
	for i = 1, desArr:getSize() do
		desStr = desArr[i].isPercent == 1 and "+{1}%" or "+{1}";
		attrValue = desArr[i].isPercent == 1 and desArr[i].value * 100 or desArr[i].value;
		addValue = LanUtil.formateStr(desStr, attrValue);
		addValue = i < desArr:getSize() and addValue .. "，" or addValue;
		tab = {str, desArr[i].show_name, addValue};
		str = table.concat(tab, "");
	end
	return str;
end

function Lua_HeroTrialBuffInfoWindow:dispose()
	self:superCall("dispose");
end