-- 英雄试炼增益升级弹框
Lua_HeroTrialBuffUpWindow = class("Lua_HeroTrialBuffUpWindow", Lua_Window);
function Lua_HeroTrialBuffUpWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroTrialBuffUpWindow";
	self.skinName = "HeroTrialBuffUpWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showWinBg = true;
	self.isFullSizeWin = true;
	self.winBgPath = "/images/common/xui_common_bg_002.jpg";
end

function Lua_HeroTrialBuffUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.allUpDesContainer = Lua_DragContainer.new(self.content, 720, 160, Lua_AxisDefine.Vertical);
	self.allUpDesContainer:setCellPivot(1);
	self.allUpDesContainer:setLocation(0, 82, 0);
	self.allUpDesContainer:setSiblingIndex(11);

	self.upDesContainer = Lua_DragContainer.new(self.content, 720, 160, Lua_AxisDefine.Vertical);
	self.upDesContainer:setCellPivot(1);
	self.upDesContainer:setLocation(0, -163, 0);
	self.upDesContainer:setSiblingIndex(11);
    
    self.winBg.anchorValue = 1;
    self.winBg.pivotValue = 1;
    self.winBg:setLocation(0, 0);
	self.winBg:addClickFuntion(self, self.hide);
end

function Lua_HeroTrialBuffUpWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateDesInfo(param);
end

function Lua_HeroTrialBuffUpWindow:updateDesInfo(buffInfo)
	self.preLvTxt.text = LanUtil.formateStr(750014, buffInfo.buff_lvl);
	self.curLvTxt.text = LanUtil.formateStr(750014, buffInfo.buff_lvl + 1);
	local skillInfo = Lua_SkillConfigData.getConfigData(buffInfo.skill_info.key);
	if skillInfo then
		self.powerDesTxt.text = LanUtil.formateStr(750015, skillInfo.name, buffInfo.next_buff_lvl);
	end

	local desArr = self:getAttributeInfo(buffInfo.all_add, buffInfo.next_all_add);
	for i = 1, desArr:getSize() do
		self.allUpDesContainer:addSubContainer(Lua_HeroTrialBuffUpAttItem, desArr[i]);
	end
	self.allUpDesContainer:updateChildPos();
	self.allUpDesContainer.canDrag = not self.allUpDesContainer.isTheEnd;

	desArr = self:getAttributeInfo(buffInfo.hero_add, buffInfo.next_hero_add);
	for i = 1, desArr:getSize() do
		self.upDesContainer:addSubContainer(Lua_HeroTrialBuffUpAttItem, desArr[i]);
	end
	self.upDesContainer:updateChildPos();
	self.upDesContainer.canDrag = not self.upDesContainer.isTheEnd;
end

function Lua_HeroTrialBuffUpWindow:getAttributeInfo(preDic, curDic)
	local vo;
	local prePower;
	local curPower;
	local info;
	local desArr = Array();
	for i = 1, #preDic do
		vo = Lua_AttributesVo.new(preDic[i].name);
		if vo.isPercent == 1 then
			prePower = LanUtil.formateStr("{1}%", preDic[i].value * 100);
			curPower = LanUtil.formateStr("{1}%", curDic[i].value * 100);
		else
			prePower = preDic[i].value;
			curPower = curDic[i].value;
		end
		desArr:add({index = i, show_name = vo.show_name, sort = vo.sort, prePower = prePower, curPower = curPower});
	end
	desArr:sort("sort", false);
	return desArr;
end

function Lua_HeroTrialBuffUpWindow:dispose()
	if self.allUpDesContainer ~= nil then
		self.allUpDesContainer:dispose();
		self.allUpDesContainer = nil;
	end
	if self.upDesContainer ~= nil then
		self.upDesContainer:dispose();
		self.upDesContainer = nil;
	end
	self:superCall("dispose");
end










Lua_HeroTrialBuffUpAttItem = class("Lua_HeroTrialBuffUpAttItem", Lua_DragContainerItem);
function Lua_HeroTrialBuffUpAttItem:ctor(p)
	self:superCall("ctor", p, "HeroTrialBuffUpAttItem_skin");
end

function Lua_HeroTrialBuffUpAttItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroTrialBuffUpAttItem:setData(data)
	if data == nil then
		return;
	end

	self.bg:setEnable(data.index % 2 ~= 0);
	self.attNameTxt.text = LanUtil.formateStr("{1}:", data.show_name);
	self.attValueTxt.text = data.prePower;
	self.curAttValueTxt.text = data.curPower;
end

function Lua_HeroTrialBuffUpAttItem:getWidth()
	return self.bg.width;
end

function Lua_HeroTrialBuffUpAttItem:getHeight()
	return self.bg.height;
end

function Lua_HeroTrialBuffUpAttItem:dispose()
	self:superCall("dispose");
end