checkRequire("Lua_HeroTrialRankPanel");
Lua_HeroTrialRankWindow = class("Lua_HeroTrialRankWindow", Lua_Window);
function Lua_HeroTrialRankWindow:ctor()
	self:superCall("ctor");
    
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_HeroTrialRankWindow";
	self.skinName = "HeroTrialRankWindow_skin";
	self.isSingleShowWin = true;
	self.isFullSizeWin = true
end

function Lua_HeroTrialRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnInfo = Array();
	self.btnInfo:add({title = LanUtil.getValue(750009), textAtlas = "starRiver_atlas", textNormalSprite = "xui_xhsl_zgnbutton_1_n", textSelectedSprite = "xui_xhsl_zgnbutton_1_p", panel = Lua_HeroTrialRankPanel});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setRectPivot(5);
	self.btnList:setLocation(360, 59, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 108, 118, 0.01, 1);
	self.btnList:setButtonItem(108, 118);
	self.btnList:setClickCallBack(self, self.onButtonClick);
	self.btnList:setData(self.btnInfo);
	self.btnList:setSelected(1);

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content);
	self.roleInfoPanel:setRectAnchor(1);
    
    self.listBg:SetDimensions(720, 563 + self.adaptHeight);
	self.checkReward:addClickFuntion(self, self.onRankRewardBtnClick);
end

function Lua_HeroTrialRankWindow:onButtonClick(val)
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.curPanel = self.btnInfo[val].panel.new(self.content);
	self.curPanel:setRectAnchor(9);
	self.curPanel:onScreenResize(self.adaptHeight);
	self.nameText.text = self.btnInfo[val].title;
end

function Lua_HeroTrialRankWindow:onRankRewardBtnClick()
	Lua_WindowUtil.openWin("Lua_HeroTrialRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_HeroTrialRankWindow:onScreenResize()
	self:superCall("onScreenResize");
	if self.curPanel ~= nil then
		self.curPanel:onScreenResize(self.adaptHeight);
	end
	self.listBg:SetDimensions(720, 563 + self.adaptHeight);
end

function Lua_HeroTrialRankWindow:dispose()
	if self.btnInfo ~= nil then
		self.btnInfo:dispose();
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	if self.roleInfoPanel ~= nil then
		self.roleInfoPanel:dispose();
		self.roleInfoPanel = nil;
	end

	self:superCall("dispose");
end