-- 英雄试炼排行奖励
Lua_HeroTrialRewardWindow = class("Lua_HeroTrialRewardWindow", Lua_Window);
function Lua_HeroTrialRewardWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_HeroTrialRewardWindow";
	self.skinName = "HeroTrialRankRewardWindow_skin";
	self.showBlackMask = true;
	self.closeClickMask = true;
end

function Lua_HeroTrialRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 651, 695, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_HeroTrialRewardItem, 651, 120, 1);
	self.itemList:setLocation(0, -94, 0);
	self.itemList:setCellSpacing(0, 5);

	self:addLuaEvent("UPDATE_HEROTRIAL_REWARD_INFO", self, self.updateShowInfo);
	Lua_MsgUtil.callFunc("SEND_HEROTRIAL_RANKREWARD");
end

function Lua_HeroTrialRewardWindow:updateShowInfo()
	local rankReward = DataCenter.newHeroActData.rankReward;
	self.itemList:setArrayData(rankReward);
end

function Lua_HeroTrialRewardWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_HeroTrialRewardItem = class("Lua_HeroTrialRewardItem", Lua_ListCell);
function Lua_HeroTrialRewardItem:ctor(p)
	self:superCall("ctor", p, "HeroTrialRewardItem_skin");
end

function Lua_HeroTrialRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 320, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_HeroTrialRewardIconItem, 87, 87, 1);
	self.rewardList:setLocation(51, 0, 0);
	self.rewardList:setCellSpacing(5, 0);
	self:setSubList(self.rewardList);
end

function Lua_HeroTrialRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if data.rank_left == data.rank_right then
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_1"..(tonumber(data.rank_left) - 1));
		self.rankNumTxt:setEnable(false);
	else
		self.rankNumTxt:setEnable(true);
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_13");
		self.rankNumTxt.text = LanUtil.formateStr("{1}-{2}", data.rank_left, data.rank_right);
	end

	self.rewardList:setArrayData(data.reward);
	self.rewardList.canDrag = #data.reward > 3;
end

function Lua_HeroTrialRewardItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.rewardList.sub);
	for i = 1, self.rewardList.showList:getSize() do
		if self.rewardList.showList[i]:checkInBound(winPos.x, winPos.y) then
			return self.rewardList.showList[i];
		end
	end
	return nil;
end

function Lua_HeroTrialRewardItem:onMouseDownHandle()
	if #self.data.reward > 3 then
		return;
	end

	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:onMouseDownHandle();
	end
end

function Lua_HeroTrialRewardItem:onMouseUpHandle()
	if #self.data.reward > 3 then
		return;
	end

	if self.pressItem ~= nil then
		self.pressItem:onMouseUpHandle();
	end
end

function Lua_HeroTrialRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.pressItem ~= nil then
		self.pressItem:dispose();
		self.pressItem = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end










Lua_HeroTrialRewardIconItem = class("Lua_HeroTrialRewardIconItem", Lua_ListCell)
function Lua_HeroTrialRewardIconItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_HeroTrialRewardIconItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.7, 0.7);
end

function Lua_HeroTrialRewardIconItem:setData(data)
	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(data.key, data.value);
	else
		self.tvo:setData(data.key, data.value);
	end
	self.itemIcon:setData(self.tvo);
	self.itemIcon:setScale(0.7, 0.7);
end

function Lua_HeroTrialRewardIconItem:onPressClick()
	self.itemIcon:onItemClick();
end

function Lua_HeroTrialRewardIconItem:onMouseDownHandle()
	self.itemIcon:setScale(0.65, 0.65);
end

function Lua_HeroTrialRewardIconItem:onMouseUpHandle()
	self.itemIcon:setScale(0.7, 0.7);
end

function Lua_HeroTrialRewardIconItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end