--新英雄主题活动 招募Panel
Lua_NewHeroActRecruitPanel = class("Lua_NewHeroActRecruitPanel", Lua_DisplayObject);

function Lua_NewHeroActRecruitPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_NewHeroActRecruitPanel:buildPanel()
	self:superCall("buildPanel");
	self:addLuaEvent("UPDATE_NEWHERO_RECRUIT", self, self.updateData);
	self:addLuaEvent("UPDATE_NEWHERO_RECRUIT_REWARD", self, self.updateReward);
	self:addLuaEvent("UPDATE_NEWHERO_RECRUIT_GET_REWARD", self, self.onGetReward);
	-- self:addLuaEvent("NEWHERO_TRIAL_GET", self, self.setTrialIcon);

	self:addLuaEvent("MONEY_UPDATE", self, self.onItemUpdate);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.onItemUpdate);

	self:addLuaEvent("CLICK_SENIORRECRUIT_ONERECRUIT", self, self.onOneBtnClick);
	self:addLuaEvent("CLICK_SENIORRECRUIT_TENRECRUIT", self, self.onTenBtnClick);
end

function Lua_NewHeroActRecruitPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardArr = Array();
	self.itemBgArr = Array();

	self.rectW = 595;
	self.rectH = 100;
    self.subRectW = self.rectW;
    self.subRectH = self.rectH;
    self.subMinPos = -(self.subRectW - self.rectW) / 2;
    self.subMaxPox = -self.subMinPos;
    self.spaceW = 150;

	self.scrollContainer = UICreate.createScrollContainer(self.content, 61, 415, self.rectW, self.rectH);
	self.scrollContainer.horizontal = true;
	self.scrollContainer.vertical = false;
	self.scrollContainer.movementTypeValue = 1;
	self.scrollContainer.elasticity = 0.3;
	self.scrollContainer.inertia = true;
	self.scrollContainer:setScrollAnchor(0.5, 0.5, 0.5, 0.5);
	self.scrollContainer:setScrollPivot(4);
	self.scrollContainer:addRectMask2D();
	self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun);
	self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun);

	self.sub = self.scrollContainer.scrollContent;
	LuaUtil.setObjAnchor(self.scrollContainer.mainContent, 7);

	self.tipIcon:addClickFuntion(self, self.onTipIconClick);
	self.previewIcon:addClickFuntion(self, self.onPreviewClick);
	self.trialIcon:addClickFuntion(self, self.onTrialBtnClick);
	self.oneBtn:addClickFuntion(self, self.onOneBtnClick);
	self.tenBtn:addClickFuntion(self, self.onTenBtnClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);

	self:setTrialIcon();
end

function Lua_NewHeroActRecruitPanel:dispose()
	self.actVo = nil;
	self.sub = nil;

	if self.scrollContainer ~= nil then
		self.scrollContainer:dispose();
		self.scrollContainer = nil;
	end
	if self.rewardArr ~= nil then
		self.rewardArr:dispose();
		self.rewardArr = nil;
	end
	if self.itemBgArr ~= nil then
		self.itemBgArr:dispose();
		self.itemBgArr = nil;
	end
	if self.redPointList ~= nil then
		for k, v in pairs(self.redPointList) do
			v:dispose();
			v = nil;
		end
		self.redPointList = nil;
	end
	self:returnModel();
	self:superCall("dispose");
end

function Lua_NewHeroActRecruitPanel:setModelShow(param)
	if self.modelScenePanel == nil then
		if param ~= nil then
			self.modelScenePanel = param;
		else
			self.modelScenePanel = Lua_ModelScenePanel.new();
		end
		self.modelScenePanel:setParent(self.content);
		self.modelScenePanel:setRotBgDimensions(350, 600);
		self.modelScenePanel:setRotBgPos(0, 160);
	end

	if not self.modelScenePanel.bShowModel then
		local heroVo = Lua_HeroVo.new(DataCenter.newHeroActData.heroId);
		self.modelScenePanel:setModelDir(heroVo.uiModelDir);
		self.modelScenePanel:setModelScale(heroVo.uiModelScale);
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, heroVo.poseActEffs);
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, heroVo.showActEffs);
		self.modelScenePanel:showModelScene(DataCenter.newHeroActData.sceneId, heroVo.uiModelUrl, heroVo.uiModelAvatarName, heroVo.uiModelCamController);
		self.modelScenePanel:setModelAct(heroVo.uiShowAct, Lua_ThingDefine.UIWAIT, true);
	end
end

function Lua_NewHeroActRecruitPanel:returnModel()
	if self.modelScenePanel ~= nil then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
end

function Lua_NewHeroActRecruitPanel:setData(data)
	self.actVo = data;

	local startDate = Lua_TimeTransform.transSeconds27(data.start_tick, false);
	local endDate = Lua_TimeTransform.transSeconds27(data.end_tick, false);
	self.timeTxt.text = LanUtil.formateStr(761100, startDate, endDate);
	self:starTimer();
	self:updateData();

	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sRecruitReward(data.actIdx);
end

function Lua_NewHeroActRecruitPanel:starTimer()
	if not self.isTimer then
		self.isTimer = true;
		self:onTimer();
		self:addTimer("onTimer", 1, self, self.onTimer);
	end
end

function Lua_NewHeroActRecruitPanel:onTimer()
	local time = self.actVo.residueTime;
	if time < 0 then
		time = 0;
		self:endTimer();
	end
	self.remianTimeTxt.text = LanUtil.formateStr(761101, Lua_TimeTransform.transSeconds16(time, true, true, true));
end

function Lua_NewHeroActRecruitPanel:endTimer()
	if self.isTimer then
		self.isTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_NewHeroActRecruitPanel:updateData()
	local newHeroActData = DataCenter.newHeroActData;
	if newHeroActData.heroId == nil then return end

	self.nameBg:setAltas(newHeroActData.nameAtlas, newHeroActData.nameSprite);

	local heroVo = Lua_HeroConfigData.getConfig(newHeroActData.heroId);
	self.titleTxt.text = heroVo.title;
	self.nameTxt_2.text = heroVo.name;
	self.campIcon:setAltas("common_altas_2", "xui_common_attribute_"..40 + heroVo.camp);

	self.nameTxt_1.text = heroVo.name;
	self.nameTxt_1:resetSize();
	self.timeTxt:setLocation(60 - self.nameTxt_1.width, 614.3, 0)

	self.remainTxt.text = LanUtil.formateStr(761102, newHeroActData.mustTime);

	self.diamondLimitTxt.text = LanUtil.formateStr(761107, newHeroActData.diamondCostNum);
	self.diamondLimitTxt:setEnable(newHeroActData.isDiamondCost);

	local moneyVo = Lua_ResourcesData.getConfigDataById(Lua_ResourcesDefine.DIAMOND)
	local itemVo = Lua_ToolVo.new(newHeroActData.costItemId);
	self.itemNum = DataCenter.packData:getItemCountById(itemVo.id);

	self.moneyIcon:setAltas(itemVo.atlas, itemVo.sprite);
	self.moneyTxt.text = self.itemNum;

	self.oneCostIcon:setAltas(itemVo.atlas, itemVo.sprite);
	self.oneCostTxt.text = newHeroActData.oneDrawTime;

	if newHeroActData.isDiamondCost and newHeroActData.diamondCostNum >= newHeroActData.tenDrawTime then
		if self.itemNum >= newHeroActData.tenDrawTime then
			self.tenCostIcon:setAltas(itemVo.atlas, itemVo.sprite);
			self.tenCostTxt.text = newHeroActData.tenDrawTime;
		else
			self.tenCostIcon:setAltas(moneyVo.iconAtlas, moneyVo.iconSprite);
			self.tenCostTxt.text = newHeroActData.tenDrawCost;
		end
	else
		self.tenCostIcon:setAltas(itemVo.atlas, itemVo.sprite);
		self.tenCostTxt.text = newHeroActData.tenDrawTime;
	end

	local isFree = newHeroActData.isFreeDraw;
	self.freeTxt:setEnable(isFree);
	self.oneCostIcon:setEnable(not isFree);
	self.oneCostTxt:setEnable(not isFree);

	self:checkRedPoint(1, isFree);
	self:checkRedPoint(2, self.itemNum >= newHeroActData.tenDrawTime);
end

function Lua_NewHeroActRecruitPanel:updateReward()
	local list = DataCenter.newHeroActData.rewardList;
	local len = #list;
	local barWidth = (len - 1) * self.spaceW;
	
	if self.progressBar == nil then
		local width = barWidth + self.spaceW / 2;
		self.subRectW = width >= self.rectW and width or self.rectW;
        self.subMinPos = -(self.subRectW - self.rectW) / 2;
        self.subMaxPox = -self.subMinPos;
		self.scrollContainer:setScrollSize(self.subRectW, self.subRectH);
		-- self.scrollContainer:setScrollPosition(self.subMaxPox, 0, 0);

		self.progressBar = UICreate.createProgressBar(self.sub, "new_hero_atlas_2", "xui_xszh_widget_5", "new_hero_atlas_2", "xui_xszh_widget_7", 
			-self.subRectW / 2 + 40, 8, barWidth, 6);
		self.progressBar.pivot = Lua_WindowUtil.getPivot(3);
		self.progressBar:setBarOffset(-5, -5);
		self.progressBar:setBarPosOffset(0, -1);
	end

	local value = 0;
	local drawTime = DataCenter.newHeroActData.drawTime;
	local idx = 1;
	if drawTime > 0 then
		idx = len;
		for i = 1, len do
			if drawTime <= list[i].times then
				idx = i - 1;
				break;
			end
		end

		if idx == len then
			value = barWidth;
		else
			local time = idx > 0 and list[idx].times or 0;
			local nextTime = list[idx + 1].times;
			local offset = (drawTime - time) / (nextTime - time) * self.spaceW;
			value = (idx - 1) * self.spaceW + offset;
		end
	end
	self.progressBar:setMaxValue(barWidth);
	self.progressBar:setValue(value);

	local len2 = self.rewardArr:getSize();
	local count = len > len2 and len or len2;
	local item;
	local index = 0;
	local endIndx = 0;
	local posX;
	for i = 1, count do
		item = self.rewardArr[i];
		itemBg = self.itemBgArr[i];
		if item == nil then
			posX = -self.subRectW / 2 + (i - 1) * self.spaceW + 40;

			item = Lua_NewHeroActRecruitRewardItem.new(self.sub);
			item:setLocation(posX, 8, 0);
			self.rewardArr:add(item);

			itemBg = UICreate.createUIAtlasImage(self.sub, "new_hero_atlas_2", "xui_xszh_widget_14", posX, 8, 0, 0);
			itemBg.siblingIndex = 0;
			self.itemBgArr:add(itemBg);
		end

		if i <= len then
			item:setData(list[i], drawTime);

			if index == 0 and list[i].state == 1 then
				index = i;
			elseif list[i].state == 2 then
				endIndx = i;
			end
		end
		item:setEnable(i <= len);

		if i > idx then
			itemBg:setAltas("new_hero_atlas_2", "xui_xszh_widget_14");
		else
			itemBg:setAltas("new_hero_atlas_2", "xui_xszh_widget_17");
		end
		itemBg:setEnable(i <= len);
	end
	self.rewardTxt.text = drawTime;

	if not self.isFirstIn then
		self.isFirstIn = true;
		
		local moveIdx;
		if index == 0 then
			if endIndx ~= 0 then
				moveIdx = endIndx;
			else
				moveIdx = 1;
			end
		else
			moveIdx = index;
		end
		local posX = self.subRectW / 2 - (moveIdx - 1) * self.spaceW - 40;
		if posX < self.subMinPos then
			posX = self.subMinPos;
		elseif posX > self.subMaxPox then
			posX = self.subMaxPox;
		end
		self.scrollContainer:setScrollPosition(posX, 0, 0);
	end
end

function Lua_NewHeroActRecruitPanel:onMouseDownFun()
    self.startMouseX = CommonUtil.mousePositionX;
    self.startMouseY = CommonUtil.mousePositionY;
    self.startClickTime = getTime();
    self.checkItem = self:checkPressItem();
end

function Lua_NewHeroActRecruitPanel:onMouseUpFun()
    if self.checkItem == nil then return end
    local dx = CommonUtil.mousePositionX - self.startMouseX;
    local dy = CommonUtil.mousePositionY - self.startMouseY;
    if Mathf.Abs(dx) + Mathf.Abs(dy) < 4 then
    	if getTime() - self.startClickTime <= 0.3 then 
    		self.checkItem:onPressClick();
    	else
    		self.checkItem:onLongPressClick();
    	end
    end
end

function Lua_NewHeroActRecruitPanel:checkPressItem()
	local winPos = LuaUtil.getTouchPosInverseObj(self.sub);
	local item;
	for i = 1, self.rewardArr:getSize() do
		item = self.rewardArr[i];
		if item.isActive and item:checkInBound(winPos.x, winPos.y) then
			return item;
		end
	end
	return nil;
end

function Lua_NewHeroActRecruitPanel:checkRedPoint(type, val)
	if self.redPointList == nil then
		self.redPointList = {};
	end

	if val and self.redPointList[type] == nil then
		self.redPointList[type] = Lua_RedPointIcon.new(self.content);
		self.redPointList[type]:setRectAnchor(7);
		self.redPointList[type]:createRedPointEff();
		self.redPointList[type]:setLocation(-80 + (type - 1) * 360, 240, 0)
	end

	if self.redPointList[type] ~= nil then
		self.redPointList[type]:updateRedPointShow(val);
	end
end

function Lua_NewHeroActRecruitPanel:onTipIconClick(go)
	local tipsData = { des = LanUtil.getValue(761105), posX = 150, posY = -290 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_NewHeroActRecruitPanel:onPreviewClick(go)
	if self.preClickTime == nil or getTime() - self.preClickTime >= 3 then
		self.preClickTime = getTime();
		Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sRecruitPreview(self.actVo.actIdx);
	else
		OperateAlert.showLangValue(761106);
	end
end

function Lua_NewHeroActRecruitPanel:onOneBtnClick(go)
	if self.btnClickTime == nil or getTime() - self.btnClickTime >= 0.5 then
		self.btnClickTime = getTime();
	else
		OperateAlert.showLangValue(761106);
		return;
	end

	local newHeroActData = DataCenter.newHeroActData;
	if not DataCenter.heroData:isBagEnough(newHeroActData.oneDrawTime) then
		OperateAlert.showLangValue(761103);
		return;
	end
	newHeroActData.selectNum = newHeroActData.oneDrawTime;
	newHeroActData.diamondCost = newHeroActData.oneDrawCost;
	
	if newHeroActData.isFreeDraw or self.itemNum >= newHeroActData.oneDrawTime then
		self:onSureFun();
	else
		DataCenter.packUtil:openPathWindow(newHeroActData.costItemId, true);
	end
end

function Lua_NewHeroActRecruitPanel:onTenBtnClick(go)
	if self.btnClickTime == nil or getTime() - self.btnClickTime >= 0.5 then
		self.btnClickTime = getTime();
	else
		OperateAlert.showLangValue(761106);
		return;
	end

	local newHeroActData = DataCenter.newHeroActData;
	if not DataCenter.heroData:isBagEnough(newHeroActData.tenDrawTime) then
		OperateAlert.showLangValue(761103);
		return;
	end
	newHeroActData.selectNum = newHeroActData.tenDrawTime;
	newHeroActData.diamondCost = newHeroActData.tenDrawCost;

	if self.itemNum >= newHeroActData.tenDrawTime then
		self:onSureFun();
	else
		if newHeroActData.isDiamondCost and newHeroActData.diamondCostNum >= newHeroActData.tenDrawTime then
			if DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, newHeroActData.tenDrawCost, true, true) then
				self:onShowTip();
			end
		else
			DataCenter.packUtil:openPathWindow(newHeroActData.costItemId, true);
		end
	end
end

function Lua_NewHeroActRecruitPanel:onShowTip()
	local newHeroActData = DataCenter.newHeroActData;
	local moneyNum = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.DIAMOND);
	local getExp = newHeroActData.selectNum * newHeroActData.oneDrawExp;
	local str = spliceIconStrById(Lua_ResourcesDefine.DIAMOND);
	local tipsData = {
		des = LanUtil.formateStr(761104, str, newHeroActData.diamondCost, moneyNum, getExp, newHeroActData.selectNum),
		btnType = 1, owner = self, sureFun = self.onSureFun
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_NewHeroActRecruitPanel:onSureFun()
	DataCenter.chatData:setDelayBroadcast(1025);
	DataCenter.chatData:setDelayBroadcast(1060);
	DataCenter.chatData:setDelayBroadcast(1061);
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sRecruitHero(self.actVo.actIdx, DataCenter.newHeroActData.selectNum);
end

function Lua_NewHeroActRecruitPanel:onAddBtnClick()
	DataCenter.packUtil:openPathWindow(DataCenter.newHeroActData.costItemId, false);
end

function Lua_NewHeroActRecruitPanel:onTrialBtnClick()
	local actArr = DataCenter.backstageActData:getActIdxArrByType(20008);
	if actArr ~= nil and actArr[1] ~= nil then
		Lua_WindowUtil.openWin("Lua_NewHeroActTryWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_NewHeroActRecruitPanel:onGetReward(time)
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sGetRecruitReward(self.actVo.actIdx, time);
end

function Lua_NewHeroActRecruitPanel:onItemUpdate(dic)
	if dic[DataCenter.newHeroActData.costItemId] == nil then
		return;
	end
	self:updateData();
end

function Lua_NewHeroActRecruitPanel:setTrialIcon()
	-- local state = DataCenter.newHeroActData.trialstate == 0;
	-- self.trialIcon:setEnable(state);
	-- self:updateTrialRedPoint(state);
	self.trialIcon:setEnable(false);
end

function Lua_NewHeroActRecruitPanel:updateTrialRedPoint(val)
	if val then
		if self.trialRedPoint == nil then
			self.trialRedPoint = Lua_RedPointIcon.new(self.content);
			self.trialRedPoint:setRectAnchor(1);
			self.trialRedPoint:setLocation(305, -600);
			self.trialRedPoint:createRedPointEff();
		end
		self.trialRedPoint:updateRedPointShow(true);
	else
		if self.trialRedPoint ~= nil then
			self.trialRedPoint:updateRedPointShow(false);
		end
	end
end






















Lua_NewHeroActRecruitRewardItem = class("Lua_NewHeroActRecruitRewardItem", Lua_DisplayObject);

function Lua_NewHeroActRecruitRewardItem:ctor(p)
	self:superCall("ctor", p, "NewHeroActRecruitRewardItem_skin");
end

function Lua_NewHeroActRecruitRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(1);
	self.itemIcon:setScale(0.5, 0.5);
end

function Lua_NewHeroActRecruitRewardItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_NewHeroActRecruitRewardItem:setData(data, curTime)
	self.data = data;

	local itemInfo = data.rewards[1];
	local itemVo = Lua_ToolVo.createToolVo(itemInfo.id, itemInfo.amount);
	self.itemIcon:setData(itemVo);
	self.itemIcon:setDrawMask(data.state == 2);
	self.valueTxt.text = data.times;
	self.showBg:setEnable(data.state == 1);
	self:showRedDot(data.state == 1);

	-- if data.state < 1 then
	-- 	self.itemBg:setAltas("new_hero_atlas_2", "xui_xszh_widget_14");
	-- else
	-- 	self.itemBg:setAltas("new_hero_atlas_2", "xui_xszh_widget_17");
	-- end
end

function Lua_NewHeroActRecruitRewardItem:checkInBound(posX, posY)
	local width = self.itemIcon.itemW / 2 * self.itemIcon.scaleX;
	local height = self.itemIcon.itemH / 2 * self.itemIcon.scaleY;
	local minX = self.centerPosX - width;
	local maxX = self.centerPosX + width;
	local minY = self.centerPosY - height;
	local maxY = self.centerPosY + height;
	if posX >= minX and posX <= maxX and posY >= minY and posY <= maxY then
		return true;
	end
	return false
end

function Lua_NewHeroActRecruitRewardItem:onPressClick()
	if self.data.state == 1 then
		Lua_MsgUtil.callFunc("UPDATE_NEWHERO_RECRUIT_GET_REWARD", self.data.times);
	else
		self:onLongPressClick();
	end
end

function Lua_NewHeroActRecruitRewardItem:onLongPressClick()
	self.itemIcon:onItemClick();
end


function Lua_NewHeroActRecruitRewardItem:showRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setScale(0.8, 0.8);
			self.redPoint:setLocation(22, 22, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end