--新英雄主题活动 招募展示Window
Lua_NewHeroActRecruitShowWindow = class("Lua_NewHeroActRecruitShowWindow", Lua_Window);

function Lua_NewHeroActRecruitShowWindow:ctor()
    self:superCall("ctor");

    self.showBlackMask = true;
    -- self.isClickClose = true;

    self.windowName = "Lua_NewHeroActRecruitShowWindow";
    -- self.skinName = "NewHeroActRecruitShowWindow_skin";
end

function Lua_NewHeroActRecruitShowWindow:buildShowItem()
    self:superCall("buildShowItem");

    self:addLuaEvent("SINGLE_HERO_WIN_HIDE", self, self.openShowWindow);
    self:addLuaEvent("CLOSE_NEWHERO_RECRUIT_SHOW", self, self.hide);
end

function Lua_NewHeroActRecruitShowWindow:showWin(param)
    self:superCall("showWin", param);

    DataCenter.recruitData.selectType = Lua_RecruitData.NEWHERO;
    self.isOpenWindow = true;

    if Lua_WindowUtil.isWindowShowing("Lua_RecruitShowHeroWindow") then
        Lua_WindowUtil.openWin("Lua_RecruitShowHeroWindow", Lua_WinParam.ACTION_CLOSE);
    end
    self:onPlayAni();
end

function Lua_NewHeroActRecruitShowWindow:dispose()
    Lua_CommonUtil.removeTimer(self.showHeroModel);
    self:removeShowModel();
    -- DataCenter.heroAssemblyData:showAutoDecomposeReward(); --展示自动流放奖励
    self:superCall("dispose");
end

function Lua_NewHeroActRecruitShowWindow:onPlayAni()
    if self.showEffect == nil then
        self.showEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_xianshi_juanzhou", "ui_xianshi_juanzhou", 0, 0);
    else
        self.showEffect:setEnable(true);
    end
    Lua_CommonUtil.delayCall(3, self, self.showHeroModel);
end

function Lua_NewHeroActRecruitShowWindow:showHeroModel()
    Lua_CommonUtil.removeTimer(self.showHeroModel);
    self.showEffect:setEnable(false);

    if self.showData.maxQuality >= 4 then
        local arr = self.showData.heroIdArr;
        local herdId = arr:shift();
        local heroVo = Lua_HeroVo.new(herdId);
        local param = { heroVo = heroVo, heroArr = arr };
        DataCenter.preLoadData:preShowModelScene("Lua_RecruitShowSingleHeroWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, param, heroVo);
    else
        self:openShowWindow()
    end
end

function Lua_NewHeroActRecruitShowWindow:onShowModel(param, modelScenePanel, isSuccess)
    if isSuccess then
        param.modelScenePanel = modelScenePanel;
        Lua_WindowUtil.openWin("Lua_RecruitShowSingleHeroWindow", Lua_WinParam.ACTION_OPEN, param);
    end
    self:removeShowModel();
end

function Lua_NewHeroActRecruitShowWindow:removeShowModel()
    DataCenter.preLoadData:removeBySign("Lua_RecruitShowSingleHeroWindow", self, self.onShowModel);
end

function Lua_NewHeroActRecruitShowWindow:openShowWindow()
    if self.showData ~= nil and self.isOpenWindow then
        self.isOpenWindow = false;
        Lua_WindowUtil.openWin("Lua_RecruitShowHeroWindow", Lua_WinParam.ACTION_OPEN, self.showData);
    end
end
