-- --新英雄主题活动 剧情关卡Panel
Lua_NewHeroActStoryPanel = class("Lua_NewHeroActStoryPanel", Lua_DisplayObject);
function Lua_NewHeroActStoryPanel:ctor(p, skinName)
    self:superCall("ctor", p, skinName);
end

function Lua_NewHeroActStoryPanel:buildPanel()
	self:superCall("buildPanel");
end

function Lua_NewHeroActStoryPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.englishTitleTxt:setLangValue(763018);
	self.chineseTitleTxt:setLangValue(763019);
	self.listHeight = 454;
	local curHeight = self.listHeight + self.adaptHeight < 131 and 131 or self.listHeight + self.adaptHeight;
	self.dragList = Lua_DragList.new(self.content, 720, curHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_NewHeroStoryChapterItem, 720, 131, 1);
    self.dragList:setLocation(0, 297, 0);
    self.dragList:setRectAnchor(7);
    self.dragList:setRectPivot(7);

    self.rewardSp.clickScale = false;
    self.recordSp.clickScale = false;
    self.rewardSp:addMousDownFuntion(self, self.onMouseDownRewardSp);
	self.rewardSp:addMouseUpFuntion(self, self.onMouseUpRewardSp);
	self.recordSp:addMousDownFuntion(self, self.onMouseDownRecordSp);
	self.recordSp:addMouseUpFuntion(self, self.onMouseUpRecordSp);

	self:addLuaEvent("UPDATE_STORYLEVEL_LIST", self, self.updatePanel);
	self:addLuaEvent("FIGHTPLAY_ENTER", self, self.updatePanel);
    self:addLuaEvent("FIGHTPLAY_COMPLETE", self, self.updatePanel);
end

function Lua_NewHeroActStoryPanel:onScreenResize(adaptHeight)
	if adaptHeight == self.adaptHeight then
		return;
	end
	
	self:superCall("onScreenResize", adaptHeight);

	self:updateListHeight();
end

function Lua_NewHeroActStoryPanel:onMouseDownRewardSp()
	LuaUtil.setObjScale(self.rewardObj, 1.1, 1.1, 1.1);
end

function Lua_NewHeroActStoryPanel:onMouseUpRewardSp()	
	LuaUtil.setObjScale(self.rewardObj, 1, 1, 1);

	local actId = DataCenter.newHeroActData.storyLevelActId;
	local actVo = DataCenter.backstageActData:getActVoByIdx(actId);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end

	Lua_WindowUtil.openWin("Lua_NewHeroStoryRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_NewHeroActStoryPanel:onMouseDownRecordSp()
	LuaUtil.setObjScale(self.recordObj, 1.1, 1.1, 1.1);
end

function Lua_NewHeroActStoryPanel:onMouseUpRecordSp()
	LuaUtil.setObjScale(self.recordObj, 1, 1, 1);

	local actId = DataCenter.newHeroActData.storyLevelActId;
	local actVo = DataCenter.backstageActData:getActVoByIdx(actId);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end
	
	Lua_WindowUtil.openWin("Lua_NewHeroStoryRecordWindow", Lua_WinParam.ACTION_OPEN, 1);
end

function Lua_NewHeroActStoryPanel:dispose()
	self:endTimer();
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_NewHeroActStoryPanel:setData(data)
	self.data = data;
	DataCenter.newHeroActData.storyLevelActId = self.data.actIdx;
	self.redPointIcon = Lua_RedPointIcon.new(self.rewardObj, self.data.redPointId);
	self.redPointIcon:setLocation(27, 23, 0);
	self:startTimer();
end

function Lua_NewHeroActStoryPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:updateResidueTime();
		self:addTimer("Lua_NewHeroActStoryPanel", 1, self, self.updateResidueTime);
	end
end

function Lua_NewHeroActStoryPanel:updateResidueTime()
	local time = self.data.residueTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.timeTxt.text = LanUtil.formateStr(763000, Lua_TimeTransform.transSeconds16(time, true, true, true));
end

function Lua_NewHeroActStoryPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateResidueTime);
	end
end

function Lua_NewHeroActStoryPanel:updatePanel()
	if DataCenter.newHeroActData.storyLevelFighting ~= true then
		DataCenter.newHeroActData.storyCurFightLevelId = nil;
	end

	self.totalLevelIds = DataCenter.newHeroActData:getEnableFightLevelIds();
	self.count = self.totalLevelIds ~= nil and #self.totalLevelIds or 0;
	self.dragList:setArrayData(self.totalLevelIds);
	self:updateListHeight();
	if self.count > 3 then
		self.dragList:moveToIndex(1, true, false);
	end
end

function Lua_NewHeroActStoryPanel:updateListHeight()
	local height = self.count * 131;
	local listHeight = 454 + self.adaptHeight;
	local canDrag = height > listHeight;
	self.listHeight = canDrag and listHeight or height;
	self.dragList.canDrag = canDrag;
	self.dragList:setContentRect(720, self.listHeight);
	self.listBg:SetDimensions(720, self.listHeight + 30);

	if self.count <= 3 then
		local index = self:getShowItemIndex(self.totalLevelIds);
		self.dragList:moveToIndex(index, true);
	end
end

function Lua_NewHeroActStoryPanel:getShowItemIndex(totalLevelIds)
	if totalLevelIds == nil or #totalLevelIds > 3 then
		return
	end

	local index;
	local levelData;
	local count = #totalLevelIds;
	for i = count, 1, -1 do
		levelData = DataCenter.newHeroActData:getChapterLevelInfoByLevelId(totalLevelIds[i]);
		if levelData ~= nil and levelData.state ~= 3 then
			index = i;
			break;
		end
	end
	
	return index or 1;
end






--------------------------------

Lua_NewHeroStoryChapterItem = class("Lua_NewHeroStoryChapterItem", Lua_ListCell);
function Lua_NewHeroStoryChapterItem:ctor(p)
	self:superCall("ctor", p, "NewHeroStoryChapterItem_skin");
end

function Lua_NewHeroStoryChapterItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_NewHeroStoryChapterItem:dispose()
	if self.fightEff ~= nil then
		self.fightEff:dispose();
		self.fightEff = nil;
	end
	self:superCall("dispose");
end

function Lua_NewHeroStoryChapterItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	local levelInfo = DataCenter.newHeroActData:getChapterLevelInfoByLevelId(self.data);
	if levelInfo == nil then
		return;
	end

	local name = levelInfo.title;
	local needFight = levelInfo.needFight;
	if needFight then
		local spriteStr = spliceIconStr("new_hero_atlas_3", "xui_jqgq_label_1", 22, 22);
		name =  name.. Lua_SpaceDefine.SPACE_3 ..spriteStr;
	end
	self.levelNameTxt.text = name;
	self.chapterId = levelInfo.chapterId;
	self.levelState = levelInfo.state;

	local str = self.levelState == 0 and LanUtil.getValue(763001) or nil;
	self.lockTxt.text = str;
	self.lockMaskSp:setEnable(str ~= nil);
	self.passSp:setEnable(self.levelState == 3);
	self:checkIsFighting();


	local unlockTimeStr;
	local residueTime, openTime = DataCenter.newHeroActData:checkUnlockChapter(self.chapterId);
	if residueTime ~= nil and residueTime <= 0 then
		unlockTimeStr = nil;
		self.levelNameTxt:setLocation(-75, 4);
	else
		unlockTimeStr = os.date("%Y"..LanUtil.getValue(46).."%m"..LanUtil.getValue(47).."%d"..LanUtil.getValue(48) .."%H", openTime);
		unlockTimeStr = LanUtil.formateStr(763016, unlockTimeStr);
		self.levelNameTxt:setLocation(-75, 20);
	end
	self.unlockTimeTxt.text = unlockTimeStr;
end

function Lua_NewHeroStoryChapterItem:onPressClick()
	local actId = DataCenter.newHeroActData.storyLevelActId;
	local actVo = DataCenter.backstageActData:getActVoByIdx(actId);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end

	if DataCenter.newHeroActData.storyLevelFighting then
		if DataCenter.newHeroActData.storyCurFightLevelId == self.data then
			local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_STORY);
			if recordId ~= nil and recordId > 0 then
				DataCenter.fightData:showFightToStageByRid(recordId);
			end
		else
			OperateAlert.showLangValue(763015);
		end
		return;
	end

	if self.levelState == 0 then
		local residueTime = DataCenter.newHeroActData:checkUnlockChapter(self.chapterId);
		if residueTime ~= nil and residueTime <= 0 then
			OperateAlert.showLangValue(763002);
		else
			self:showTimeStr(residueTime);
		end
	else
		Lua_WindowUtil.openWin("Lua_NewHeroStoryPreviewWindow", Lua_WinParam.ACTION_OPEN, self.data);
	end

end

function Lua_NewHeroStoryChapterItem:showTimeStr(time)
	if time == nil then
		return;
	end

	local day = Mathf.Floor(time / 86400);
	local hour = Mathf.Floor(time % 86400 / 3600);
    local minute = Mathf.Floor( time % 3600 / 60);
    local second = Mathf.Floor( time % 60);
    local timeStr = "";
    if day > 0 then
    	timeStr = day .. LanUtil.getValue(23);
    end

    timeStr = timeStr..hour..LanUtil.getValue(24)..minute..LanUtil.getValue(25)..second..LanUtil.getValue(26);
    timeStr = LanUtil.formateStr(763020, timeStr);
    OperateAlert.show(timeStr);
end

function Lua_NewHeroStoryChapterItem:showEffect(value)
	if value then
		if self.fightEff == nil then
			self.fightEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", 12, 165);
			self.fightEff:setScale(0.5, 0.5, 0.5);
			self.fightEff:setLocation(302, -10);
		end
		self.fightEff:setEnable(false);
		self.fightEff:setEnable(true);
	else
		if self.fightEff then
			self.fightEff:setEnable(false);
		end
	end
end

function Lua_NewHeroStoryChapterItem:checkIsFighting()
    local bFight = DataCenter.newHeroActData.storyLevelFighting;  
    self:showEffect(bFight and self.data == DataCenter.newHeroActData.storyCurFightLevelId);
end