--剧情关卡关卡预览Window
Lua_NewHeroStoryPreviewWindow = class("Lua_NewHeroStoryPreviewWindow", Lua_Window);
function Lua_NewHeroStoryPreviewWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.windowName = "Lua_NewHeroStoryPreviewWindow";
	self.skinName = "NewHeroStoryPreviewWindow_skin";
end

function Lua_NewHeroStoryPreviewWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 500, 120, Lua_AxisDefine.Horizontal);
	self.dragList:setListCell(Lua_NewHeroStoryPreviewItem, 120, 120, 1);
	self.dragList:setLocation(52, -10, 0);

	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);
end

function Lua_NewHeroStoryPreviewWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_NewHeroStoryPreviewWindow:showWin(param)
	self:superCall("showWin", param);

	local levelData = DataCenter.newHeroActData:getChapterLevelInfoByLevelId(self.showData);
	local levelState = levelData.state;
	local rewards = levelData.rewards;
	self.titleTxt.text = levelData.title;
	self.dragList:setArrayData(rewards);
	self.needFight = levelData.needFight;
	self.bPassLevel = levelData.state == 3;
	self.storyGuideId = levelData.guideId;

	if self.bPassLevel then
		if self.needFight ~= true then
			self.sureBtn:setLangValue(763012);
		else
			self.sureBtn:setLangValue(763013);
		end
	else
		self.sureBtn:setLangValue(763013);
	end
	DataCenter.newHeroActData.storyCurLevelId = self.showData;
end

function Lua_NewHeroStoryPreviewWindow:onSureBtnClick()
	local actId = DataCenter.newHeroActData.storyLevelActId;
	local actVo = DataCenter.backstageActData:getActVoByIdx(actId);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end
	
	local bExist = DataCenter.guideUtil:getGuideCfg(self.storyGuideId);
	if not bExist then
		DataCenter.newHeroActData:displayWhenStroyEnd(); -- 不存在剧情直接战斗
		self:hide();
		return;
	end
	if not self.bPassLevel then
		local playEnd = DataCenter.newHeroActData:checkStoryEndByLevelId(self.showData);
		-- 播放剧情
		if not playEnd then
			DataCenter.guideData:play(self.storyGuideId);
			self:hide();
			return;
		else
			LogManager.showLog("该剧情id与其他关卡的剧情id有重复，关卡id："..self.showData.." 剧情id"..self.storyGuideId);
			DataCenter.newHeroActData:displayWhenStroyEnd();
			self:hide();
			return;
		end
	end

	if self.needFight then
		local act_index = DataCenter.newHeroActData.storyLevelActId;
		Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sStoryLevelFighting(act_index, self.showData, 2);
	else
		Lua_WindowUtil.openWin("Lua_GuideWindow", Lua_WinParam.ACTION_OPEN, {guideId = self.storyGuideId, guideStep = 0});
	end

	self:hide();
end





--------------------------------------------------





Lua_NewHeroStoryPreviewItem = class("Lua_NewHeroStoryPreviewItem", Lua_ListCell);
function Lua_NewHeroStoryPreviewItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_NewHeroStoryPreviewItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.9, 0.9, 0.9);
	self.itemIcon:setLocation(0, 0, 0);
end

function Lua_NewHeroStoryPreviewItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_NewHeroStoryPreviewItem:setData(data)
	if data == nil then
		return;
	end

	self.data = data;

	local tvo = Lua_ToolVo.createToolVo(self.data.costId, self.data.count);
	self.itemIcon:setData(tvo);

	local bPass = false;
	local levelData = DataCenter.newHeroActData:getChapterLevelInfoByLevelId(self.data.levelId);
	if levelData ~= nil then
		bPass = levelData.state == 3;
	end
	self.itemIcon:setDrawMask(bPass);
end

function Lua_NewHeroStoryPreviewItem:onPressClick()
	if self.data ~= nil then
		local tvo = Lua_ToolVo.createToolVo(self.data.costId, self.data.count);
		DataCenter.packUtil:showItemInfo(tvo);
	end
end