--新英雄主题活动 作战记录Panel
Lua_NewHeroStoryRecordPanel = class("Lua_NewHeroStoryRecordPanel", Lua_DisplayObject);
function Lua_NewHeroStoryRecordPanel:ctor(p)
	self:superCall("ctor", p, "NewHeroStoryRecordPanel_skin");
end

function Lua_NewHeroStoryRecordPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.tipTxt:setLangValue(763010);
	self.noneTipTxt:setLangValue(763017);
	self.noneObject:SetActive(false);
	self.recordListBg:SetDimensions(720, 976 + self.adaptHeight);

	self.dragList = Lua_DragList.new(self.content, 720, 967 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_NewHeroStoryRecordItem, 720, 339, 1);
	self.dragList:setLocation(0, -104, 0);
	self.dragList:setCellSpacing(0, 10);

	self:addLuaEvent("UPDATE_STORYLEVEL_RECORDLIST", self, self.updataPlane);
	local active_id = DataCenter.newHeroActData.storyLevelActId;
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sStoryLevelFightRecords(active_id);
end

function Lua_NewHeroStoryRecordPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.dragList:setContentRect(720, 967 + adaptHeight);
	self.recordListBg:SetDimensions(720, 976 + adaptHeight);
end

function Lua_NewHeroStoryRecordPanel:updataPlane(msg)
	local list = msg.record_list;
	self.dragList:setArrayData(list);
	self.noneObject:SetActive(#list <= 0);
end

function Lua_NewHeroStoryRecordPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewHeroStoryRecordItem = class("Lua_NewHeroStoryRecordItem", Lua_ListCell);
function Lua_NewHeroStoryRecordItem:ctor(p)
	self:superCall("ctor", p, "NewHeroStoryRecordItem_skin");
end

function Lua_NewHeroStoryRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.leftAvatar = Lua_AvatarItem.new(self.content);
	self.leftAvatar:setLocation(-315, 111, 0);
	self.leftAvatar:setScale(0.6, 0.6, 1);

	self.leftPanel = Lua_HeroGridViewPanel.new(self.content);
	self.leftPanel:setLocation(-199, -40, 0);
	self.leftPanel:setLayout(2, 0);
	self.leftPanel:setGridCell(73, 73);

	self.rightPanel = Lua_HeroGridViewPanel.new(self.content);
	self.rightPanel:setLocation(199, -40, 0);
	self.rightPanel:setLayout(2, 0);
	self.rightPanel:setGridCell(73, 73);

	self.dataSp:addClickFuntion(self, self.onDataSpClick);
end

function Lua_NewHeroStoryRecordItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.playerNameTxt.text = LanUtil.formateStr(763011, data.att_player.server_prev, data.att_player.name);
	self.bossNameTxt.text = data.title;
	
	local winSprite, failSprite = "xui_jys_label_1", "xui_jys_label_2";
	local winBg, failBg = "xui_jys_widget_6", "xui_jys_widget_5";
	if data.win_type == 1 then
		self.playerNameBg:setAltas("common_altas_4", winBg);
		self.bossNameBg:setAltas("common_altas_4", failBg);
		self.playerResultSp:setAltas("common_altas_4", winSprite);
		self.bossResultSp:setAltas("common_altas_4", failSprite);
	else
		self.playerNameBg:setAltas("common_altas_4", failBg);
		self.bossNameBg:setAltas("common_altas_4", winBg);
		self.playerResultSp:setAltas("common_altas_4", failSprite);
		self.bossResultSp:setAltas("common_altas_4", winSprite);
	end

	self.leftAvatar:setRoleId(data.att_player.id);
	self.leftAvatar:setRoleDressUp(data.att_player.dress_info, true);
	self.leftAvatar:setRoleLevel2(data.att_player.level);

	self.leftPanel:setDataByProto(data.att_lineup);
	self.rightPanel:setDataByProto(data.def_lineup);
end

function Lua_NewHeroStoryRecordItem:onDataSpClick()
	Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, self.data.hurt_collect_list);
end

function Lua_NewHeroStoryRecordItem:dispose()
	if self.leftAvatar ~= nil then
		self.leftAvatar:dispose();
		self.leftAvatar = nil;
	end
	if self.leftPanel ~= nil then
		self.leftPanel:dispose();
		self.leftPanel = nil;
	end
	if self.rightPanel ~= nil then
		self.rightPanel:dispose();
		self.rightPanel = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end