--新英雄主题活动 通关记录Window
checkRequire("Lua_NewHeroStoryRecordPanel");
Lua_NewHeroStoryRecordWindow = class("Lua_NewHeroStoryRecordWindow", Lua_Window);
function Lua_NewHeroStoryRecordWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_NewHeroStoryRecordWindow";
	self.winBgPath = "/images/common/ui_common_bg_001.jpg";
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.showBackBtn = true;
end

function Lua_NewHeroStoryRecordWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.downBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 0, 720, 121);
	self.downBg.pivot = Lua_WindowUtil.getPivot(7);
	self.downBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.downBg:setLocation(0, -5, 0);
	self.downBg.siblingIndex = self.backBtn.siblingIndex;

	self.btnInfo = Array();
	self.btnInfo:add({ textAtlas = "new_hero_atlas_3", textUnOpenSprite = "xui_jqgq_zgnbutton_2_d", textNormalSprite = "xui_jqgq_zgnbutton_2_n", textSelectedSprite = "xui_jqgq_zgnbutton_2_p", panel = Lua_NewHeroStoryRecordPanel }); -- 作战记录
	
	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setRectPivot(5)
	self.btnList:setLocation(360, 53.5, 0);
	self.btnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
	self.btnList:setButtonItem(120, 108);
	self.btnList:setData(self.btnInfo);
	self.btnList:setClickCallBack(self, self.onBtnClick);

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content)
    self.roleInfoPanel.content.name = "roleInfoPanel";
    self.roleInfoPanel:setRectAnchor(1)
end

function Lua_NewHeroStoryRecordWindow:showWin(param)
	self:superCall("showWin", param);

	local index;
	if type(param) == "table" then
		index = param.main_id;
	else
		index = param;
	end

	self.btnList:setSelected(index);
end

function Lua_NewHeroStoryRecordWindow:onBtnClick(index)
	if self.selectedIdx == index then
		return;
	end
	self.selectedIdx = index;

	local data = self.btnInfo[index];
	if data.panel ~= nil then
		if self.showPanel ~= nil then
			self.showPanel:dispose();
			self.showPanel = nil;
		end

		self.showPanel = data.panel.new(self.content);
		self.showPanel:setSiblingIndex(1);
		self.showPanel:setRectAnchor(9);
		if self.showPanel.updateData ~= nil then
			self.showPanel:updateData();
		end
	end
end

function Lua_NewHeroStoryRecordWindow:dispose()
	if self.roleInfoPanel ~= nil then
		self.roleInfoPanel:dispose();
		self.roleInfoPanel = nil;
	end
	if self.btnInfo ~= nil then
		self.btnInfo:dispose();
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.showPanel ~= nil then
		self.showPanel:dispose();
		self.showPanel = nil;
	end
	self:superCall("dispose");
end