--剧情关卡 章节奖励Window
Lua_NewHeroStoryRewardWindow = class("Lua_NewHeroStoryRewardWindow", Lua_Window);
function Lua_NewHeroStoryRewardWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;
	self.windowName = "Lua_NewHeroStoryRewardWindow";
	self.skinName = "NewHeroStoryRewardWindow_skin";
end

function Lua_NewHeroStoryRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 640, 729, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_NewHeroStoryChapterRewardItem, 640, 164, 1);
	self.dragList:setLocation(0, -68, 0);
	self.dragList:setCellSpacing(0, 10);

	self:addLuaEvent("UPDATE_STORYLEVEL_CHAPTERREWARD", self, self.updateInfo);

	local active_id = DataCenter.newHeroActData.storyLevelActId;
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sStoryLevelCharacterRewards(active_id);
end

function Lua_NewHeroStoryRewardWindow:updateInfo()
	local chapterIds = DataCenter.newHeroActData:getTotalChaptersIds();
	self.dragList:setArrayData(chapterIds);
end

function Lua_NewHeroStoryRewardWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewHeroStoryChapterRewardItem = class("Lua_NewHeroStoryChapterRewardItem", Lua_ListCell);
function Lua_NewHeroStoryChapterRewardItem:ctor(p)
	self:superCall("ctor", p, "NewHeroStoryRewardItem_skin");
end

function Lua_NewHeroStoryChapterRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 411, 88, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_NewHeroStoryRewardItem, 88, 88, 1);
	self.rewardList:setLocation(-88, -22, 0);
	self.rewardList:setCellSpacing(10, 0);
	self:setSubList(self.rewardList);

	self.receiveBtn:addClickFuntion(self, self.onReceiveBtnClick);
end

function Lua_NewHeroStoryChapterRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local chapterData = DataCenter.newHeroActData:getChapterDataById(self.data);
	if chapterData == nil then
		return;
	end

	local rewards = chapterData.rewards;
	self.rewardList:setArrayData(rewards);
	self.receivedState = chapterData.state;
	self.titleTxt.text = LanUtil.formateStr(763003, self.data);

	if self.receivedState == 0 then
		self.receiveBtn:setLangValue(763004);
		self.receiveBtn.fontSize = 32;
		self.receiveBtn:setStyle(16);
	elseif self.receivedState == 1 then
		self.receiveBtn:setLangValue(763005);
		self.receiveBtn.fontSize = 34;
		self.receiveBtn:setStyle(1);
	end

	self.receiveBtn:setEnable(self.receivedState ~= 2);
	self.receivedIcon:setEnable(self.receivedState == 2);

end

function Lua_NewHeroStoryChapterRewardItem:onReceiveBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	local actId = DataCenter.newHeroActData.storyLevelActId;
	local actVo = DataCenter.backstageActData:getActVoByIdx(actId);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end

	if self.receivedState == 0 then
		OperateAlert.showLangValue(763006);
	elseif self.receivedState == 1 then
		Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sStoryReward(actId, self.data);
	end
end

function Lua_NewHeroStoryChapterRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end














Lua_NewHeroStoryRewardItem = class("Lua_NewHeroStoryRewardItem", Lua_ListCell)
function Lua_NewHeroStoryRewardItem:buildShowItem()
	self:superCall("buildShowItem")

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.7, 0.7, 1)
end

function Lua_NewHeroStoryRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(self.data.costId, self.data.count);
	self.itemIcon:setData(tvo);
end

function Lua_NewHeroStoryRewardItem:onPressClick()
	if self.data ~= nil then
		local tvo = Lua_ToolVo.createToolVo(self.data.costId, self.data.count);
		DataCenter.packUtil:showItemInfo(tvo);
	end
end

function Lua_NewHeroStoryRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end

	self:superCall("dispose");
end