-- 升星专属(周期)(新英雄后台活动)
Lua_NewHeroUpStarPanel = class("Lua_NewHeroUpStarPanel", Lua_DisplayObject);
function Lua_NewHeroUpStarPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_NewHeroUpStarPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.heroItem = Lua_ItemIcon.new(self.heroBg.mainContent);
	self.heroItem:setScale(0.9, 0.9);
	-- self.heroItem:setCanClick(true);

	self.giftList = Lua_DragList.new(self.content, 682, 782 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList.tweenId = 2025;
	self.giftList:setListCell(Lua_NewHeroUpStarRewardItem, 682, 133, 1);
	self.giftList:setCellSpacing(0, 9);
	self.giftList:setLocation(0, -170, 0);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.gotoRecruitBtn:addClickFuntion(self, self.onGotoRecruitClick);

	self:addLuaEvent("DRAW_NERHERO_UPSTAR_REWARD", self, self.drawNewHeroUpStarReward);
	self:addLuaEvent("UPDATE_NEWHERO_UPSTAR_INFO", self, self.updateNewHeroUpStarInfo);
end

function Lua_NewHeroUpStarPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.giftList:setContentRect(682, 782 + adaptHeight);
end

function Lua_NewHeroUpStarPanel:setData(data)
	self.data = data;
	self:startTimer();
	self:updateLeftTime();
end

function Lua_NewHeroUpStarPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_NewHeroUpStarPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_NewHeroUpStarPanel:updateLeftTime()
	local time = self.data.residueTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr(730000, Lua_TimeTransform.transSeconds16(time, true, true, true));
end

function Lua_NewHeroUpStarPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_NewHeroUpStarPanel:updateNewHeroUpStarInfo()
	local vo = Lua_ToolVo.createToolVo(DataCenter.newHeroActData.heroId);
	self.heroItem:setData(vo);
	self.giftList:setArrayData(DataCenter.newHeroActData.upStarArr);
end

function Lua_NewHeroUpStarPanel:onRuleClick(go)
	local tipData = { des = self.data.help_des, posX = 160, posY = -260 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_NewHeroUpStarPanel:onGotoRecruitClick(go)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	DataCenter.funcPathUtil:gotoFunction(DataCenter.newHeroActData.eventId, true)
end

function Lua_NewHeroUpStarPanel:drawNewHeroUpStarReward(giftId)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sDrawUpStarReward(giftId, self.data.actIdx);
end

function Lua_NewHeroUpStarPanel:dispose()
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewHeroUpStarRewardItem = class("Lua_NewHeroUpStarRewardItem", Lua_ListCell);
function Lua_NewHeroUpStarRewardItem:ctor(p)
	self:superCall("ctor", p, "NewHeroUpStarRewardItem_skin");
end

function Lua_NewHeroUpStarRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.stageBar.typeValue = 3;
	self.stageBar.fillMethodValue = 1;
	self.stageBar.fillOrigin = 1;
	self.stageBar:setMaxValue(10);

	self.freeIcon = Lua_ItemIcon.new(self.content);
	self.freeIcon:setLocation(-153, 0, 0);
	self.freeIcon:setScale(0.65, 0.65);

	self.rewardList = Lua_DragList.new(self.content, 240, 81, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_RechargeRewardItem, 81, 81, 1);
	self.rewardList:setCellSpacing(10, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-50, -2, 0);
	self:setSubList(self.rewardList);

	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick);
end

function Lua_NewHeroUpStarRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemBg_1:setAltas("new_hero_atlas_1", data.isCond and "xui_sxzs_widget_07" or "xui_sxzs_widget_08");
	-- self.heroQualityTxt.text = DataCenter.heroUtil:getHeroQualityName(data.quality, data.qualityStar);
	self.heroQualityTxt.text = LanUtil.formateStr(730004, DataCenter.heroUtil:getHeroQualityName(data.quality), data.qualityStar);

	local upStar = DataCenter.newHeroActData.upStar;
	if data.stage == 1 then
		self.stageBar:SetDimensions(14, 80);
		self.stageBar:setLocation(-287, 9, 0);
		self.stageBar:setValue(upStar > data.condStar and 10 or 0);
	else
		self.stageBar:SetDimensions(14, data.isEndStage and 62 or 142);
		self.stageBar:setLocation(-287, 71, 0);
		if upStar > data.condStar then
			self.stageBar:setValue(10);
		elseif upStar == data.condStar then
			self.stageBar:setValue(5);
		else
			self.stageBar:setValue(0);
		end
	end
	-- print(upStar, data.condStar, "Lua_NewHeroUpStarPanel");

	self.freeIcon:setData(data.freeVo);
	self.freeIcon:setDrawMask(data.freeTimes <= 0);
	
	self.rewardList.canDrag = data.rechargeArr:getSize() >= 3;
	self.rewardList:setArrayData(data.rechargeArr);

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(data.rechargeId);
	self.rechargeBtn.label = LanUtil.formateStr(730001, tonumber(rechargeInfo.money));
	self.limitCountTxt.text = LanUtil.formateStr(730002, data.rechargeTimes, data.totalRechargeTimes);

	self.rechargeBtn:setStyle(data.isCond and 1 or 16);
	self.rechargeBtn:setEnable(data.rechargeTimes > 0);
	self.sellOutIcon:setEnable(data.rechargeTimes <= 0);
	self.limitCountTxt:setEnable(data.rechargeTimes > 0);
	self:showRedDot(data.isCond and data.freeTimes > 0);
end

function Lua_NewHeroUpStarRewardItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(-127, 25, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_NewHeroUpStarRewardItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.freeIcon:checkInBound(winPos.x, winPos.y) then
		self:onBtnClick();
	end
end

function Lua_NewHeroUpStarRewardItem:onBtnClick()
	if self._data.isCond and self._data.freeTimes > 0 then
		Lua_MsgUtil.callFunc("DRAW_NERHERO_UPSTAR_REWARD", self._data.freeGiftId);
	else
		DataCenter.packUtil:showItemInfo(self.freeIcon.data);
	end
end

function Lua_NewHeroUpStarRewardItem:onRechargeClick(go)
	if self._data.isCond and self._data.rechargeTimes > 0 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self._data.rechargeId);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		local vo = Lua_ToolVo.createToolVo(DataCenter.newHeroActData.heroId);
		-- local nameStr = DataCenter.heroUtil:getHeroQualityName(self._data.quality, self._data.qualityStar);
		local nameStr = LanUtil.formateStr(730004, DataCenter.heroUtil:getHeroQualityName(self._data.quality), self._data.qualityStar);
		OperateAlert.show(LanUtil.formateStr(730003, vo.name, nameStr));
	end
end

function Lua_NewHeroUpStarRewardItem:dispose()
	if self.freeIcon ~= nil then
		self.freeIcon:dispose();
		self.freeIcon = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RechargeRewardItem = class("Lua_RechargeRewardItem", Lua_ListCell);
function Lua_RechargeRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RechargeRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rechargeIcon = Lua_ItemIcon.new(self.content);
	self.rechargeIcon:setScale(0.65, 0.65);
end

function Lua_RechargeRewardItem:setData(data)
	if data == nil then
		return;
	end

	self.rechargeIcon:setData(data);
	self.rechargeIcon:setDrawMask(data.times <= 0);
end

function Lua_RechargeRewardItem:onPressClick(go)
	DataCenter.packUtil:showItemInfo(self.rechargeIcon.data);
end

function Lua_RechargeRewardItem:dispose()
	if self.rechargeIcon ~= nil then
		self.rechargeIcon:dispose();
		self.rechargeIcon = nil;
	end
	self:superCall("dispose");
end