-- 新英雄战令购买弹窗
Lua_NewHeroWarCoinBuyLvWindow = class("Lua_NewHeroWarCoinBuyLvWindow", Lua_Window);
function Lua_NewHeroWarCoinBuyLvWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_NewHeroWarCoinBuyLvWindow";
	self.skinName = "WarCoinBuyLvWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_NewHeroWarCoinBuyLvWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 548, 112, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_NewHeroWarCoinBuyLvRewardItem, 112, 112, 1);
	self.rewardList:setCellSpacing(11, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(0, 33, 0);

	self.txtInput.keyboardTypeValue = 12;
	self.txtInput.contentTypeValue = 2; -- 内容类型
	self.txtInput.characterValidationValue = 1; -- 字符验证，数字样式(1整数)
	self.txtInput.text = 1;
	self.txtInput:onEndEdit(self, self.updateCount);
	self.lessBtn:addClickFuntion(self, self.onLessBtnClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.sureBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_NewHeroWarCoinBuyLvWindow:showWin(param)
	self:superCall("showWin", param);

	local rewardList = DataCenter.newHeroActData.warCoinRewardList;
	self.upLv = DataCenter.newHeroActData.level + 1;
	self.maxLv = rewardList[#rewardList].level;

	self:updateShowInfo(self.upLv);
end

function Lua_NewHeroWarCoinBuyLvWindow:updateShowInfo(curLv)
	self.tipsTxt.text = LanUtil.formateStr(761015, curLv);
	self.txtInput.text = curLv - self.upLv + 1;

	if self.showLv == curLv then
		return;
	end
	self.showLv = curLv;
	
	-- 当前等级奖励没达到领取，算进去
	local curWarCoinLv = DataCenter.newHeroActData.level;
	local rewardList = DataCenter.newHeroActData.warCoinRewardList;
	local startIdx = curWarCoinLv + 1;
	local endIdx = startIdx + curLv - self.upLv;

	-- 要显示的道具
	local list;
	local tvoInfo;
	local sortWeight = 1;
	local itemDic = {};
	for i = startIdx, endIdx do
		list = rewardList[i].reward_item;
		for j = 1, #list do
			tvoInfo = itemDic[list[j].key];
			if tvoInfo == nil then
				tvoInfo = {id = list[j].key, count = list[j].value, sortWeight = sortWeight};
				sortWeight = sortWeight + 1;
				itemDic[list[j].key] = tvoInfo;
			else
				tvoInfo.count = tvoInfo.count + list[j].value;
			end
		end
 
		if DataCenter.newHeroActData.rechargeState == 1 then -- 高级奖励未解锁时不显示
			list = rewardList[i].stage_reward_item;
			for j = 1, #list do
				tvoInfo = itemDic[list[j].key];
				if tvoInfo == nil then
					tvoInfo = {id = list[j].key, count = list[j].value, sortWeight = sortWeight};
					sortWeight = sortWeight + 1;
					itemDic[list[j].key] = tvoInfo;
				else
					tvoInfo.count = tvoInfo.count + list[j].value;
				end
			end
		end
	end
	local arr = Array();
	for k,v in pairs(itemDic) do
		arr:add(v);
	end
	arr:sort("sortWeight", false);

	width = (arr:getSize() - 1) * 123 + 112;
	posX = width > 548 and -274 or -width / 2;
	self.rewardList.canDrag = arr:getSize() > 4;
	self.rewardList:setArrayData(arr);
	self.rewardList:setLocation(posX, 33, 0);

	local exp = DataCenter.newHeroActData.totalExe * (endIdx - startIdx + 1) - DataCenter.newHeroActData.curExe;
	local payInfo = DataCenter.newHeroActData.payInfo;
	local needCount = Mathf.Round(exp * payInfo.value); -- 四舍五入
	local haveCount = DataCenter.packData:getItemCountById(payInfo.key);
	local color = haveCount >= needCount and "8F5123" or "FF0000";
	self.moneyTxt.text = LanUtil.formateStr(761016, spliceIconStrById(payInfo.key), color, needCount);
	self.isCanBuy = haveCount >= needCount;
end

function Lua_NewHeroWarCoinBuyLvWindow:updateCount()
	if self.txtInput.text == "" then
		val = 1; -- self.txtInputNum
	else
		val = tonumber(self.txtInput.text) + self.upLv - 1;
	end
	if val > self.maxLv then
		val = self.maxLv;
	elseif val < self.upLv then
		val = self.upLv;
	end
	self:updateShowInfo(val);
end

function Lua_NewHeroWarCoinBuyLvWindow:onLessBtnClick(go)
	if self.showLv <= self.upLv then
		return;
	end
	self:updateShowInfo(self.showLv - 1);
end

function Lua_NewHeroWarCoinBuyLvWindow:onAddBtnClick(go)
	if self.showLv >= self.maxLv then
		OperateAlert.showLangValue(761018);
		return;
	end
	self:updateShowInfo(self.showLv + 1);
end

function Lua_NewHeroWarCoinBuyLvWindow:onBuyBtnClick()
	if self.isCanBuy then
		Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sUpgradeOfWarCoin(self.showData, self.showLv);
		self:hide();
	else
		DataCenter.packUtil:openPathWindow(DataCenter.newHeroActData.payInfo.key);
	end
end

function Lua_NewHeroWarCoinBuyLvWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_NewHeroWarCoinBuyLvRewardItem = class("Lua_NewHeroWarCoinBuyLvRewardItem", Lua_ListCell);
function Lua_NewHeroWarCoinBuyLvRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_NewHeroWarCoinBuyLvRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.9, 0.9);
end

function Lua_NewHeroWarCoinBuyLvRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.id, data.count);
	self.itemIcon:setData(tvo);
end

function Lua_NewHeroWarCoinBuyLvRewardItem:onPressClick()
	if self._data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.itemIcon.data);
end

function Lua_NewHeroWarCoinBuyLvRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end