-- 新英雄战令购买窗口
Lua_WarCoinRewardWindow = class("Lua_WarCoinRewardWindow", Lua_Window);
function Lua_WarCoinRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_WarCoinRewardWindow";
	self.skinName = "WarCoinRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_WarCoinRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt:setLangValue(761010);
	if DataCenter.newHeroActData.rechargeUpLv then
		self.tipsTxt.text = LanUtil.formateStr(761017, DataCenter.newHeroActData.rechargeUpLv);
	end

	local list = DataCenter.newHeroActData.rechargeReward;
	local posX = 458 > #list * 103 + 10 and (458 - #list * 103 + 10) / 2 or 0;
	self.topDragList = Lua_DragList.new(self.content, 458, 93, Lua_AxisDefine.Horizontal);
	self.topDragList.canDrag = #list > 4;
	self.topDragList:setListCell(Lua_WarCoinRewardItem, 93, 93, 1);
	self.topDragList:setCellSpacing(10, 0);
	self.topDragList:setLocation(posX, 97);
	self.topDragList:setArrayData(list);

	list = DataCenter.newHeroActData.rechargeAllReward;
	posX = 458 > #list * 103 + 10 and (458 - #list * 103 + 10) / 2 or 0;
	self.downDragList = Lua_DragList.new(self.content, 458, 93, Lua_AxisDefine.Horizontal);
	self.downDragList.canDrag = true;
	self.downDragList:setListCell(Lua_WarCoinRewardItem, 93, 93, 1);
	self.downDragList:setCellSpacing(10, 0);
	self.downDragList:setLocation(posX, -61);
	self.downDragList:setArrayData(list);
	
	self:updateInfo();

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
	self:addLuaEvent("UPDATE_WARCOIN_INFO", self, self.updateInfo);
end

function Lua_WarCoinRewardWindow:showWin(param)
	self.actVo = param;
end

function Lua_WarCoinRewardWindow:updateInfo()
	if DataCenter.newHeroActData.rechargeState == 0 then
		local rechargeId = DataCenter.newHeroActData.warCoinRechargeId;
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
		if rechargeInfo ~= nil then
			self.buyBtn.label = LanUtil.formateStr(761005, rechargeInfo.money);
		end
		self.buyBtn:setBtnEnable(true);
	else
		self.buyBtn:setLangValue(761006);
		self.buyBtn:setBtnEnable(false);
	end
end

function Lua_WarCoinRewardWindow:onBuyBtnClick()
	if DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	local rechargeId = DataCenter.newHeroActData.warCoinRechargeId;
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
	if rechargeInfo ~= nil then
		DataCenter.sdkInterface:PointOut(tonumber(rechargeInfo.gold), tonumber(rechargeInfo.money),
		tonumber(rechargeInfo.money_type), tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	end
end

function Lua_WarCoinRewardWindow:dispose()
	if self.topDragList ~= nil then
		self.topDragList:dispose();
		self.topDragList = nil;
	end
	if self.downDragList ~= nil then
		self.downDragList:dispose();
		self.downDragList = nil;
	end
	self.actVo = nil;
	self:superCall("dispose");
end










Lua_WarCoinRewardItem = class("Lua_WarCoinRewardItem", Lua_ItemIconCell)
function Lua_WarCoinRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_WarCoinRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.75, 0.75);
end

function Lua_WarCoinRewardItem:setData(data)
	if data == nil then
		return;
	end

	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(data.key, data.value);
	else
		self.tvo:setData(data.key, data.value);
	end
	self.itemIcon:setData(self.tvo);
end

function Lua_WarCoinRewardItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onItemClick();
	end
end

function Lua_WarCoinRewardItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon.isActive and self.itemIcon:checkInBound(winPos.x, winPos.y) then
		return self.itemIcon;
	end
	return nil;
end

function Lua_WarCoinRewardItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.7, 0.7);
	end
end

function Lua_WarCoinRewardItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.75, 0.75);
	end
end

function Lua_WarCoinRewardItem:dispose()
	self.tvo = nil;
	self:superCall("dispose");
end