-- 特惠礼包
Lua_SpecialDiscountGiftPanel = class("Lua_SpecialDiscountGiftPanel", Lua_DisplayObject);
function Lua_SpecialDiscountGiftPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_SpecialDiscountGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.packShopTxt:setLangValue(305000);
	self.packShopSp:addClickFuntion(self, self.clickPackShopSpFunc); -- 打包购买按钮

	self.gradeList = Lua_DragList.new(self.content, 672, 650 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.gradeList:setRectAnchor(1);
	self.gradeList:setRectPivot(1);
	self.gradeList:setLocation(0, -420);
	self.gradeList:setListCell(Lua_SpecialDiscountGiftItem, 672, 133, 1);
	self.gradeList:setCellSpacing(0, 15);
	self.gradeList.tweenId = 2014;
    
    self:showPrice();
	self:addLuaEvent("BUY_SPECIAL_REWARD", self, self.buySpecialDiscountGift);
	self:addLuaEvent("UPDATE_SPECIALDISCOUNTGIFT_INFO", self, self.updateServerInfo);
end

function Lua_SpecialDiscountGiftPanel:dispose()	
	if self.gradeList ~= nil then
		self.gradeList:dispose();
		self.gradeList = nil;
	end
	self:endTimer();
	self.data = nil;

	self:superCall("dispose");
end

function Lua_SpecialDiscountGiftPanel:setData(data)
	self.data = data;
end

function Lua_SpecialDiscountGiftPanel:updateResidueTime()
	self.actEndTime = DataCenter.specialDiscountGiftData.actEndTime;
	local residueTime = self.actEndTime - DataCenter.roleData.serverTime;
	if residueTime > 0 then
		self.timeTxt.text = LanUtil.formateStr(305006, Lua_TimeTransform.transSeconds1(residueTime));--"刷新时间："
		self:starTimer();
	else
		self:endTimer();
		self.timeTxt.text = nil;
	end
end

function Lua_SpecialDiscountGiftPanel:starTimer()
	if self.sTime == nil then
		self.sTime = true;
		self:addTimer("SPECIAL_DISCOUNT", 1, self, self.onTimer);
	end
end

function Lua_SpecialDiscountGiftPanel:onTimer()
	local residueTime = self.actEndTime - DataCenter.roleData.serverTime;
	if residueTime > 0 then
		self.timeTxt.text = LanUtil.formateStr(305006, Lua_TimeTransform.transSeconds1(residueTime));
	else
		self:endTimer();
		self.timeTxt.text = nil;
	end
end

function Lua_SpecialDiscountGiftPanel:endTimer()
	if self.sTime == true then
		self.sTime = false;
		self:removeTimer(self, self.onTimer);
	end
end

--点击打包购买按钮执行
function Lua_SpecialDiscountGiftPanel:clickPackShopSpFunc()
	local enablePackShop = DataCenter.specialDiscountGiftData.enablePackShop;
	local packRechargeId = DataCenter.specialDiscountGiftData.packRechargeId;
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	if enablePackShop then
		--购买接口
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(packRechargeId);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
					tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		OperateAlert.showLangValue(305007);
	end
end

--服务端数据更新后，更新档位等数据
function Lua_SpecialDiscountGiftPanel:updateServerInfo()
	self:updateDragList();
	self:showPrice();
	self:updateResidueTime();
end

--显示list内容
function Lua_SpecialDiscountGiftPanel:updateDragList()
	local specialDiscountGiftData = DataCenter.specialDiscountGiftData;
	local list = specialDiscountGiftData.gift_list;
	if list == nil then
		return;
	end
	table.sort(list, function(a, b)
		local aSort = a.buy_limit - a.buy_times <= 0 and 0 or 1;
		local bSort = b.buy_limit - b.buy_times <= 0 and 0 or 1;
		if aSort == bSort then
			return a.gift_id < b.gift_id;
		else
			return aSort > bSort;
		end
	end);
	self.gradeList:setArrayData(list);
end

--显示价格
function Lua_SpecialDiscountGiftPanel:showPrice()
	local specialDiscountGiftData = DataCenter.specialDiscountGiftData;
	if specialDiscountGiftData.packRechargeId == nil then
		return;
	end
	local packShopInfo = Lua_RechargeConfigData.getRechargeConfig(specialDiscountGiftData.packRechargeId);
	local ratio = Mathf.Floor(specialDiscountGiftData.totalMoney / packShopInfo.money) * 100;
	ratio = ratio - ratio % 10;
	self.originPriceTxt.text = LanUtil.formateStr(305001, ratio);

	self.curPriceTxt.text = LanUtil.formateStr(305003, packShopInfo.money); 
	if specialDiscountGiftData.enablePackShop then
		self.packShopSp:setGray(false);
		self.packShopTxt.colorStr = Lua_ColorDefine.transColorStr("8F5123");
	else
		self.packShopSp:setGray(true);
		self.packShopTxt.colorStr = Lua_ColorDefine.transColorStr("676161");
	end
end

function Lua_SpecialDiscountGiftPanel:buySpecialDiscountGift(data)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	if data.giftId ~= nil then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sBuySpecialDiscountGift(self.data.actIdx, data.giftId);
	else
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(data.rechargeId);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
					tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	end
end

function Lua_SpecialDiscountGiftPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.gradeList:setContentRect(672, 650 + adaptHeight);
end

































--------------------------------------------------
Lua_SpecialDiscountGiftItem = class("Lua_SpecialDiscountGiftItem", Lua_ListCell);
function Lua_SpecialDiscountGiftItem:ctor(p)
	self:superCall("ctor", p, "SpecialDiscountGiftItem_skin");
end

function Lua_SpecialDiscountGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 440, 100, Lua_AxisDefine.Horizontal);
	self.itemList:setLocation(-320, 3);
	self.itemList:setListCell(Lua_SpecialDiscountGiftItemCell, 100, 100, 1);
	self.itemList:setCellSpacing(10, 0);
	self.itemList:setRectPivot(3);
	self:setSubList(self.itemList);
	self.itemList.canDrag = false;
	
	self.shopBtn:addClickFuntion(self, self.onClickShopBtn);	
end

function Lua_SpecialDiscountGiftItem:setData(data)
	if data == nil then
		return;
	end

	self.data = data;
	local enableShopCount = self.data.buy_limit - self.data.buy_times; -- 可购买次数

	if self.data.original_value == 0 then
		self.shopBtn:setLangValue(305005);
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(285, 42);
		end
		self.redPoint:updateRedPointShow(enableShopCount > 0);
	else
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.data.recharge_id);
		self.shopBtn.label = LanUtil.formateStr(305002, rechargeInfo.money);
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end

	if enableShopCount <= 0 then 
		self.receivedIcon:setEnable(true); -- 当前限购小于等于0时显示
		self.residueShopTxt.text = nil;
	else
		self.residueShopTxt.text = LanUtil.formateStr(305004, enableShopCount); -- 限购文本
		self.receivedIcon:setEnable(false); -- 当前限购大于0时不显示
	end
	self.shopBtn:setEnable(enableShopCount > 0); -- 购买按钮是否显示

	self.itemList:moveToIndex(1, true, false);
	self.itemList:setArrayData(self.data.item_list);
	self.itemList.canDrag = #self.data.item_list > 4;
end

function Lua_SpecialDiscountGiftItem:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.pressItem ~= nil then
		self.pressItem:dispose();
		self.pressItem = nil;
	end

	self:superCall("dispose");
end

--打包购买按钮点击事件
function Lua_SpecialDiscountGiftItem:onClickShopBtn()
	if self.data == nil then
		return;
	end

	--购买接口 or 领取免费礼包
	if self.data.original_value == 0 then
		Lua_MsgUtil.callFunc("BUY_SPECIAL_REWARD", {giftId = self.data.gift_id});
	else
		Lua_MsgUtil.callFunc("BUY_SPECIAL_REWARD", {rechargeId = self.data.recharge_id});
	end
end

function Lua_SpecialDiscountGiftItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.itemList.sub);
	for i = 1, self.itemList.showList:getSize() do
		if self.itemList.showList[i]:checkInBound(winPos.x, winPos.y) then
			return self.itemList.showList[i];
		end
	end
	return nil;
end

function Lua_SpecialDiscountGiftItem:onMouseDownHandle()
	if #self.data.item_list > 4 then
		return;
	end
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:onMouseDownHandle();
	end
end

function Lua_SpecialDiscountGiftItem:onMouseUpHandle()
	if #self.data.item_list > 4 then
		return;
	end
	if self.pressItem ~= nil then
		self.pressItem:onMouseUpHandle();
	end
end
























--------------------------------------------------
Lua_SpecialDiscountGiftItemCell = class("Lua_SpecialDiscountGiftItemCell", Lua_ListCell);
function Lua_SpecialDiscountGiftItemCell:ctor(p)
	self:superCall("ctor", p);
end

function Lua_SpecialDiscountGiftItemCell:buildShowItem()
	self:superCall("buildShowItem");

	self.shopItem = Lua_ItemIcon.new(self.content);
	self.shopItem:setScale(0.8, 0.8);
end

function Lua_SpecialDiscountGiftItemCell:setData(data)
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.id);
	tvo:fromServer(data);
	self.shopItem:setData(tvo);
end

function Lua_SpecialDiscountGiftItemCell:onPressClick()
	if self.shopItem.isActive then
		self.shopItem:onItemClick();
	end
end

function Lua_SpecialDiscountGiftItemCell:onMouseDownHandle()
	self.shopItem:setScale(0.76, 0.76);
end

function Lua_SpecialDiscountGiftItemCell:onMouseUpHandle()
	self.shopItem:setScale(0.8, 0.8);
end

function Lua_SpecialDiscountGiftItemCell:dispose()
	if self.shopItem ~= nil then
		self.shopItem:dispose();
		self.shopItem = nil;
	end

	self:superCall("dispose");
end