-- 超值基金（后台）
Lua_NewSpecialFundsPanel = class("Lua_NewSpecialFundsPanel", Lua_DisplayObject);
function Lua_NewSpecialFundsPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_NewSpecialFundsPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardBg:SetDimensions(711, 726 + self.adaptHeight);
	self.tipsObj:SetActive(false);

	self.rewardList = Lua_DragList.new(self.content, 665, 690 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.rewardList.tweenId = 2003;
	self.rewardList:setListCell(Lua_NewSpecialFundsItem, 133, 159, 5);
	self.rewardList:setSiblingIndex(3);
	self.rewardList:setCellSpacing(0, 11);
	self.rewardList:setLocation(0, -70, 0);

	self.rechargeBtn:addClickFuntion(self, self.onSureBtnClick)

	self:addLuaEvent("DRAW_SPECIALFUNDS_REWARD", self, self.onDrawRewardClick);
	self:addLuaEvent("UPDATE_FUNDSITEM_INFO", self, self.updateFundsItemInfo);
end

function Lua_NewSpecialFundsPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.rewardBg:SetDimensions(711, 726 + adaptHeight);
	self.rewardList:setContentRect(665, 690 + adaptHeight);
end

function Lua_NewSpecialFundsPanel:setData(data)
	self.data = data;
end

function Lua_NewSpecialFundsPanel:updateFundsItemInfo()
	local newSpecialFundsData = DataCenter.newSpecialFundsData;
	self.totalValueTxt.text = newSpecialFundsData.reward_value[2];
	self.buyStandTxt.text = newSpecialFundsData.reward_value[3];

	local showList = newSpecialFundsData.reward_list;
	self.rewardList:setArrayData(showList);

	local lockState = newSpecialFundsData.lockState;
	self.tipsObj:SetActive(lockState == 0);

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(newSpecialFundsData.recharge_id);
	if lockState == 0 then
		self.rechargeBtn.label = LanUtil.formateStr(203000, rechargeInfo.money);
	else
		local curDrawDay = #showList <= newSpecialFundsData.curDay and #showList or newSpecialFundsData.curDay;
		local isCanDraw = newSpecialFundsData.maxDay < curDrawDay and showList[curDrawDay].reward_state == 1;
		if isCanDraw then
			self.rechargeBtn:setGray(false);
			self.rechargeBtn:setLangValue(203001); -- 领取
		else
			self.rechargeBtn:setGray(true);
			self.rechargeBtn:setLangValue(203002); -- 已领取
		end
		self:showRedDot(lockState == 1 and isCanDraw);
	end
end

function Lua_NewSpecialFundsPanel:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(108, 254, 0);
			self.redPoint:setRectAnchor(7);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_NewSpecialFundsPanel:onDrawRewardClick()
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sSpecialFundsReward(self.data.actIdx);
end

function Lua_NewSpecialFundsPanel:onSureBtnClick(go)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	
	local newSpecialFundsData = DataCenter.newSpecialFundsData;
	if newSpecialFundsData.lockState == 0 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(newSpecialFundsData.recharge_id);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
				tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		local showList = newSpecialFundsData.reward_list;
		local curDrawDay = #showList <= newSpecialFundsData.curDay and #showList or newSpecialFundsData.curDay;
		local isCanDraw = newSpecialFundsData.maxDay < curDrawDay and showList[curDrawDay].reward_state == 1;
		if isCanDraw then
			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sSpecialFundsReward(self.data.actIdx);
		else
			OperateAlert.showLangValue(203003);
		end
	end
end

function Lua_NewSpecialFundsPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewSpecialFundsItem = class("Lua_NewSpecialFundsItem", Lua_ListCell)
function Lua_NewSpecialFundsItem:ctor(p)
	self:superCall("ctor", p, "NewSpecialFundsItem_skin");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(2);
	self.itemIcon:setLocation(0, -17, 0);
	self.itemIcon:setScale(0.92, 0.92);

	self.itemBg:addLoadCompleteFun(self, self.onLoadCompletedFun);
end

function Lua_NewSpecialFundsItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local newSpecialFundsData = DataCenter.newSpecialFundsData;
	local isCanDraw = data.reward_day <= newSpecialFundsData.curDay;
	if isCanDraw then
		self.itemBg:setAltas("funds_atlas", "xui_czjz2_widget_4");
	else
		self.itemBg:setAltas("funds_atlas", "xui_czjz2_widget_3");
	end
	self.dayTxt.text = LanUtil.formateStr(203004, data.reward_day);

	local tvo = Lua_ToolVo.createToolVo(data.reward_item[1].key, data.reward_item[1].value);
	self.itemIcon:setData(tvo);

	local isDrawed = data.reward_day <= newSpecialFundsData.maxDay;
	self.drawIcon:setEnable(isDrawed);
	self:showRedDot(newSpecialFundsData.lockState == 1 and isCanDraw and not isDrawed);
end

function Lua_NewSpecialFundsItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(49, 67, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_NewSpecialFundsItem:onPressClick(go)
	local newSpecialFundsData = DataCenter.newSpecialFundsData;
	if newSpecialFundsData.lockState == 1 and self.data.reward_day <= newSpecialFundsData.curDay
		and self.data.reward_day > newSpecialFundsData.maxDay then
			Lua_MsgUtil.callFunc("DRAW_SPECIALFUNDS_REWARD");
	else
		DataCenter.packUtil:showItemInfo(self.itemIcon.data);
	end
end

function Lua_NewSpecialFundsItem:onLoadCompletedFun()
	self.itemBg:resetSize();
end

function Lua_NewSpecialFundsItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end