-- 升星专属(周期)(后台)
Lua_UpStarOfCyclePanel = class("Lua_UpStarOfCyclePanel", Lua_DisplayObject);
function Lua_UpStarOfCyclePanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_UpStarOfCyclePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.giftList = Lua_DragList.new(self.content, 720, 600 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_UpStarOfCycleRewardItem, 720, 152, 1);
	self.giftList:setCellSpacing(0, 10);
	self.giftList:setLocation(0, -215, 0);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.gotoRecruitBtn:addClickFuntion(self, self.onGotoRecruitClick);

	self:addLuaEvent("DRAW_UPSTAROF_CYCLE_REWARD", self, self.drawUpStarOfCycleReward);
    self:addLuaEvent("UPDATE_UPSTAROFCYCLE_INFO", self, self.updateUpStarOfCycleData);
end

function Lua_UpStarOfCyclePanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.giftList:setContentRect(720, 600 + adaptHeight);
end

function Lua_UpStarOfCyclePanel:setData(data)
	self.data = data;
	self:startTimer();
	self:updateLeftTime();
end

function Lua_UpStarOfCyclePanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_UpStarOfCyclePanel", 1, self, self.updateLeftTime);
	end
end

function Lua_UpStarOfCyclePanel:updateLeftTime()
	local time = self.data.residueTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr(203200, Lua_TimeTransform.transSeconds16(time, true, true, true));
end

function Lua_UpStarOfCyclePanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_UpStarOfCyclePanel:updateUpStarOfCycleData()
	self.giftList:setArrayData(DataCenter.upStarOfCycleData.rewardArr);
end

function Lua_UpStarOfCyclePanel:onRuleClick(go)
    local tipData = { des = self.data.help_des, posX = 160, posY = -260 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_UpStarOfCyclePanel:onGotoRecruitClick(go)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	DataCenter.funcPathUtil:gotoFunction(DataCenter.upStarOfCycleData.eventId, true)
end

function Lua_UpStarOfCyclePanel:drawUpStarOfCycleReward(giftId)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sReceiveUpStarReward(self.data.actIdx, giftId);
end

function Lua_UpStarOfCyclePanel:dispose()
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_UpStarOfCycleRewardItem = class("Lua_UpStarOfCycleRewardItem", Lua_ListCell);
function Lua_UpStarOfCycleRewardItem:ctor(p)
	self:superCall("ctor", p, "UpStarOfCycleRewardItem_skin");
end

function Lua_UpStarOfCycleRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroIcon = Lua_ItemIcon.new(self.content);
	self.heroIcon:setLocation(-290, 0, 0);
	self.heroIcon:setScale(0.8, 0.8);
	self.heroIcon:setSiblingIndex(1);

	self.freeIcon = Lua_ItemIcon.new(self.content);
	self.freeIcon:setLocation(-140, 0);
	self.freeIcon:setScale(0.8, 0.8);
	self.freeIcon:setSiblingIndex(2);

	self.rewardList = Lua_DragList.new(self.content, 240, 115, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_CycleRechargeRewardItem, 112, 112, 1);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-45, -2, 0);
	self:setSubList(self.rewardList);

	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick);
end

function Lua_UpStarOfCycleRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local upStarOfCycleData = DataCenter.upStarOfCycleData;
	local vo = Lua_ToolVo.createToolVo(upStarOfCycleData.heroId);
	vo.quality = data.quality;
	vo.qualityStar = data.qualityStar;
	self.heroIcon:setData(vo);

	self.freeIcon:setData(data.freeVo);
	self.freeIcon:setDrawMask(data.freeTimes <= 0, "investment_atlas", "xui_czjz_label_1");

	self.rewardList.canDrag = data.rechargeArr:getSize() >= 3;
	self.rewardList:setArrayData(data.rechargeArr);

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(data.rechargeId);
	self.rechargeBtn.label = LanUtil.formateStr(203201, tonumber(rechargeInfo.money));
	self.limitCountTxt.text = LanUtil.formateStr(203202, data.rechargeTimes, data.totalRechargeTimes);

	local isCond = upStarOfCycleData.quality >= data.quality and upStarOfCycleData.qualityStar >= data.qualityStar;
	self.mask:setEnable(not isCond);
	self.freeIcon:showEffect(isCond);
	self.rechargeBtn:setStyle(isCond and 1 or 3);
	self.rechargeBtn:setEnable(data.rechargeTimes > 0);
	self.sellOutIcon:setEnable(data.rechargeTimes <= 0);
	self.limitCountTxt:setEnable(data.rechargeTimes > 0);
end

function Lua_UpStarOfCycleRewardItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.freeIcon:checkInBound(winPos.x, winPos.y) then
		self:onBtnClick();
	end
end

function Lua_UpStarOfCycleRewardItem:onBtnClick()
	local upStarOfCycleData = DataCenter.upStarOfCycleData;
	local isCond = upStarOfCycleData.quality >= self._data.quality and upStarOfCycleData.qualityStar >= self._data.qualityStar;
	if isCond and self._data.freeTimes > 0 then
		Lua_MsgUtil.callFunc("DRAW_UPSTAROF_CYCLE_REWARD", self._data.freeGiftId);
	else
		DataCenter.packUtil:showItemInfo(self.freeIcon.data);
	end
end

function Lua_UpStarOfCycleRewardItem:onRechargeClick(go)
	local upStarOfCycleData = DataCenter.upStarOfCycleData;
	local isCond = upStarOfCycleData.quality >= self._data.quality and upStarOfCycleData.qualityStar >= self._data.qualityStar;
	if isCond and self._data.rechargeTimes > 0 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self._data.rechargeId);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		local nameStr = DataCenter.heroUtil:getHeroQualityName(self._data.quality, self._data.qualityStar);
		OperateAlert.show(LanUtil.formateStr(203203, self.heroIcon.data.name, nameStr));
	end
end

function Lua_UpStarOfCycleRewardItem:dispose()
	if self.heroIcon ~= nil then
		self.heroIcon:dispose();
		self.heroIcon = nil;
	end
	if self.freeIcon ~= nil then
		self.freeIcon:dispose();
		self.freeIcon = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_CycleRechargeRewardItem = class("Lua_CycleRechargeRewardItem", Lua_ListCell);
function Lua_CycleRechargeRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CycleRechargeRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rechargeIcon = Lua_ItemIcon.new(self.content);
	self.rechargeIcon:setScale(0.8, 0.8);
end

function Lua_CycleRechargeRewardItem:setData(data)
	if data == nil then
		return;
	end

	self.rechargeIcon:setData(data);
	self.rechargeIcon:setDrawMask(data.times <= 0, "investment_atlas", "xui_czjz_label_1");
end

function Lua_CycleRechargeRewardItem:onPressClick(go)
	DataCenter.packUtil:showItemInfo(self.rechargeIcon.data);
end

function Lua_CycleRechargeRewardItem:dispose()
	if self.rechargeIcon ~= nil then
		self.rechargeIcon:dispose();
		self.rechargeIcon = nil;
	end
	self:superCall("dispose");
end