-- 百发百中
Lua_CrackShotGetPosWindow = class("Lua_CrackShotGetPosWindow", Lua_Window);
function Lua_CrackShotGetPosWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CrackShotGetPosWindow";
	self.skinName = "CrackShotGetPosWindow_skin";
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.showBackBtn = true;
	-- self.winBgPath = "/images/activities/xui_bfbz_bg_3.jpg";
	self.winBgPath = "/images/common/ui_common_bg_001.jpg";
end

function Lua_CrackShotGetPosWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.direction = 1; -- 顺时针，逆时针
	self.speed = 50;
	self.radius = 203;
	self.infoPosX = 0;
	self.infoPosY = -140;
	self.angle = 90; -- 默认位置固定
	-- self.angle = Mathf.Atan2(self.infoPosY + self.radius, self.infoPosX) * 180 / Mathf.PI;
	LuaUtil.setObjRot(self.rotateObj, 0, 0, self.angle);

	self.speedInput.keyboardTypeValue = 12;
	self.speedInput.contentTypeValue = 2; -- 内容类型
	self.speedInput.characterValidationValue = 2; -- 字符验证，数字样式(允许 . 和 -)
	self.speedInput.defaultText = "输入速度倍率";
	self.speedInput.text = self.speed;
	self.speedInput:onEndEdit(self, self.updateSpeed);

	self.angleInput.keyboardTypeValue = 12;
	self.angleInput.contentTypeValue = 2; -- 内容类型
	self.angleInput.characterValidationValue = 1; -- 字符验证，数字样式(1整数)
	self.angleInput.defaultText = "输入角度";
	self.angleInput.text = self.angle;
	self.angleInput:onEndEdit(self, self.updateAngle);

	-- 计算最大角度
	local miniRadius = self.balloonIcon.width / 2; -- 气球半径
	local miniPosX = 0; -- 气球圆心X坐标
	local miniPosY = self.radius; -- 气球圆心Y坐标
	local minusWidth = self.radius * self.radius - miniRadius * miniRadius; -- 底圆到气球顶点的距离
	-- 直角向量法 (x1 - x2)(x3 - x2) + (y1 - y2)(y3 - y2) = 0，底圆圆心坐标为原点(0，0)
	-- a. (0 - needPosX) * (miniPosX - needPosX) + (0 - needPosY) * (miniPosY - needPosY) = 0;
	-- b. needPosX * needPosX + needPosY * needPosY - miniPosY * needPosY = 0;
	-- c. needPosX * needPosX + needPosY * needPosY = minusWidth;
	-- minusWidth - needPosY * miniPosY = 0;
	local needPosY = minusWidth / miniPosY;
	local needPosX = Mathf.Sqrt(minusWidth - needPosY * needPosY);
	local needAngle = Mathf.Atan2(needPosY, needPosX) * 180 / Mathf.PI;
	self.maxAngle = self.angle - needAngle;
	self.maxAngleTxt.text = LanUtil.formateStr("底图圆心到气球圆心和顶点之间的最大角度：{1}", self.maxAngle);

	self.qiqiuEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_bfb_qiqiu", "ui_bfb_qiqiu", 0, 0);
	self.qiqiuEff.siblingIndex = 1;

	self.infoBg.clickScale = false;
	self.infoBg:addClickFuntion(self, self.onGetPosFunClick);

	self.rotateTime = getTime();
	Lua_CommonUtil.addTimer("Lua_CrackShotGetPosWindow", 0.01, self, self.onRotateFun, nil, -1, true);
	self:onRotateFun();
	self:updateAngle();
end

function Lua_CrackShotGetPosWindow:onRotateFun()
	local time = getTime();
	local dt = time - self.rotateTime;
	local changeAngle = dt * self.speed;
	self.rotateTime = time;
	
	self.angle = (self.angle + changeAngle) % 360; -- 0 ~ 2 * Mathf.PI
	LuaUtil.setObjRot(self.rotateObj, 0, 0, self.angle);
end

function Lua_CrackShotGetPosWindow:updateSpeed()
	if self.speedInput.text == "" then
		val = 1;
	else
		val = tonumber(self.speedInput.text);
	end
	self.speed = val;
end

function Lua_CrackShotGetPosWindow:updateAngle()
	if self.angleInput.text == "" then
		val = 0;
	else
		val = tonumber(self.angleInput.text) % 360;
	end
	local iconPosX = self.radius * Mathf.Cos(Mathf.Rad(val)) + self.infoPosX;
	local iconPosY = self.radius * Mathf.Sin(Mathf.Rad(val)) + self.infoPosY;
	self.balloonIcon:setLocation(iconPosX, iconPosY, 0, 1);
	self.balloonIcon:setRot(0, 0, -90 + val);
	self.posTxt.text = LanUtil.formateStr("x：{1}\ny：{2}", iconPosX, iconPosY);
end

function Lua_CrackShotGetPosWindow:onGetPosFunClick(go)
	local winPos = LuaUtil.getTouchPosInverseObj(self.content);
	local pointRadius = Mathf.Sqrt(Mathf.Pow(winPos.x, 2) + Mathf.Pow(winPos.y, 2));
	-- local actPosX = winPos.x - self.infoPosX; -- 吸附
	-- local actPosY = self.radius * (winPos.y - self.infoPosY + self.height / 2) / pointRadius; -- 吸附
	local actPosX = winPos.x - self.infoPosX; -- 居中
	local actPosY = self.radius * (winPos.y - self.infoPosY) / pointRadius; -- 居中
	local pointAngle = Mathf.Atan2(actPosY, actPosX) * 180 / Mathf.PI; -- -Mathf.PI ~ Mathf.PI
	local curAngle = (pointAngle < 0 and pointAngle or pointAngle + 360) % 360;
	local angleMinus = Mathf.Abs(self.angle - curAngle);
	angleMinus = angleMinus > 180 and 360 - angleMinus or angleMinus;
	self.angleMinusTxt.text = LanUtil.formateStr("当前相差角度：{1}", angleMinus);
	print(self.angle, pointAngle, curAngle, angleMinus);
end

function Lua_CrackShotGetPosWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.onRotateFun, true);
	self:superCall("dispose");
end