-- 百发百中
Lua_CrackShotPanel = class("Lua_CrackShotPanel", Lua_DisplayObject);
function Lua_CrackShotPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_CrackShotPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.qiqiuEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_bfb_qiqiu", "ui_bfb_qiqiu", 0, -140);
	self.qiqiuEff.siblingIndex = 0;

	self.taskRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.CrackShot_Task);
	self.taskRedPoint:setRectAnchor(1);
	self.taskRedPoint:setLocation(330, -190, 0);

	self.crackShotList = Lua_DragList.new(self.content, 716, 469, Lua_AxisDefine.Vertical);
	self.crackShotList.tweenId = 2002;
	self.crackShotList:setListCell(Lua_CrackShotItem, 716, 153, 1);
	self.crackShotList:setCellSpacing(0, 5);
	self.crackShotList:setRectAnchor(7);
	self.crackShotList:setLocation(0, 420, 0);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.taskBtn:addClickFuntion(self, self.onTaskClick);
	self.rankBtn:addClickFuntion(self, self.onRankClick);

	self:addLuaEvent("UPDATE_CRACKSHOT_INFO", self, self.updateCrackShotInfo);
	self:addLuaEvent("ON_CRACKSHOT_REFRESH_CLICK", self, self.onCrackShotRefreshClick);
	self:addLuaEvent("ON_CRACKSHOT_CHALLENGE_CLICK", self, self.onCrackShotChallengeClick);
	self:addLuaEvent("ON_CRACKSHOT_PROGRESS_CLICK", self, self.onCrackShotProgressClick);
end

function Lua_CrackShotPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_CrackShotPanel:setData(actVo)
	self.actVo = actVo;
	DataCenter.crackShotData.actOpenTime = actVo.start_tick;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sCrackShotTaskInfo(actVo.actIdx, 1); -- 每日任务红点
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sCrackShotTaskInfo(actVo.actIdx, 2); -- 累计任务红点

	self.titleTxt.text = actVo.title;
	self:startTimer();
	self:updateLeftTime();
end

function Lua_CrackShotPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_CrackShotPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_CrackShotPanel:updateLeftTime()
	local time = self.actVo.residueTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr(768000, Lua_TimeTransform.transSeconds16(time, true, true, true));
end

function Lua_CrackShotPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_CrackShotPanel:updateCrackShotInfo()
	if DataCenter.crackShotData.isFirst then
		self:onRuleClick();
	end

	self.timesTxt.text = LanUtil.formateStr(768001, DataCenter.crackShotData.challengeTimes);
	local arr = DataCenter.crackShotData.crackShotDiffTypeArr;
	self.crackShotList.canDrag = arr:getSize() > 3;
	self.crackShotList:setArrayData(arr);

	if self.levelInfo then
		self:onCrackShotChallengeClick(self.levelInfo);
		self.levelInfo = nil;
	end
end

function Lua_CrackShotPanel:onRuleClick(go)
	-- local tipData = { des = self.actVo.help_des, posX = 180, posY = -240 };
	-- Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
	Lua_WindowUtil.openWin("Lua_CrackShotRuleWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
end

function Lua_CrackShotPanel:onTaskClick(go)
	self:onCrackShotOperate(1);
end

function Lua_CrackShotPanel:onRankClick(go)
	self:onCrackShotOperate(2);
end

function Lua_CrackShotPanel:onCrackShotRefreshClick()
	self:onCrackShotOperate(3);
end

function Lua_CrackShotPanel:onCrackShotChallengeClick(param)
	self:onCrackShotOperate(4, param);
end

function Lua_CrackShotPanel:onCrackShotProgressClick(param)
	self:onCrackShotOperate(5, param);
end

function Lua_CrackShotPanel:onCrackShotOperate(operateType, param)
	if self.actVo == nil or DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	if operateType == 1 then
		Lua_WindowUtil.openWin("Lua_CrackShotTaskWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 2 then
		Lua_WindowUtil.openWin("Lua_CrackShotRankWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 3 then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx); -- 开启刷新
	elseif operateType == 4 then
		if DataCenter.crackShotData.challengeTimes <= 0 then
			local times = DataCenter.crackShotData.limitBuyTimes;
			if times > 0 or times == -1 then
				Lua_WindowUtil.openWin("Lua_CrackShotBuyTimesWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
				self.levelInfo = param;
			else
				OperateAlert.showLangValue(768002);
			end
		else
			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx); -- 最高记录刷新
			Lua_WindowUtil.openWin("Lua_CrackShotChallengeWindow", Lua_WinParam.ACTION_OPEN, {actVo = self.actVo, levelInfo = param});
		end
	elseif operateType == 5 then
		if param.data.drawState == 1 then
			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sDrawCrackShotStageReward(self.actVo.actIdx, param.data.diffType, param.data.score);
		else
			local winPos = LuaUtil.getTouchPosInverseObj(self.content);
			param.posY = winPos.y;
			Lua_WindowUtil.openWin("Lua_CrackShotProgressRewardWindow", Lua_WinParam.ACTION_OPEN, param);
		end
	end
end

function Lua_CrackShotPanel:dispose()
	if self.qiqiuEff ~= nil then
		self.qiqiuEff:dispose();
		self.qiqiuEff = nil;
	end
	if self.taskRedPoint ~= nil then
		self.taskRedPoint:dispose();
		self.taskRedPoint = nil;
	end
	if self.crackShotList ~= nil then
		self.crackShotList:dispose();
		self.crackShotList = nil;
	end
	self.actVo = nil;
	self:endTimer();
	self:superCall("dispose");
end











Lua_CrackShotItem = class("Lua_CrackShotItem", Lua_ListCell);
function Lua_CrackShotItem:ctor(p)
	self:superCall("ctor", p, "CrackShotItem_skin");
end

function Lua_CrackShotItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showTime = 0;
	self.progressItemArr = Array();
	self.challengeBtn:addClickFuntion(self, self.onChallengeClick);

	self:addLuaEvent("UPDATE_ROLE_LEVEL", self, self.checkLvCondFun);
end

function Lua_CrackShotItem:setData(data)
	self._data = DataCenter.crackShotData:getDiffTypeInfoByDiffType(data);
	if self._data == nil then
		return;
	end

	self.levelTxt.text = LanUtil.formateStr(768003, self._data.diffType);
	self.scoreTxt.text = self._data.top_score;

	local isLock = self._data.timeCond or self._data.lvCond;
	if isLock then -- 未开启
		self.itemBg:setAltas("crack_shot_atlas", "xui_bfbz_widget_6");
		self.levelBg.alpha = 0.6;
		self.openTxt:setEnable(true);
		self.openObj:SetActive(false);

		if self._data.timeCond then
			self.showTime = self._data.open_time;
			self:startTimer();
			self:updateOpenTime();
		else
			self:checkLvCondFun();
		end
	else
		self.itemBg:setAltas("crack_shot_atlas", "xui_bfbz_widget_5");
		self.levelBg.alpha = 1;
		self.openTxt:setEnable(false);
		self.openObj:SetActive(true);

		-- 进度条
		local score = self._data.top_score;
		local list = self._data.progressRewardDic;
		local dataLen = #list;
		local maxValue = list[dataLen].score;
		local value = 0;
		local index = 1;
		if score >= maxValue then
			value = maxValue;
		else
			local stepSpace = maxValue / dataLen;
			for i = 1, dataLen do
				if list[i].score >= score then
					index = i;
					break;
				end
			end
			value = value + stepSpace * (index - 1);
			local num;
			if index <= 1 then
				num = stepSpace / list[index].score;
				value = value + score * num;
			else
				num = stepSpace / (list[index].score - list[index - 1].score);
				value = value + (score - list[index - 1].score) * num;
			end
		end
		self.scoreBar:setMaxValue(maxValue);
		self.scoreBar:setValue(value);

		-- 阶段奖励
		local width = 72;
		local vo;
		for i = 1, dataLen do
			vo = self.progressItemArr[i];
			if vo == nil then
				vo = Lua_CrackShotScoreItem.new(self.openObj);
				self.progressItemArr:add(vo);
			end
			vo:setData(list[i]);
			vo:setLocation(-123 + (i - 1) * width, 0, 0);
		end
	end
	self.lockIcon:setEnable(isLock);
end

function Lua_CrackShotItem:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_CrackShotItem", 1, self, self.updateOpenTime);
	end
end

function Lua_CrackShotItem:updateOpenTime()
	self.showTime = self.showTime - 1;
	local openTime;
	if self.showTime >= 86400 then
		openTime = LanUtil.formateStr(768004, Mathf.Ceil(self.showTime / 86400));
	else
		openTime = Lua_TimeTransform.transSeconds6(self.showTime, true, true, true);
	end
	self.openTxt.text = LanUtil.formateStr(768005, openTime, self._data.open_level);
	
	if self.showTime <= 0 then
		self:checkLvCondFun();
	end
end

function Lua_CrackShotItem:stopTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateOpenTime);
	end
end

function Lua_CrackShotItem:checkLvCondFun()
	if self.showTime > 0 then
		return;
	end

	self:stopTimer();
	if self._data.lvCond then
		self.openTxt.text = LanUtil.formateStr(768006, self._data.open_level);
	else
		Lua_MsgUtil.callFunc("ON_CRACKSHOT_REFRESH_CLICK");
	end
end

function Lua_CrackShotItem:onChallengeClick(go)
	Lua_MsgUtil.callFunc("ON_CRACKSHOT_CHALLENGE_CLICK", self._data);
end

function Lua_CrackShotItem:dispose()
	if self.progressItemArr ~= nil then
		self.progressItemArr:dispose();
		self.progressItemArr = nil;
	end
	self._data = nil;
	self:stopTimer();
	self:superCall("dispose");
end










Lua_CrackShotScoreItem = class("Lua_CrackShotScoreItem", Lua_ListCell);
function Lua_CrackShotScoreItem:ctor(p)
	self:superCall("ctor", p, "CrackShotScoreItem_skin");
end

function Lua_CrackShotScoreItem:buildShowItem()
	self:superCall("buildShowItem");
	self.stateIcon:addLoadCompleteFun(self, self.onLoadCompletedFun);
	self.stateIcon:addClickFuntion(self, self.onShowRewardClick);
end

function Lua_CrackShotScoreItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local stateSprite;
	local pointSprite;
	if data.drawState == 0 then -- 未达成
		stateSprite = "xui_bfbz_widget_7";
		pointSprite = "xui_bfbz_widget_10";
	elseif data.drawState == 1 then -- 可领取
		stateSprite = "xui_bfbz_widget_9";
		pointSprite = "xui_bfbz_widget_11";
	else -- 已领取
		stateSprite = "xui_bfbz_widget_8";
		pointSprite = "xui_bfbz_widget_10";
	end
	self.stateIcon:setAltas("crack_shot_atlas", stateSprite);
	self.pointIcon:setAltas("crack_shot_atlas", pointSprite);

	self.scoreTxt.text = data.score;
	self:showRedDot(data.drawState == 1);
end

function Lua_CrackShotScoreItem:onLoadCompletedFun(go)
	self.stateIcon:resetSize();
end

function Lua_CrackShotScoreItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(20, 35, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CrackShotScoreItem:onShowRewardClick(go)
	Lua_MsgUtil.callFunc("ON_CRACKSHOT_PROGRESS_CLICK", {data = self._data, posX = self.posX});
end

function Lua_CrackShotScoreItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end