-- 百发百中规则弹窗
Lua_CrackShotRuleWindow = class("Lua_CrackShotRuleWindow", Lua_Window);
function Lua_CrackShotRuleWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CrackShotRuleWindow";
	self.skinName = "CrackShotRuleWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_CrackShotRuleWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.minNum = 1;
	self.maxNum = 2;
	self.showRuleArr = Array();

	local width = 46;
	local startPosX = -(width * self.maxNum) / 2 + width / 2;
	local icon;
	self.btnIconArr = Array();
	for i = 1, self.maxNum do
		icon = UICreate.createUIAtlasImage(self.content, "crack_shot_atlas", "xui_xslb_widget_8", 0, 0, 0, 0);
		icon:setLocation(startPosX + ((i - 1) % self.maxNum) * width, -408, 0);
		icon.clickScale = false;
		icon:addClickFuntion(self, self.onWinBgClick);
		self.btnIconArr:add(icon);
	end

	self.preBtn:addClickFuntion(self, self.onPreBtnClick);
	self.nextBtn:addClickFuntion(self, self.onNextBtnClick);
end

function Lua_CrackShotRuleWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateShowInfo(1, false);
end

function Lua_CrackShotRuleWindow:updateShowInfo(index, isPlayTween)
	self.preBtn:setEnable(index > self.minNum);
	self.nextBtn:setEnable(index < self.maxNum);
	self:playRuleTween(index, isPlayTween);
end

function Lua_CrackShotRuleWindow:playRuleTween(showIdx, isMove)
	if self.showIdx == showIdx then
		return;
	end

	local preIdx = self.showIdx or 1;
	self.btnIconArr[preIdx]:setAltas("crack_shot_atlas", "xui_xslb_widget_8");
	self.btnIconArr[showIdx]:setAltas("crack_shot_atlas", "xui_xslb_widget_7");
	self.showIdx = showIdx;

	local width = 720;
	local panel = self.showRuleArr[showIdx];
	if panel == nil then
		if showIdx == 1 then
			panel = Lua_CrackShotRuleOnePanel.new(self.showObj);
		else
			panel = Lua_CrackShotRuleTwoPanel.new(self.showObj);
		end
		panel:setData(self.showData.help_des);
		panel:setLocation((showIdx - 1) * width, 0, 0);
		self.showRuleArr:add(panel);
	end

	self:stopRuleTween();
	if not isMove then
		LuaUtil.setObjPos(self.showObj, -(showIdx - 1) * width, 0, 0);
	else
		local posX = -(showIdx - 1) * width;
		TweenUtil.getInstance():addTweenTargetPos(self.showObj, 1, 0, posX, 0, 0);
	end
end

function Lua_CrackShotRuleWindow:stopRuleTween()
	TweenUtil.getInstance():stop(self.showObj);
end

function Lua_CrackShotRuleWindow:onPreBtnClick(go)
	if self.showIdx <= self.minNum then
		return;
	end
	self:updateShowInfo(self.showIdx - 1, true);
end

function Lua_CrackShotRuleWindow:onNextBtnClick(go)
	if self.showIdx >= self.maxNum then
		return;
	end
	self:updateShowInfo(self.showIdx + 1, true);
end

function Lua_CrackShotRuleWindow:dispose()
	if self.showRuleArr ~= nil then
		self.showRuleArr:dispose();
		self.showRuleArr:clear();
		self.showRuleArr = nil;
	end
	if self.btnIconArr ~= nil then
		self.btnIconArr:dispose();
		self.btnIconArr:clear();
		self.btnIconArr = nil;
	end
	self:superCall("dispose");
end










Lua_CrackShotRuleOnePanel = class("Lua_CrackShotRuleOnePanel", Lua_DisplayObject);
function Lua_CrackShotRuleOnePanel:ctor(p)
	self:superCall("ctor", p, "CrackShotRuleOnePanel_skin");
end

function Lua_CrackShotRuleOnePanel:buildShowItem()
	self:superCall("buildShowItem");
	self.bg_1.clickScale = false;
	self.bg_1:addClickFuntion(self, self.onBgClick);
end

function Lua_CrackShotRuleOnePanel:setData(data)
	if data == nil then
		return;
	end
	self.desTxt.text = data;
end

function Lua_CrackShotRuleOnePanel:onBgClick(go)
end










Lua_CrackShotRuleTwoPanel = class("Lua_CrackShotRuleTwoPanel", Lua_DisplayObject);
function Lua_CrackShotRuleTwoPanel:ctor(p)
	self:superCall("ctor", p, "CrackShotRuleTwoPanel_skin");
end

function Lua_CrackShotRuleTwoPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.bg_1.clickScale = false;
	self.bg_1:addClickFuntion(self, self.onBgClick);
end

function Lua_CrackShotRuleTwoPanel:setData(data)
	if data == nil then
		return;
	end
	self.desTxt_1:setLangValue(768024);
	self.desTxt_2:setLangValue(768025);
	self.desTxt_3:setLangValue(768026);
	self.desTxt_4:setLangValue(768027);
	self.desTxt_5:setLangValue(768028);
end

function Lua_CrackShotRuleTwoPanel:onBgClick(go)
end